VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Roles"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private EstatusINACTIVO As String
Private TipoDeSuscripcionADMIN_MODERADOR As String
Private TipoDeSuscripcionMODERADOR As String
Private TipoDeSuscripcionNORMAL As String
Private TipoDeSuscripcionSUSPENDIDO As String

Public Property Get NOT_LOGGED() As String
  NOT_LOGGED = "NL"
End Property

Public Property Get SUSPENDED() As String
  SUSPENDED = "SU"
End Property

Public Property Get NOT_MEMBER() As String
  NOT_MEMBER = "NM"
End Property

Public Property Get INACTIVE_MEMBER() As String
  INACTIVE_MEMBER = "IM"
End Property

Public Property Get MEMBER() As String
  MEMBER = "ME"
End Property

Public Property Get ADMIN_MODERATOR() As String
  ADMIN_MODERATOR = "AM"
End Property

Public Property Get MODERATOR() As String
  MODERATOR = "MO"
End Property

Public Property Get ADMINISTRATOR() As String
  ADMINISTRATOR = "AD"
End Property

Public Function isEnough(neededRole As String, currentRole As String) As Boolean
  If neededRole = currentRole Then
    isEnough = True
  ElseIf InStr(Me.ADMINISTRATOR & Me.ADMIN_MODERATOR & Me.MODERATOR & Me.MEMBER, neededRole) >= 0 Then
    If currentRole = Me.ADMINISTRATOR Then
      isEnough = True
    ElseIf neededRole = Me.MODERATOR Then
      isEnough = currentRole = Me.ADMIN_MODERATOR
    ElseIf neededRole = Me.MEMBER Then
      isEnough = currentRole = Me.ADMIN_MODERATOR Or currentRole = Me.MODERATOR
    Else
      isEnough = False
    End If
  Else
    isEnough = False
  End If
End Function

Public Function isMember(currentRole As String) As Boolean
  isMember = isEnough(Me.MEMBER, currentRole)
End Function

Public Function isModerator(currentRole As String) As Boolean
  isModerator = isEnough(Me.MODERATOR, currentRole)
End Function

Public Function isAdminModerator(currentRole As String) As Boolean
  isAdminModerator = isEnough(Me.ADMIN_MODERATOR, currentRole)
End Function

Public Function isAdministrator(currentRole As String) As Boolean
  isAdministrator = isEnough(Me.ADMINISTRATOR, currentRole)
End Function

Public Function getRolesListExcluding(Optional excList As String) As String
  Dim excArr As Variant
  Dim itm1 As Variant
  Dim itm2 As Variant
  Dim found As Boolean
  Dim list As String
  Dim allRolesArr(0 To 7) As String
  
  allRolesArr(0) = Me.NOT_LOGGED
  allRolesArr(1) = Me.SUSPENDED
  allRolesArr(2) = Me.NOT_MEMBER
  allRolesArr(3) = Me.INACTIVE_MEMBER
  allRolesArr(4) = Me.MEMBER
  allRolesArr(5) = Me.ADMIN_MODERATOR
  allRolesArr(6) = Me.MODERATOR
  allRolesArr(7) = Me.ADMINISTRATOR
  excArr = Split(excList, ",")
  list = ""
  For Each itm1 In allRolesArr
    found = False
    For Each itm2 In excArr
      If itm1 = itm2 Then
        found = True
        Exit For
      End If
    Next
    If Not found Then
      list = list & itm1 & ","
    End If
  Next
  If Len(list) > 0 Then
    list = Left(list, Len(list) - 1)
  End If
  getRolesListExcluding = list
End Function

Public Function getSuscriptionRole(Suscription_status As String, Suscription_type As String) As String
  If Suscription_status = EstatusINACTIVO Then
    getSuscriptionRole = Me.INACTIVE_MEMBER
  ElseIf Suscription_type = TipoDeSuscripcionADMIN_MODERADOR Then
    getSuscriptionRole = Me.ADMIN_MODERATOR
  ElseIf Suscription_type = TipoDeSuscripcionMODERADOR Then
    getSuscriptionRole = Me.MODERATOR
  ElseIf Suscription_type = TipoDeSuscripcionNORMAL Then
    getSuscriptionRole = Me.MEMBER
  ElseIf Suscription_type = TipoDeSuscripcionSUSPENDIDO Then
    getSuscriptionRole = Me.SUSPENDED
  Else
    getSuscriptionRole = Me.NOT_MEMBER
  End If
End Function

Private Sub Class_Initialize()
  Dim mEstatus As WebForumsTypes.estatus
  Dim mTipoDeSuscripcion As WebForumsTypes.TipoDeSuscripcion
  Set mEstatus = CreateObject("WebForumsTypes.Estatus")
  EstatusINACTIVO = mEstatus.INACTIVO
  Set mEstatus = Nothing
  Set mTipoDeSuscripcion = CreateObject("WebForumsTypes.TipoDeSuscripcion")
  TipoDeSuscripcionADMIN_MODERADOR = mTipoDeSuscripcion.ADMIN_MODERADOR
  TipoDeSuscripcionMODERADOR = mTipoDeSuscripcion.MODERADOR
  TipoDeSuscripcionNORMAL = mTipoDeSuscripcion.Normal
  TipoDeSuscripcionSUSPENDIDO = mTipoDeSuscripcion.SUSPENDIDO
  Set mTipoDeSuscripcion = Nothing
End Sub
