VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CEnumVariant"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'     Este cdigo esta basado en el cdigo y ejemplos del libro:
'     Hardcore Visual Basic
'     Online Update for Visual Basic 6.0
'
'     Bruce McKinney
'     www.pobox.com/HardcoreVB

Option Explicit

' Implement VB version of IEnumVARIANT (from type library interface)
Implements IVBEnumVARIANT

Private connect As IVariantWalker

' Delegators must connect themselves so we can call back
Sub Attach(connectA As IVariantWalker)
    Set connect = connectA
End Sub

Private Sub Class_Initialize()
    ' Only executes once for life of program
    If MEnumVariant.fNotFirstTime = False Then
        MEnumVariant.fNotFirstTime = True
        ' There's only one v-table for the object, so modify it once
        Dim iev As IVBEnumVARIANT
        Set iev = Me
        ' Ignore item 1: QueryInterface
        ' Ignore item 2: AddRef
        ' Ignore item 3: Release
        ReplaceVtableEntry ObjPtr(iev), 4, AddressOf MEnumVariant.BasNext
        ReplaceVtableEntry ObjPtr(iev), 5, AddressOf MEnumVariant.BasSkip
        ' Ignore item 6: Reset
        ' Ignore item 7: Clone
    End If

End Sub

' ********************************************************************************
' Dummy versions of implemented functions are replaced by standard module versions
Private Sub IVBEnumVARIANT_Next(ByVal cv As Long, v As Variant, ByVal cvFetched As Long)
End Sub

Private Sub IVBEnumVARIANT_Skip(ByVal cv As Long)
End Sub
' ********************************************************************************

' Can be implemented directly--no need to mess with the v-table
Private Sub IVBEnumVARIANT_Reset()
    If connect Is Nothing Then Err.Raise 445
    connect.Reset
End Sub

' Not implemented--just raise an error
Private Sub IVBEnumVARIANT_Clone(ppenum As stdole.IEnumVARIANT)
    Err.Raise &H80004001     ' E_NOTIMPL
End Sub

'' Object methods called by standard module v-table functions contain implementation
Function ClsNext(v As Variant) As Boolean
  If connect Is Nothing Then Err.Raise 445
  ClsNext = connect.More(v)
End Function

Sub ClsSkip(c As Long)
  If connect Is Nothing Then Err.Raise 445
  connect.Skip c
End Sub


