VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CVectorIntWalker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'     Este cdigo esta basado en el cdigo y ejemplos del libro:
'     Hardcore Visual Basic
'     Online Update for Visual Basic 6.0
'
'     Bruce McKinney
'     www.pobox.com/HardcoreVB

Option Explicit

' Implement Basic-friendly version of IEnumVARIANT
Implements IVariantWalker
' Connect back to parent collection
Private connect As CVectorInt

' Private state data
Private iCur As Long

Private Sub Class_Initialize()
  ' Initialize position in collection
  iCur = 0
End Sub

' Receive connection from CVectorInt
Friend Sub Attach(connectA As CVectorInt)
  Set connect = connectA
End Sub

' Return IEnumVARIANT (indirectly) to client collection
Function NewEnum() As stdole.IEnumVARIANT
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
  ' Delegate to class that implements real IEnumVARIANT
  Dim vars As CEnumVariant
  ' Connect walker to CEnumVariant so it can call methods
  Set vars = New CEnumVariant
  vars.Attach Me
  ' Return walker to collection data
  Set NewEnum = vars
End Function

' Implement IVariantWalker methods
Private Function IVariantWalker_More(v As Variant) As Boolean
  ' Move to next element
  iCur = iCur + 1
  ' Return False if no more data
  If iCur > connect.Last Then Exit Function
  ' Return element through reference
  v = connect.Vector(iCur)
  IVariantWalker_More = True
End Function

Private Sub IVariantWalker_Reset()
  ' Move to first element
  iCur = 0
End Sub

Private Sub IVariantWalker_Skip(c As Long)
  ' Skip a given number of elements
  iCur = iCur + c
End Sub

