VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CVectorObj"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'     Este cdigo esta basado en el cdigo y ejemplos del libro:
'     McKinney, Bruce, 1953Hardcore Visual Basic / Bruce McKinney. -- 2nd ed.
'     ISBN 1-57231-422-2
'     y la actualizacin el mismo
'     Online Update for Visual Basic 6.0
'
'     Bruce McKinney
'     www.pobox.com/HardcoreVB

Option Explicit

Private ao() As Object
Private iLast As Long
Private cChunk As Long

Private Sub Class_Initialize()
    cChunk = 10     ' Default size can be overridden
    ReDim ao(1 To cChunk) As Object
    iLast = 0
End Sub

' Item is the default property
Property Get item(ByVal i As Long) As Object
Attribute item.VB_UserMemId = 0
    If Not i > 0 Then Err.Raise 445
    ' If index is out-of-range, return default (Empty)
    On Error Resume Next
    Set item = ao(i)
End Property

Property Set item(ByVal i As Long, ByVal vItemA As Object)
    If Not i > 0 Then Err.Raise 445
    On Error GoTo FailSetItem
    Set ao(i) = vItemA
    If i > iLast Then iLast = i
    Exit Property
FailSetItem:
    If i > UBound(ao) Then
        ReDim Preserve ao(1 To i + cChunk) As Object
        Resume      ' Try again
    End If
    Err.Raise Err.Number     ' Other VB error for client
End Property

Property Get Last() As Long
    Last = iLast
End Property

Property Let Last(iLastA As Long)
    If Not iLastA > 0 Then Err.Raise 445
    ReDim Preserve ao(1 To iLastA) As Object
    iLast = iLastA
End Property

Property Get Chunk() As Long
    Chunk = cChunk
End Property

Property Let Chunk(cChunkA As Long)
    If Not cChunkA > 0 Then Err.Raise 445
    cChunk = IIf(cChunkA < 100, cChunkA, 100)
End Property

Public Function toArray() As Object()
  If Last = 0 Then
    Dim arrDummy() As Object
    toArray = arrDummy
  Else
    Last = Last
    toArray = ao
  End If
End Function

Public Sub Clear()
  ReDim ao(1 To cChunk) As Object
  iLast = 0
End Sub

' Friend properties to make data structure accessible to walker
Friend Property Get vector(ByVal i As Long) As Object
    If i <= 0 Or i > iLast Then Err.Raise 445
    Set vector = ao(i)
End Property

' NewEnum must have the procedure ID -4 in Procedure Attributes dialog
' Create a new data walker object and connect to it
Public Function NewEnum() As stdole.IEnumVARIANT
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    ' Create a new iterator object
    Dim vectorwalker As CVetcorObjWalker
    Set vectorwalker = New CVetcorObjWalker
    ' Connect it with collection data
    vectorwalker.Attach Me
    ' Return it
    Set NewEnum = vectorwalker.NewEnum
End Function


