VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MensajeTree"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public mensaje_primero As IMensajeMinimo

Private nodos As CVectorObj

Private Sub Class_Initialize()
  Set mensaje_primero = New MensajeNulo
End Sub

Friend Sub Build(mensajes As Variant)
  Dim mens As Variant
  For Each mens In mensajes
    Add mens
  Next
End Sub

Friend Sub Add(vMensaje As Variant)
  Dim flagParentFound As Boolean
  Dim aLeaf As New MensajeTree
  Dim i As Integer
  Dim mensaje As IMensajeMinimo

  On Error GoTo errhandler

  Set mensaje = vMensaje
  With nodos
    If mensaje.IdMensajeOriginal = mensaje_primero.IdMensaje Then
      Set aLeaf.mensaje_primero = mensaje
      If nodos Is Nothing Then
        Set nodos = New CVectorObj
        Set nodos.item(1) = aLeaf
      Else
        Set .item(.Last + 1) = aLeaf
      End If
      Exit Sub
    Else
      If Not nodos Is Nothing Then
        For i = 1 To .Last
          flagParentFound = True
          Set aLeaf = .item(i)
          aLeaf.Add vMensaje
          If flagParentFound Then Exit Sub
        Next i
      End If
    End If
  End With
  
  On Error GoTo 0
  
  Err.Raise vbObjectError + 1001, , "Element (" & mensaje.IdMensaje & _
    ") has no parents in the tree"
    Exit Sub
    
errhandler:
  If Err.Number = vbObjectError + 1001 Then
    flagParentFound = False
    Resume Next
  Else
    Err.Raise Err.Number
  End If
End Sub

Public Function toArray() As Object()
  Dim i As Integer, j As Integer
  Dim vectObj As CVectorObj
  Dim arr() As Object
  Dim num_nodos As Integer
  
  If Not nodos Is Nothing Then num_nodos = nodos.Last
  'else num_nodos=0
  If Not nodos Is Nothing Or mensaje_primero.IdMensaje > 0 Then
    Set vectObj = New CVectorObj
    ' primero va el padre (si es que no es un mensaje nulo)
    If mensaje_primero.IdMensaje > 0 Then
      Set vectObj.item(1) = mensaje_primero
    End If
    ' luego sus hijitos... y nietos, bisnietos, etc.
    For i = 1 To num_nodos
      arr = nodos.item(i).toArray
      For j = LBound(arr) To UBound(arr)
        Set vectObj.item(vectObj.Last + 1) = arr(j)
      Next j
    Next i
    toArray = vectObj.toArray
  End If
End Function

Public Function depthArray(Optional ByVal currDeep As Integer = 0) As Integer()
  Dim i As Integer, j As Integer
  Dim vectInt As CVectorInt
  Dim arr() As Integer
  Dim num_nodos As Integer
  
  If Not nodos Is Nothing Then num_nodos = nodos.Last
  'else num_nodos=0
  If Not nodos Is Nothing Or mensaje_primero.IdMensaje > 0 Then
    Set vectInt = New CVectorInt
    ' primero va el padre (si es que no es un mensaje nulo)
    If mensaje_primero.IdMensaje > 0 Then
      vectInt.item(1) = currDeep
    End If
    ' luego sus hijitos... y nietos, bisnietos, etc.
    For i = 1 To num_nodos
      arr = nodos.item(i).depthArray(currDeep + 1)
      For j = LBound(arr) To UBound(arr)
        vectInt.item(vectInt.Last + 1) = arr(j)
      Next j
    Next i
    depthArray = vectInt.toArray
  End If
End Function

Public Function depthVariantArray(Optional ByVal currDeep As Integer = 0) As Variant
  Dim i As Integer
  Dim vRetVal()
  Dim arrIntTmp() As Integer
  
  arrIntTmp = depthArray(currDeep)
  ReDim vRetVal(LBound(arrIntTmp) To UBound(arrIntTmp))
  For i = LBound(arrIntTmp) To UBound(arrIntTmp)
    vRetVal(i) = arrIntTmp(i)
  Next i
  depthVariantArray = vRetVal
End Function
