VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PagedIterator"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Implement Basic-friendly version of IEnumVARIANT
Implements IVariantWalker
' mArray back to parent collection
Private mArray As Variant

' Private state data
Private mIndex As Long
Private mPage As Long
Private mPageSize As Integer

Public Sub Init(ByRef vector As Variant, Optional ByVal page As Long, Optional ByVal pageSize As Integer)
  If Not IsArray(vector) Then Err.Raise vbObjectError + 1001, , "El parmetro ""vector"" debe de ser un Arreglo"
  mArray = vector
  If pageSize > 0 Then
    mPageSize = pageSize
  Else
    mPageSize = UBound(mArray)
  End If
  If page >= 0 Then
    mPage = page
  Else
    mPage = 1
  End If
  If mPage > pagesCount Then
    mPage = pagesCount
  End If
  ' Initialize position in collection
  mIndex = 0
End Sub

' Return IEnumVARIANT (indirectly) to client collection
Function NewEnum() As stdole.IEnumVARIANT
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
  ' Delegate to class that implements real IEnumVARIANT
  Dim vars As CEnumVariant
  ' mArray walker to CEnumVariant so it can call methods
  Set vars = New CEnumVariant
  vars.Attach Me
  ' Return walker to collection data
  Set NewEnum = vars
End Function

' Implement IVariantWalker methods
Private Function IVariantWalker_More(v As Variant) As Boolean
  ' Move to next element
  mIndex = mIndex + 1
  ' Return False if no more data
  If (mPage - 1) * mPageSize + mIndex > Min(UBound(mArray), mPage * mPageSize) Or mPage < 1 Then Exit Function
  ' Return element through reference
  If IsObject(mArray((mPage - 1) * mPageSize + mIndex)) Then
    Set v = mArray((mPage - 1) * mPageSize + mIndex)
  Else
    v = mArray((mPage - 1) * mPageSize + mIndex)
  End If
  IVariantWalker_More = True
End Function

Private Sub IVariantWalker_Reset()
  ' Move to first element
  mIndex = 0
End Sub

Private Sub IVariantWalker_Skip(c As Long)
  ' Skip a given number of elements
  mIndex = mIndex + c
End Sub

Private Function Min(value1 As Long, value2 As Long) As Long
 If value1 < value2 Then
  Min = value1
 Else
  Min = value2
 End If
End Function

Public Property Get currentPage() As Long
  currentPage = mPage
End Property

Public Property Get length() As Long
  length = UBound(mArray) - LBound(mArray) + 1
End Property

Public Property Get currentIndex() As Long
  currentIndex = mIndex
End Property

Public Property Get currentAbsoluteIndex() As Long
  currentAbsoluteIndex = (mPage - 1) * mPageSize + mIndex
End Property

Public Property Get pagesCount() As Long
  pagesCount = Ceil(UBound(mArray) / mPageSize)
End Property

Private Function Ceil(value As Double) As Long
  Ceil = IIf(Int(value) = value, Int(value), Int(value) + 1)
End Function

