VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "VectorInteger"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private av() As Integer
Private iLast As Long
Private cChunk As Long

Private Sub Class_Initialize()
    cChunk = 10     ' Default size can be overridden
    ReDim av(1 To cChunk) As Integer
    iLast = 0
End Sub

' Item is the default property
Property Get item(ByVal i As Long) As Integer
    If Not i > 0 Then Err.Raise 445
    ' If index is out-of-range, return default (Empty)
    On Error Resume Next
    item = av(i)
End Property

Property Let item(ByVal i As Long, ByVal vItemA As Integer)
    If Not i > 0 Then Err.Raise 445
    On Error GoTo FailSetItem
    av(i) = vItemA
    If i > iLast Then iLast = i
    Exit Property
FailSetItem:
    If i > UBound(av) Then
        ReDim Preserve av(1 To i + cChunk) As Integer
        Resume      ' Try again
    End If
    Err.Raise Err.Number     ' Other VB error for client
End Property

Property Get Last() As Long
    Last = iLast
End Property

Property Let Last(iLastA As Long)
    If Not iLastA > 0 Then Err.Raise 445
    ReDim Preserve av(1 To iLastA) As Integer
    iLast = iLastA
End Property

Property Get Chunk() As Long
    Chunk = cChunk
End Property

Property Let Chunk(cChunkA As Long)
    If Not cChunkA > 0 Then Err.Raise 445
    cChunk = IIf(cChunkA < 100, cChunkA, 100)
End Property

Property Get LowerBound() As Long
    LowerBound = LBound(av)
End Property

Public Function toArray() As Integer()
  Last = Last
  toArray = av
End Function
