VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Uploader"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private sUploadDirectory As String
Private bAutomaticSave As Boolean
Private bFlagSaved As Boolean
Private bFlagParsed As Boolean
Private dictForm As Scripting.Dictionary
Private dictFilesName As Scripting.Dictionary
Private dictFilesData As Scripting.Dictionary
Private dictFilesContentType As Scripting.Dictionary

Public Property Let AutomaticSave(ByVal vData As Boolean)
  bAutomaticSave = vData
End Property

Public Property Get AutomaticSave() As Boolean
  AutomaticSave = bAutomaticSave
End Property

Public Property Let UploadDirectory(ByVal vData As String)
  sUploadDirectory = vData
  If Mid(sUploadDirectory, Len(sUploadDirectory)) <> "\" Then sUploadDirectory = sUploadDirectory & "\"
End Property

Public Property Get UploadDirectory() As String
  UploadDirectory = sUploadDirectory
End Property

Public Function Form() As Scripting.Dictionary
  Set Form = dictForm
End Function

Public Function FilesData() As Scripting.Dictionary
  Set FilesData = dictFilesData
End Function

Public Function FilesName() As Scripting.Dictionary
  Set FilesName = dictFilesName
End Function

Public Function FilesContentType() As Scripting.Dictionary
  Set FilesContentType = dictFilesContentType
End Function

Public Sub Parse()
  If Not bFlagParsed Then
    Dim objContext As COMSVCSLib.ObjectContext
    Dim objRequest As ASPTypeLibrary.Request
    Dim biData As String, sInputName As String
    Dim nPosBegin As Long, nPosEnd As Long, nPos As Long
    Dim vDataBounds As String, nDataBoundPos As Long
    Dim nPosFile As Long, nPosBound As Long
    Dim sFileName As String
    
    Set objContext = GetObjectContext
    Set objRequest = objContext("Request")
    biData = objRequest.BinaryRead(objRequest.TotalBytes)
    Set objRequest = Nothing
    Set objContext = Nothing
    bFlagParsed = True
    nPosBegin = 1
    nPosEnd = InStrB(nPosBegin, biData, CByteString(Chr(13)))
    If (nPosEnd - nPosBegin) <= 0 Then Exit Sub
    vDataBounds = MidB(biData, nPosBegin, nPosEnd - nPosBegin)
    nDataBoundPos = InStrB(1, biData, vDataBounds)
    Do Until nDataBoundPos = InStrB(biData, vDataBounds & CByteString("--"))
      nPos = InStrB(nDataBoundPos, biData, CByteString("Content-Disposition"))
      nPos = InStrB(nPos, biData, CByteString("name="))
      nPosBegin = nPos + 6
      nPosEnd = InStrB(nPosBegin, biData, CByteString(Chr(34)))
      sInputName = CWideString(MidB(biData, nPosBegin, nPosEnd - nPosBegin))
      nPosFile = InStrB(nDataBoundPos, biData, CByteString("filename="))
      nPosBound = InStrB(nPosEnd, biData, vDataBounds)
      If nPosFile <> 0 And nPosFile < nPosBound Then
        nPosBegin = nPosFile + 10
        nPosEnd = InStrB(nPosBegin, biData, CByteString(Chr(34)))
        sFileName = CWideString(MidB(biData, nPosBegin, nPosEnd - nPosBegin))
        sFileName = Right(sFileName, Len(sFileName) - InStrRev(sFileName, "\"))
        If Not dictFilesName.Exists(LCase(sInputName)) Then dictFilesName.Add LCase(sInputName), sFileName
        nPos = InStrB(nPosEnd, biData, CByteString("Content-Type:"))
        nPosBegin = nPos + 14
        nPosEnd = InStrB(nPosBegin, biData, CByteString(Chr(13)))
        If Not dictFilesContentType.Exists(LCase(sInputName)) Then dictFilesContentType.Add LCase(sInputName), CWideString(MidB(biData, nPosBegin, nPosEnd - nPosBegin))
        nPosBegin = nPosEnd + 4
        nPosEnd = InStrB(nPosBegin, biData, vDataBounds) - 2
        If Not dictFilesData.Exists(LCase(sInputName)) Then dictFilesData.Add LCase(sInputName), MidB(biData, nPosBegin, nPosEnd - nPosBegin)
      Else
        nPos = InStrB(nPos, biData, CByteString(Chr(13)))
        nPosBegin = nPos + 4
        nPosEnd = InStrB(nPosBegin, biData, vDataBounds) - 2
        If Not dictForm.Exists(LCase(sInputName)) Then dictForm.Add LCase(sInputName), CWideString(MidB(biData, nPosBegin, nPosEnd - nPosBegin))
      End If
      nDataBoundPos = InStrB(nDataBoundPos + LenB(vDataBounds), biData, vDataBounds)
    Loop
    If bAutomaticSave Then SaveFiles False
  Else
    Err.Raise 445, App.EXEName, "Request already parsed!"
  End If
End Sub
  
'String to byte string conversion
Private Function CByteString(sString) As String
  Dim nIndex As Long
  For nIndex = 1 To Len(sString)
     CByteString = CByteString & ChrB(AscB(Mid(sString, nIndex, 1)))
  Next
End Function

'Byte string to string conversion
Private Function CWideString(bsString) As String
  Dim nIndex As Long
  CWideString = ""
  For nIndex = 1 To LenB(bsString)
     CWideString = CWideString & Chr(AscB(MidB(bsString, nIndex, 1)))
  Next
End Function

Public Sub SaveFiles(Optional ByVal ReSave As Boolean = False)
  Dim objFSO As Scripting.FileSystemObject
  Dim oFile As Scripting.TextStream
  Dim nIndex As Long
  Dim item As Variant
  Dim FileData As String

  bFlagSaved = bFlagSaved And bFlagParsed
  If bFlagSaved And Not ReSave Then Exit Sub
  If Len(sUploadDirectory) = 0 Then Err.Raise 445, App.EXEName, "UploadDirectory is required!"
  On Error GoTo ErrHandler
  Set objFSO = CreateObject("Scripting.FileSystemObject")
  If Not objFSO.FolderExists(sUploadDirectory) Then Err.Raise 445, App.EXEName, "UploadDirectory is invalid!"
  If Not bFlagParsed Then Parse
  Set objFSO = CreateObject("Scripting.FileSystemObject")
  If Not objFSO.FolderExists(sUploadDirectory) Then Exit Sub
  For Each item In dictFilesName.Keys
    Set oFile = objFSO.CreateTextFile(sUploadDirectory & dictFilesName(item), True)
    FileData = dictFilesData(item)
    For nIndex = 1 To LenB(FileData)
      oFile.Write Chr(AscB(MidB(FileData, nIndex, 1)))
    Next
    oFile.Close
  Next item
  bFlagSaved = True
  Exit Sub
ErrHandler:
  Set objFSO = Nothing
  Err.Raise Err.Number
End Sub

Private Sub Class_Initialize()
 Set dictForm = CreateObject("Scripting.Dictionary")
 Set dictFilesName = CreateObject("Scripting.Dictionary")
 Set dictFilesData = CreateObject("Scripting.Dictionary")
 Set dictFilesContentType = CreateObject("Scripting.Dictionary")
End Sub
