VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "AttachmentPersist"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements ObjectControl
Private mobjContext As ObjectContext
Private mflgInMTS As Boolean

Public Function putAttachment(ByVal Buffer As String) As String
  Dim udtProps As AttachmentProps
  Dim rs As New adodb.Recordset
  Dim strSQL As String
  
  On Error GoTo errhandler
  
  udtProps = DeserializeAttachment(Buffer)
  strSQL = "SELECT * FROM ATTACHMENT WHERE ID_MENSAJE = " & udtProps.id_mensaje
  With rs
    .Open strSQL, DBCONNECTION, adOpenKeyset, adLockOptimistic
    .AddNew
    .Fields("id_mensaje") = udtProps.id_mensaje
    .Fields("uri") = Trim$(udtProps.uri)
    .Update
    .Close
  End With
  Set rs = Nothing
  putAttachment = SerializeAttachment(udtProps)
  Exit Function

errhandler:
  Set rs = Nothing
  Err.Raise Err.Number
End Function

Private Function removeFile(ByVal pathname As String) As Boolean
  Dim objFSO As Scripting.FileSystemObject
  Dim winpath As String
  
  On Error GoTo errhandler
  
  winpath = TranslateToWinPath(ATTACHMENTPATH & pathname)
  Set objFSO = CreateObject("Scripting.FileSystemObject")
  If objFSO.FolderExists(Mid(winpath, 1, InStrRev(winpath, "\"))) Then
    If objFSO.FileExists(winpath) Then objFSO.DeleteFile (winpath)
    objFSO.DeleteFolder Mid(winpath, 1, InStrRev(winpath, "\") - 1), True
  End If
  removeFile = True
  Set objFSO = Nothing
  Exit Function

errhandler:
  Set objFSO = Nothing
  removeFile = False
End Function

Public Function removeAttachment(ByVal id_mensaje As Long) As Boolean
  Dim strSQL As String
  Dim rs As New adodb.Recordset
  
  On Error GoTo errhandler

  strSQL = "Select ID_MENSAJE, URI From ATTACHMENT Where ID_MENSAJE = " & id_mensaje
  With rs
    .Open strSQL, DBCONNECTION, adOpenKeyset, adLockOptimistic
    If Not .EOF Then
      If removeFile(.Fields("URI")) Then
        .Delete adAffectCurrent
        .Update
      Else
        Err.Raise vbObjectError + 1001, , "No se pudo borrar el archivo fsico"
      End If
    End If
    .Close
  End With
  Set rs = Nothing
  removeAttachment = True
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  removeAttachment = False
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Private Function DeserializeAttachment(ByVal Buffer As String) As AttachmentProps
  Dim udtData As AttachmentData
  Dim PBag As PropertyBag
  Dim arrbyte_buff() As Byte
  
  arrbyte_buff = Buffer
  Set PBag = New PropertyBag
  With PBag
    .Contents = arrbyte_buff
    udtData.Buffer = .ReadProperty("fixedlength_state")
  End With
  Set PBag = Nothing
  LSet DeserializeAttachment = udtData
End Function

Private Function SerializeAttachment(ByRef udtProps As AttachmentProps) As String
  Dim udtData As AttachmentData
  Dim PBag As PropertyBag
  
  LSet udtData = udtProps
  Set PBag = New PropertyBag
  With PBag
    .WriteProperty "fixedlength_state", udtData.Buffer
    SerializeAttachment = .Contents
  End With
  Set PBag = Nothing
End Function

Private Sub ObjectControl_Activate()
  Set mobjContext = GetObjectContext
  mflgInMTS = True
End Sub

Private Function ObjectControl_CanBePooled() As Boolean
  ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
  Set mobjContext = Nothing
End Sub
