Attribute VB_Name = "AuxRegistro"
Option Explicit

Public Declare Function RegCreateKey Lib "advapi32" Alias "RegCreateKeyA" _
   (ByVal hKey As Long, _
    ByVal lpszSubKey As String, _
    phkResult As Long) _
    As Long
    
Public Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" _
   (ByVal hKey As Long, _
    ByVal lpSubKey As String, _
    ByVal Reserved As Long, _
    ByVal lpClass As String, _
    ByVal dwOptions As Long, _
    ByVal samDesired As Long, _
    lpSecurityAttributes As Any, _
    phkResult As Long, lpdwDisposition As Long) _
    As Long
    
Public Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" _
   (ByVal hKey As Long, _
    ByVal lpSubKey As String) _
    As Long
    
Public Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" _
   (ByVal hKey As Long, _
    ByVal lpValueName As String) _
    As Long
    
Public Declare Function RegEnumKeyEx Lib "advapi32" Alias "RegEnumKeyA" _
   (ByVal hKey As Long, _
    ByVal iSubKey As Long, _
    ByVal lpszName As String, _
    ByVal cchName As Long) _
    As Long
    
Public Declare Function RegOpenKeyEx Lib "advapi32" Alias "RegOpenKeyExA" _
   (ByVal hKey As Long, _
    ByVal lpszSubKey As String, _
    ByVal ulOptions As Long, _
    ByVal samDesired As Long, _
    phkResult As Long) _
    As Long
    
Public Declare Function RegSetValueEx Lib "advapi32" Alias "RegSetValueExA" _
   (ByVal hKey As Long, _
    ByVal lpszValueName As String, _
    ByVal dwReserved As Long, _
    ByVal fdwType As Long, _
    lpbData As Any, _
    ByVal cbData As Long) _
    As Long
    
Public Declare Function RegSetStringEx Lib "advapi32" Alias "RegSetValueExA" _
   (ByVal hKey As Long, _
    ByVal lpszValueName As String, _
    ByVal dwReserved As Long, _
    ByVal fdwType As Long, _
    lpbData As String, _
    ByVal cbData As Long) _
    As Long

Public Declare Function RegEnumValue Lib "advapi32.dll" _
    Alias "RegEnumValueA" _
    (ByVal hKey As Long, _
    ByVal dwIndex As Long, _
    ByVal lpValueName As String, _
    lpcbValueName As Long, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    lpData As Any, _
    lpcbData As Long) As Long
    
Public Declare Function RegQueryValueEx Lib "advapi32.dll" _
    Alias "RegQueryValueExA" _
    (ByVal hKey As Long, _
    ByVal lpValueName As String, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    lpData As Any, _
    lpcbData As Long) As Long    ' Note that if you declare the lpData parameter as String, you must pass it By Value.

Public Declare Function RegQueryValueExString Lib "advapi32.dll" _
    Alias "RegQueryValueExA" _
    (ByVal hKey As Long, _
    ByVal lpValueName As String, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    ByVal lpData As String, _
    lpcbData As Long) As Long
    
Public Declare Function RegQueryValueExLong Lib "advapi32.dll" _
    Alias "RegQueryValueExA" _
    (ByVal hKey As Long, _
    ByVal lpValueName As String, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    lpData As Long, _
    lpcbData As Long) As Long
    
Public Declare Function RegQueryValueExNULL Lib "advapi32.dll" _
    Alias "RegQueryValueExA" _
    (ByVal hKey As Long, _
    ByVal lpValueName As String, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    ByVal lpData As Long, _
    lpcbData As Long) As Long
   

Public Declare Function RegCloseKey Lib "advapi32.dll" _
    (ByVal hKey As Long) As Long

Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003

Public Const ERROR_SUCCESS = 0&
Public Const ERROR_NONE = 0
Public Const ERROR_BADDB = 1
Public Const ERROR_BADKEY = 2
Public Const ERROR_CANTOPEN = 3
Public Const ERROR_CANTREAD = 4
Public Const ERROR_CANTWRITE = 5
Public Const ERROR_OUTOFMEMORY = 6
Public Const ERROR_INVALID_PARAMETER = 7
Public Const ERROR_ACCESS_DENIED = 8
Public Const ERROR_INVALID_PARAMETERS = 87
Public Const ERROR_NO_MORE_ITEMS = 259


Public Const SYNCHRONIZE = &H100000
Public Const STANDARD_RIGHTS_READ = &H20000
Public Const STANDARD_RIGHTS_WRITE = &H20000
Public Const STANDARD_RIGHTS_EXECUTE = &H20000
Public Const STANDARD_RIGHTS_REQUIRED = &HF0000
Public Const STANDARD_RIGHTS_ALL = &H1F0000
Public Const KEY_QUERY_VALUE = &H1
Public Const KEY_SET_VALUE = &H2
Public Const KEY_CREATE_SUB_KEY = &H4
Public Const KEY_ENUMERATE_SUB_KEYS = &H8
Public Const KEY_NOTIFY = &H10
Public Const KEY_CREATE_LINK = &H20
Public Const KEY_READ = ((STANDARD_RIGHTS_READ Or _
        KEY_QUERY_VALUE Or _
        KEY_ENUMERATE_SUB_KEYS Or _
        KEY_NOTIFY) And _
        (Not SYNCHRONIZE))

Public Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or _
         KEY_QUERY_VALUE Or _
         KEY_SET_VALUE Or _
         KEY_CREATE_SUB_KEY Or _
         KEY_ENUMERATE_SUB_KEYS Or _
         KEY_NOTIFY Or _
         KEY_CREATE_LINK) And (Not SYNCHRONIZE))
        

Public Const REG_DWORD = 4
Public Const REG_BINARY = 3
Public Const REG_SZ = 1

Public Function QueryValueEx(ByVal lhKey As Long, ByVal szValueName As String, ByRef vValue As Variant) As Long
  Dim cch As Long
  Dim lrc As Long
  Dim lType As Long
  Dim lValue As Long
  Dim sValue As String

  On Error GoTo QueryValueExError

  ' Determine the size and type of data to be read
  lrc = RegQueryValueExNULL(lhKey, szValueName, 0&, lType, 0&, cch)
  If lrc <> ERROR_NONE Then Error 5

  Select Case lType
    ' For strings
    Case REG_SZ:
      sValue = String(cch, 0)
      lrc = RegQueryValueExString(lhKey, szValueName, 0&, lType, sValue, cch)
      If lrc = ERROR_NONE Then
        vValue = Left$(sValue, cch - 1)
      Else
        vValue = Empty
      End If
    ' For DWORDS
    Case REG_DWORD:
      lrc = RegQueryValueExLong(lhKey, szValueName, 0&, lType, lValue, cch)
      If lrc = ERROR_NONE Then vValue = lValue
    'all other data types not supported
    Case Else
      lrc = -1
    End Select

QueryValueExExit:
  QueryValueEx = lrc
  Exit Function
QueryValueExError:
  Resume QueryValueExExit
End Function

Public Function SetValueEx(ByVal lhKey As Long, ByVal szValueName As String, ByVal vValue As Variant) As Long
  Dim cch As Long
  Dim lrc As Long
  Dim lType As Long
  Dim lValue As Long
  Dim sValue As String

  On Error GoTo SetValueExError

  ' Determine the size and type of data to be write
  lrc = RegQueryValueExNULL(lhKey, szValueName, 0&, lType, 0&, cch)
  If lrc <> ERROR_NONE Then Error 5

  Select Case lType
    ' For strings
    Case REG_SZ:
      sValue = CStr(vValue)
      lrc = RegSetValueEx(lhKey, szValueName, _
                          ByVal 0&, lType, _
                          ByVal sValue, Len(sValue))
    ' For DWORDS
    Case REG_DWORD:
      lValue = CLng(vValue)
      lrc = RegSetValueEx(lhKey, szValueName, _
                              ByVal 0&, lType, _
                              lValue, Len(lValue))
    'all other data types not supported
    Case Else
      lrc = -1
    End Select
SetValueExExit:
  SetValueEx = lrc
  Exit Function
SetValueExError:
  Resume SetValueExExit
End Function

'''Function CreateRegEntry(pDatatype As Long, _
'''                        KeyToAdd As Variant, _
'''                        ValueToAdd As Variant) As Boolean
'''   On Local Error GoTo CreateRegEntry_Err
'''   ' ***********************************************
'''   ' Declare local usage variables.
'''   ' ***********************************************
'''   Dim lResult As Long, i As Integer, Msg As String
'''   Dim strMyKeyFull As String, MyKeyName As String
'''   Dim MyKeyValueLng As Long, MyKeyValueStr As String
'''   Dim MyDataType As Long, phkResult As Long, IsNewKey As Long
'''   ' ***********************************************
'''   ' Set path to your application's settings.
'''   ' ***********************************************
'''   lResult = RegCreateKeyEx(HKEY_LOCAL_MACHINE, REG_APP_KEYS_PATH, 0&, _
'''                            REG_SZ, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, _
'''                            ByVal 0&, phkResult, IsNewKey)
'''   If Not (lResult = ERROR_SUCCESS) Then
'''      CreateRegEntry = False
'''      Msg = "Error Creating Registry Key Entry:" & vbCrLf
'''      Msg = Msg & "Key=" & strMyKeyFull & vbCrLf
'''      Msg = Msg & "DLL Returned=" & Format$(lResult)
'''      MsgBox Msg, vbOKOnly Or vbExclamation, App.Title
'''      GoTo CreateRegEntry_End
'''   End If
'''    ' ***********************************************
'''    ' Determine data type and use appropriate
'''    ' passed value.
'''    ' ***********************************************
'''    Select Case pDatatype
'''       Case REG_DWORD
'''          MyKeyValueLng = ValueToAdd
'''          lResult = RegSetValueEx(phkResult, KeyToAdd, _
'''                                  ByVal 0&, pDatatype, _
'''                                  MyKeyValueLng, Len(MyKeyValueLng))
'''       Case REG_SZ
'''          MyKeyValueStr = ValueToAdd
'''          lResult = RegSetValueEx(phkResult, KeyToAdd, _
'''                                  ByVal 0&, pDatatype, _
'''                                  ByVal MyKeyValueStr, Len(MyKeyValueStr))
'''    End Select
'''    If Not (lResult = ERROR_SUCCESS) Then
'''       CreateRegEntry = False
'''       Msg = "Error Creating Registry Key Entry:" & vbCrLf
'''       Msg = Msg & "Key=" & KeyToAdd & vbCrLf
'''       Msg = Msg & "DLL Returned=" & Format$(lResult)
'''       MsgBox Msg, vbOKOnly Or vbExclamation, App.Title
'''       GoTo CreateRegEntry_End
'''    End If
'''   CreateRegEntry = True
'''CreateRegEntry_End:
'''   Exit Function
'''CreateRegEntry_Err:
'''   MsgBox Error.Description, vbOKOnly Or vbExclamation, App.Title
'''   Resume CreateRegEntry_End
'''End Function
'''
'''Function GetAppRegValue(WhatKey As String, _
'''                        KeyDataType As Variant, _
'''                        KeyValue As Variant, _
'''                        IsVerbose As Integer) As Boolean
'''   On Local Error GoTo GetAppRegValue_Err
'''   ' ***********************************************
'''   ' Declare local usage variables.
'''   ' ***********************************************
'''   Dim lResult As Long, dwResult As Long
'''   Dim dwType As Long, cbData As Long
'''   Dim varStrData As String, varLngData As Long
'''   Dim Msg As String
'''   ' ***********************************************
'''   ' Open the key for application's path.
'''   ' ***********************************************
'''   lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE, _
'''                          REG_APP_KEYS_PATH, _
'''                          ByVal 0&, KEY_ALL_ACCESS, dwResult)
'''   If Not (lResult = ERROR_SUCCESS) Then
'''      GetAppRegValue = False
'''      If IsVerbose Then
'''         Msg = "Error Opening Registry Key Entry:" & vbCrLf
'''         Msg = Msg & "Key/Path=" & REG_APP_KEYS_PATH & vbCrLf
'''         Msg = Msg & "DLL Returned=" & Format$(lResult)
'''         MsgBox Msg, vbOKOnly Or vbExclamation, "ODBC Registry"
'''      End If
'''      GoTo GetAppRegValue_End
'''   End If
'''   ' ***********************************************
'''   ' Set up passed variables and retrieve value.
'''   ' ***********************************************
'''   Select Case KeyDataType
'''      Case REG_SZ
'''         varStrData = String$(255, 0)
'''         cbData = Len(varStrData)
'''         lResult = RegQueryValueEx(dwResult, WhatKey, ByVal 0&, _
'''                                   dwType, ByVal varStrData, cbData)
'''      Case REG_DWORD
'''         varLngData = False
'''         cbData = Len(varLngData)
'''         lResult = RegQueryValueEx(dwResult, WhatKey, ByVal 0&, _
'''                                   dwType, varLngData, cbData)
'''   End Select
'''   If Not (lResult = ERROR_SUCCESS) Then
'''      GetAppRegValue = False
'''      If IsVerbose Then
'''         Msg = "Error Retrieving Registry Key Entry:" & vbCrLf
'''         Msg = Msg & "Key=" & WhatKey & vbCrLf
'''         Msg = Msg & "DLL Returned=" & Format$(lResult)
'''         MsgBox Msg, vbOKOnly Or vbExclamation, "ODBC Registry"
'''      End If
'''      lResult = RegCloseKey(dwResult)
'''      GoTo GetAppRegValue_End
'''   End If
'''   ' ***********************************************
'''   ' Close key.
'''   ' ***********************************************
'''   lResult = RegCloseKey(dwResult)
'''   ' ***********************************************
'''   ' Select data type (for the needed types
'''   ' used in the values) and assign value.
'''   ' ***********************************************
'''   Select Case dwType
'''      Case REG_NONE
'''         KeyValue = vbNull
'''      Case REG_SZ
'''         KeyValue = Left$(varStrData, cbData)
'''      Case REG_DWORD
'''         KeyValue = varLngData
'''      Case Else
'''         KeyValue = vbNull
'''   End Select
'''   GetAppRegValue = True
'''   Debug.Print KeyValue
'''GetAppRegValue_End:
'''   Exit Function
'''GetAppRegValue_Err:
'''   MsgBox Error.Description, vbOKOnly Or vbExclamation, "YourAppName"
'''   Resume GetAppRegValue_End
'''End Function

'''Function SetAppRegValue(WhatKey As String, _
'''                         KeyDataType As Variant, _
'''                         NewKeyValue As Variant) _
'''                         As Boolean
'''   On Local Error GoTo SetAppRegValue_Err
'''    ***********************************************
'''    Declare local usage variables.
'''    ***********************************************
'''   Dim lResult As Long, dwResult As Long
'''   Dim dwType As Long, cbData As Long
'''   Dim varStrData As String, varLngData As Long
'''   Dim Msg As String
'''    ***********************************************
'''    Open the key for application's path.
'''    ***********************************************
'''   lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE, _
'''                          REG_APP_KEYS_PATH, _
'''                          ByVal 0&, KEY_ALL_ACCESS, dwResult)
'''   If Not (lResult = ERROR_SUCCESS) Then
'''      SetAppRegValue = False
'''      Msg = "Error Opening Registry Key Entry:" & vbCrLf
'''      Msg = Msg & "Key/Path=" & REG_APP_KEYS_PATH & vbCrLf
'''      Msg = Msg & "DLL Returned=" & Format$(lResult)
'''      MsgBox Msg, vbOKOnly Or vbExclamation, "ODBC Registry"
'''      GoTo SetAppRegValue_End
'''   End If
'''    ***********************************************
'''    Set up passed variables and retrieve value.
'''    ***********************************************
'''   Select Case KeyDataType
'''      Case REG_SZ
'''         varStrData = NewKeyValue
'''         lResult = RegSetValueEx(dwResult, WhatKey, _
'''                                 ByVal 0&, KeyDataType, _
'''                                 ByVal varStrData, Len(varStrData))
'''      Case REG_DWORD
'''         varLngData = CLng(NewKeyValue)
'''         lResult = RegSetValueEx(dwResult, WhatKey, _
'''                                 ByVal 0&, KeyDataType, _
'''                                 varLngData, Len(varLngData))
'''   End Select
'''   If Not (lResult = ERROR_SUCCESS) Then
'''      SetAppRegValue = False
'''      Msg = "Error Setting Registry Key Entry:" & vbCrLf
'''      Msg = Msg & "Key=" & WhatKey & vbCrLf
'''      Msg = Msg & "DLL Returned=" & Format$(lResult)
'''      MsgBox Msg, vbOKOnly Or vbExclamation, "ODBC Registry"
'''      lResult = RegCloseKey(dwResult)
'''      GoTo SetAppRegValue_End
'''   End If
'''    ***********************************************
'''    Close key.
'''    ***********************************************
'''   lResult = RegCloseKey(dwResult)
'''   SetAppRegValue = True
'''SetAppRegValue_End:
'''   Exit Function
'''SetAppRegValue_Err:
'''   MsgBox Error.Description, vbOKOnly Or vbExclamation, "YourAppName"
'''   Resume SetAppRegValue_End
'''End Function


