VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "EmoticonPersist"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Implements ObjectControl
Private mobjContext As ObjectContext
Private mflgInMTS As Boolean

Public Function getEmoticon(ByVal id_emoticon As Long) As String
Dim rs As New adodb.Recordset
Dim strSQL As String
Dim udtProps As EmoticonProps

  On Error GoTo errhandler
  
  strSQL = "SELECT * FROM EMOTICON WHERE ID_EMOTICON = " & id_emoticon
  rs.Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
  With udtProps
    .id_emoticon = id_emoticon
    .uri = rs!uri & ""
  End With
  rs.Close
  Set rs = Nothing
  getEmoticon = SerializeEmoticon(udtProps)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "EmoticonPersist [getEmoticon()]: " & Err.Number & ": " & Err.Description & " (id_emoticon=" & id_emoticon & ")"
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function getAllEmoticons() As String
  Dim rs As New adodb.Recordset
  Dim strSQL As String
  Dim udtProps As EmoticonProps
  Dim lngIndex As Long
  Dim PBag As PropertyBag

  On Error GoTo errhandler
  
  Set PBag = New PropertyBag
  strSQL = "SELECT * FROM EMOTICON"
  rs.Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
  With rs
    While Not .EOF
      lngIndex = lngIndex + 1
      udtProps.id_emoticon = .Fields("id_emoticon").Value
      udtProps.uri = .Fields("uri").Value
      PBag.WriteProperty "Item" & lngIndex, SerializeEmoticon(udtProps)
      .MoveNext
    Wend
    .Close
  End With
  Set rs = Nothing
  PBag.WriteProperty "Count", lngIndex
  getAllEmoticons = PBag.Contents
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function

errhandler:
  App.LogEvent "EmoticonPersist [getAllEmoticons()]: " & Err.Number & ": " & Err.Description
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function updateEmoticon(ByVal Buffer As String) As String
  Dim udtProps As EmoticonProps
  
  On Error GoTo errhandler
  
  udtProps = DeserializeEmoticon(Buffer)
  updateEmoticon = saveEmoticon(udtProps, False)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "EmoticonPersist [updateEmoticon()]: " & Err.Number & ": " & Err.Description & " (id_emoticon=" & udtProps.id_emoticon & ")"
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function putEmoticon(ByVal Buffer As String) As String
  Dim udtProps As EmoticonProps
  
  On Error GoTo errhandler
  
  udtProps = DeserializeEmoticon(Buffer)
  putEmoticon = saveEmoticon(udtProps, True)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "EmoticonPersist [putEmoticon()]: " & Err.Number & ": " & Err.Description
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Private Function saveEmoticon(ByRef udtProps As EmoticonProps, ByVal isNew As Boolean) As String
Dim rs As New adodb.Recordset
Dim strSQL As String

  On Error GoTo errhandler

  strSQL = "SELECT * FROM EMOTICON WHERE ID_EMOTICON = " & udtProps.id_emoticon
  rs.Open strSQL, DBCONNECTION, adOpenKeyset, adLockOptimistic
  With udtProps
    If isNew Then
      Dim EmotIDGen As EmoticonIDGenerator
      If mflgInMTS Then
        Set EmotIDGen = mobjContext.CreateInstance("WebForumsPersist.EmoticonIDGenerator")
      Else
        Set EmotIDGen = CreateObject("WebForumsPersist.EmoticonIDGenerator")
      End If
      rs.AddNew
      .id_emoticon = EmotIDGen.getNextID
      Set EmotIDGen = Nothing
    End If
    rs!id_emoticon = .id_emoticon
    rs!uri = Trim$(.uri)
  End With
  rs.Update
  rs.Close
  Set rs = Nothing
  saveEmoticon = SerializeEmoticon(udtProps)
  Exit Function

errhandler:
  Set rs = Nothing
  Err.Raise Err.Number
End Function

Public Sub removeEmoticonCascade(ByVal id_emoticon As Long)
Dim cn As adodb.Connection
Dim strSQL As String
  
  On Error GoTo errhandler
  
  Set cn = New adodb.Connection
  With cn
    .Open DBCONNECTION
    strSQL = "UPDATE MENSAJE SET ID_EMOTICON = NULL WHERE ID_EMOTICON = " & id_emoticon
    .Execute strSQL
    strSQL = "DELETE EMOTICON WHERE ID_EMOTICON = " & id_emoticon
    .Execute strSQL
    .Close
  End With
  Set cn = Nothing
  If mflgInMTS Then mobjContext.SetComplete
  Exit Sub
  
errhandler:
  App.LogEvent "EmoticonPersist [removeEmoticonCascade()]: " & Err.Number & ": " & Err.Description & " (id_emoticon=" & id_emoticon & ")"
  Set cn = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Sub

Private Function DeserializeEmoticon(ByVal Buffer As String) As EmoticonProps
  Dim udtData As EmoticonData
  Dim PBag As PropertyBag
  Dim arrbyte_buff() As Byte
  
  arrbyte_buff = Buffer
  Set PBag = New PropertyBag
  With PBag
    .Contents = arrbyte_buff
    udtData.Buffer = .ReadProperty("fixedlength_state")
  End With
  Set PBag = Nothing
  LSet DeserializeEmoticon = udtData
End Function

Private Function SerializeEmoticon(ByRef udtProps As EmoticonProps) As String
  Dim udtData As EmoticonData
  Dim PBag As PropertyBag
  
  LSet udtData = udtProps
  Set PBag = New PropertyBag
  With PBag
    .WriteProperty "fixedlength_state", udtData.Buffer
    SerializeEmoticon = .Contents
  End With
  Set PBag = Nothing
End Function

Private Sub ObjectControl_Activate()
  Set mobjContext = GetObjectContext
  mflgInMTS = True
End Sub

Private Function ObjectControl_CanBePooled() As Boolean
  ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
  Set mobjContext = Nothing
End Sub

