VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "ForoPersist"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements ObjectControl
Private mobjContext As ObjectContext
Private mflgInMTS As Boolean

Public Function getForo(ByVal id_foro As Long) As String
Dim rs As New adodb.Recordset
Dim strSQL As String
Dim udtProps As ForoProps

  On Error GoTo errhandler
  
  strSQL = "SELECT * FROM FORO WHERE ID_FORO = " & id_foro
  rs.Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
  With udtProps
    .id_foro = id_foro
    .nombre = rs!nombre & ""
    .descripcion = rs!descripcion & ""
    .es_activo = rs!es_activo & ""
    .fecha_creacion = rs!fecha_creacion
    .fecha_ultima_visita = rs!fecha_ultima_visita
    .num_topicos = rs!num_topicos
    .num_visitas = rs!num_visitas
  End With
  rs.Close
  Set rs = Nothing
  getForo = SerializeForo(udtProps)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "ForoPersist [getForo()]: " & Err.Number & ": " & Err.Description & " (id_foro=" & id_foro & ")"
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function getForosActivos() As String
  Dim rs As New adodb.Recordset
  Dim strSQL As String
  Dim udtProps As ForoProps
  Dim lngIndex As Long
  Dim PBag As PropertyBag

  On Error GoTo errhandler
  
  Set PBag = New PropertyBag
  strSQL = "SELECT * FROM FORO WHERE ES_ACTIVO = 'S' ORDER BY ID_FORO"
  rs.Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
  With rs
    While Not .EOF
      lngIndex = lngIndex + 1
      udtProps.id_foro = .Fields("id_foro").Value
      udtProps.nombre = .Fields("nombre").Value
      udtProps.descripcion = .Fields("descripcion").Value
      udtProps.es_activo = .Fields("es_activo").Value
      udtProps.fecha_creacion = .Fields("fecha_creacion").Value
      udtProps.fecha_ultima_visita = .Fields("fecha_ultima_visita").Value
      udtProps.num_topicos = .Fields("num_topicos").Value
      udtProps.num_visitas = .Fields("num_visitas").Value
      PBag.WriteProperty "Item" & lngIndex, SerializeForo(udtProps)
      .MoveNext
    Wend
    .Close
  End With
  Set rs = Nothing
  PBag.WriteProperty "Count", lngIndex
  getForosActivos = PBag.Contents
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function

errhandler:
  App.LogEvent "ForoPersist [getForosActivos()]: " & Err.Number & ": " & Err.Description
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function getForosUsuario(ByVal id_usuario As Long) As String
  Dim rs As New adodb.Recordset
  Dim strSQL As String
  Dim udtProps As ForoProps
  Dim lngIndex As Long
  Dim PBag As PropertyBag

  On Error GoTo errhandler
  
  Set PBag = New PropertyBag
  strSQL = "SELECT T1.* FROM FORO T1, MIEMBRO_DE_FORO T2 " _
  & "WHERE T1.ID_FORO = T2.ID_FORO AND T2.STATUS_MIEMBRO = 'A' " _
  & "AND ID_USUARIO = " & id_usuario & " " _
  & "ORDER BY T1.ID_FORO"
  rs.Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
  With rs
    While Not .EOF
      lngIndex = lngIndex + 1
      udtProps.id_foro = .Fields("id_foro").Value
      udtProps.nombre = .Fields("nombre").Value
      udtProps.descripcion = .Fields("descripcion").Value
      udtProps.es_activo = .Fields("es_activo").Value
      udtProps.fecha_creacion = .Fields("fecha_creacion").Value
      udtProps.fecha_ultima_visita = .Fields("fecha_ultima_visita").Value
      udtProps.num_topicos = .Fields("num_topicos").Value
      udtProps.num_visitas = .Fields("num_visitas").Value
      PBag.WriteProperty "Item" & lngIndex, SerializeForo(udtProps)
      .MoveNext
    Wend
    .Close
  End With
  Set rs = Nothing
  PBag.WriteProperty "Count", lngIndex
  getForosUsuario = PBag.Contents
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function

errhandler:
  App.LogEvent "ForoPersist [getForosUsuario()]: " & Err.Number & ": " & Err.Description
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function updateForo(ByVal Buffer As String) As String
  Dim udtProps As ForoProps
  
  On Error GoTo errhandler
  
  udtProps = DeserializeForo(Buffer)
  updateForo = saveForo(udtProps, False)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "ForoPersist [updateForo()]: " & Err.Number & ": " & Err.Description & " (id_foro=" & udtProps.id_foro & ")"
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function putForo(ByVal Buffer As String) As String
  Dim udtProps As ForoProps
  
  On Error GoTo errhandler
  
  udtProps = DeserializeForo(Buffer)
  putForo = saveForo(udtProps, True)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "ForoPersist [putForo()]: " & Err.Number & ": " & Err.Description
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Private Function saveForo(ByRef udtProps As ForoProps, ByVal isNew As Boolean) As String
  Dim rs As New adodb.Recordset
  Dim strSQL As String

  On Error GoTo errhandler

  strSQL = "SELECT * FROM FORO WHERE ID_FORO = " & udtProps.id_foro
  rs.Open strSQL, DBCONNECTION, adOpenKeyset, adLockOptimistic
  With udtProps
    If isNew Then
      Dim ForoIDGen As ForoIDGenerator
      If mflgInMTS Then
        Set ForoIDGen = mobjContext.CreateInstance("WebForumsPersist.ForoIDGenerator")
      Else
        Set ForoIDGen = CreateObject("WebForumsPersist.ForoIDGenerator")
      End If
      rs.AddNew
      .id_foro = ForoIDGen.getNextID
      Set ForoIDGen = Nothing
      .fecha_creacion = Now
      rs!id_foro = .id_foro
    End If
    rs!nombre = Trim$(.nombre)
    rs!descripcion = Trim$(.descripcion)
    rs!es_activo = .es_activo
    rs!fecha_creacion = .fecha_creacion
    rs!fecha_ultima_visita = .fecha_ultima_visita
    rs!num_topicos = .num_topicos
    rs!num_visitas = .num_visitas
  End With
  rs.Update
  rs.Close
  Set rs = Nothing
  saveForo = SerializeForo(udtProps)
  Exit Function

errhandler:
  Set rs = Nothing
  Err.Raise Err.Number
End Function

Private Function removeForumPath(ByVal id_foro As Long) As Boolean
  Dim objFSO As Scripting.FileSystemObject
  Dim winpath As String
  
  On Error GoTo errhandler
  
  winpath = TranslateToWinPath(ATTACHMENTPATH & id_foro)
  Set objFSO = CreateObject("Scripting.FileSystemObject")
  If objFSO.FolderExists(winpath) Then objFSO.DeleteFolder winpath, True
  removeForumPath = True
  Set objFSO = Nothing
  Exit Function
  
errhandler:
  Set objFSO = Nothing
  removeForumPath = False
End Function

Public Sub removeForo(ByVal id_foro As Long)
  Dim cn As adodb.Connection
  Dim strSQL As String
  Dim TopicPerst As TopicoPersist
  Dim SuscPerst As SuscripcionPersist
  
  On Error GoTo errhandler
  
  If mflgInMTS Then
    Set TopicPerst = mobjContext.CreateInstance("WebForumsPersist.TopicoPersist")
  Else
    Set TopicPerst = CreateObject("WebForumsPersist.TopicoPersist")
  End If
  TopicPerst.removeAllTopicosForo id_foro
  Set TopicPerst = Nothing
  If mflgInMTS Then
    Set SuscPerst = mobjContext.CreateInstance("WebForumsPersist.SuscripcionPersist")
  Else
    Set SuscPerst = CreateObject("WebForumsPersist.SuscripcionPersist")
  End If
  SuscPerst.removeSuscripcionesForo id_foro
  Set SuscPerst = Nothing
  If removeForumPath(id_foro) Then
    Set cn = New adodb.Connection
    With cn
      .Open DBCONNECTION
      strSQL = "DELETE FORO WHERE ID_FORO = " & id_foro
      .Execute strSQL
      .Close
    End With
    Set cn = Nothing
  Else
    Err.Raise vbObjectError + 1001, , "No se pudo borrar el directorio fsico de los attachments"
  End If
  If mflgInMTS Then mobjContext.SetComplete
  Exit Sub
  
errhandler:
  App.LogEvent "ForoPersist [removeForo()]: " & Err.Number & ": " & Err.Description & " (id_foro=" & id_foro & ")"
  Set cn = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Sub

Public Sub visitaForo(ByVal id_foro As Long)
  Dim cm As New adodb.Command
  Dim strSQL As String
  
  On Error GoTo errhandler
  
  strSQL = "UPDATE FORO SET NUM_VISITAS = NUM_VISITAS + 1, FECHA_ULTIMA_VISITA = ? WHERE ID_FORO = ?"
  With cm
    .ActiveConnection = DBCONNECTION
    .CommandType = adCmdText
    .CommandText = strSQL
    .Parameters(0).Value = Now
    .Parameters(1).Value = id_foro
    .Execute
  End With
  Set cm = Nothing
  If mflgInMTS Then mobjContext.SetComplete
  Exit Sub
  
errhandler:
  App.LogEvent "ForoPersist [visitaForo()]: " & Err.Number & ": " & Err.Description & " (id_foro=" & id_foro & ")"
  Set cm = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Sub

Public Sub incrementNumTopicosForo(ByVal id_foro As Long, Optional ByVal increment As Long = 1)
  Dim cm As New adodb.Command
  Dim strSQL As String
  
  On Error GoTo errhandler
  
  strSQL = "Update FORO Set NUM_TOPICOS = NUM_TOPICOS + ? Where ID_FORO = ?"
  With cm
    .ActiveConnection = DBCONNECTION
    .CommandType = adCmdText
    .CommandText = strSQL
    .Parameters(0).Value = increment
    .Parameters(1).Value = id_foro
    .Execute
  End With
  Set cm = Nothing
  If mflgInMTS Then mobjContext.SetComplete
  Exit Sub
  
errhandler:
  App.LogEvent "ForoPersist [incrementNumTopicosForo()]: " & Err.Number & ": " & Err.Description & " (id_foro=" & id_foro & ")"
  Set cm = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Sub

Public Sub decrementNumTopicosForo(ByVal id_foro As Long, Optional ByVal decrement As Long = 1)
  Dim cm As New adodb.Command
  Dim strSQL As String
  
  On Error GoTo errhandler
  
  strSQL = "Update FORO Set NUM_TOPICOS = NUM_TOPICOS - ? Where ID_FORO = ?"
  With cm
    .ActiveConnection = DBCONNECTION
    .CommandType = adCmdText
    .CommandText = strSQL
    .Parameters(0).Value = decrement
    .Parameters(1).Value = id_foro
    .Execute
  End With
  Set cm = Nothing
  If mflgInMTS Then mobjContext.SetComplete
  Exit Sub
  
errhandler:
  App.LogEvent "ForoPersist [decrementNumTopicosForo()]: " & Err.Number & ": " & Err.Description & " (id_foro=" & id_foro & ")"
  Set cm = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Sub

Public Sub fixCounts()
  Dim cn As New adodb.Connection
  Dim cm As New adodb.Command
  Dim rs As New adodb.Recordset
  Dim strSQL As String
  
  On Error GoTo errhandler
  
  strSQL = "Select ID_FORO, COUNT(*) From TOPICO GROUP BY ID_FORO"
  With cn
    .ConnectionString = DBCONNECTION
    .CursorLocation = adUseClient
    .Open
  End With
  rs.Open strSQL, cn, adOpenForwardOnly, adLockReadOnly
  rs.ActiveConnection = Nothing
  strSQL = "UPDATE FORO SET NUM_TOPICOS = ? WHERE ID_FORO = ?"
  With cm
    .ActiveConnection = cn
    .CommandType = adCmdText
    .CommandText = strSQL
    While Not rs.EOF
      .Parameters(0).Value = rs.Fields(1)
      .Parameters(1).Value = rs.Fields(0)
      .Execute
      rs.MoveNext
    Wend
  End With
  cn.Close
  Set rs = Nothing
  Set cm = Nothing
  Set cn = Nothing
  If mflgInMTS Then mobjContext.SetComplete
  Exit Sub
  
errhandler:
  App.LogEvent "ForoPersist [fixCounts()]: " & Err.Number & ": " & Err.Description
  Set rs = Nothing
  Set cm = Nothing
  Set cn = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Sub

Private Function DeserializeForo(ByVal Buffer As String) As ForoProps
  Dim udtData As ForoData
  Dim PBag As PropertyBag
  Dim arrbyte_buff() As Byte
  
  arrbyte_buff = Buffer
  Set PBag = New PropertyBag
  With PBag
    .Contents = arrbyte_buff
    udtData.Buffer = .ReadProperty("fixedlength_state")
  End With
  Set PBag = Nothing
  LSet DeserializeForo = udtData
End Function

Private Function SerializeForo(ByRef udtProps As ForoProps) As String
  Dim udtData As ForoData
  Dim PBag As PropertyBag
  
  LSet udtData = udtProps
  Set PBag = New PropertyBag
  With PBag
    .WriteProperty "fixedlength_state", udtData.Buffer
    SerializeForo = .Contents
  End With
  Set PBag = Nothing
End Function

Private Sub ObjectControl_Activate()
  Set mobjContext = GetObjectContext
  mflgInMTS = True
End Sub

Private Function ObjectControl_CanBePooled() As Boolean
  ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
  Set mobjContext = Nothing
End Sub

