VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "MensajePersist"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements ObjectControl

Private mobjContext As ObjectContext
Private mflgInMTS As Boolean

Public Function getMensaje(ByVal id_mensaje As Long) As String
Dim rs As New adodb.Recordset
Dim strSQL As String
Dim udtProps As MensajeProps
Dim contenido As String

  On Error GoTo errhandler
  
  strSQL = "SELECT * FROM MENSAJE WHERE ID_MENSAJE = " & id_mensaje
  rs.Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
  With udtProps
    .id_mensaje = id_mensaje
    .id_topico = rs!id_topico
    .id_mensaje_original = Nvl(rs!id_mensaje_original, 0)
    .asunto = rs!asunto & ""
    contenido = rs!contenido & ""
    .prioridad = Nvl(rs!prioridad, 0)
    .fecha_envio = rs!fecha_envio
    .envio_anonimo = rs!envio_anonimo & ""
    .estatus = rs!estatus & ""
    .incluir_original = rs!incluir_original & ""
    .id_foro = rs!id_foro
    .id_usuario = rs!id_usuario
    .id_emoticon = Nvl(rs!id_emoticon, 0)
    .nombre_autor = rs!nombre_autor & ""
  End With
  rs.Close
  Set rs = Nothing
  getMensaje = SerializeMensaje(udtProps, contenido)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "MensajePersist [getMensaje()]: " & Err.Number & ": " & Err.Description & " (id_mensaje=" & id_mensaje & ")"
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function updateMensaje(ByVal Buffer As String) As String
  Dim udtProps As MensajeProps
  Dim contenido As String
  
  On Error GoTo errhandler
  
  DeserializeMensaje Buffer, udtProps, contenido
  updateMensaje = saveMensaje(udtProps, contenido, False)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "MensajePersist [updateMensaje()]: " & Err.Number & ": " & Err.Description & " (id_mensaje=" & udtProps.id_mensaje & ")"
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function putMensaje(ByVal Buffer As String) As String
  Dim udtProps As MensajeProps
  Dim contenido As String
  
  On Error GoTo errhandler
  
  DeserializeMensaje Buffer, udtProps, contenido
  putMensaje = saveMensaje(udtProps, contenido, True)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "MensajePersist [putMensaje()]: " & Err.Number & ": " & Err.Description
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Private Function saveMensaje(ByRef udtProps As MensajeProps, ByVal contenido As String, ByVal isNew As Boolean) As String
Dim rs As New adodb.Recordset
Dim strSQL As String

  On Error GoTo errhandler

  strSQL = "SELECT * FROM MENSAJE WHERE ID_MENSAJE = " & udtProps.id_mensaje
  rs.Open strSQL, DBCONNECTION, adOpenKeyset, adLockOptimistic
  With udtProps
    If isNew Then
      Dim MenaIDGen As MensajeIDGenerator
      If mflgInMTS Then
        Set MenaIDGen = mobjContext.CreateInstance("WebForumsPersist.MensajeIDGenerator")
      Else
        Set MenaIDGen = CreateObject("WebForumsPersist.MensajeIDGenerator")
      End If
      rs.AddNew
      .id_mensaje = MenaIDGen.getNextID
      Set MenaIDGen = Nothing
      .fecha_envio = Now
    End If
    rs!id_mensaje = .id_mensaje
    rs!id_topico = .id_topico
    If .id_mensaje_original > 0 Then
      rs!id_mensaje_original = .id_mensaje_original
    Else
      rs!id_mensaje_original = Null
    End If
    rs!asunto = Trim$(.asunto)
    rs!contenido = contenido
    rs!prioridad = .prioridad
    rs!fecha_envio = .fecha_envio
    rs!envio_anonimo = .envio_anonimo
    rs!estatus = .estatus
    rs!incluir_original = .incluir_original
    rs!id_foro = .id_foro
    rs!id_usuario = .id_usuario
    If .id_emoticon > 0 Then
      rs!id_emoticon = .id_emoticon
    Else
      rs!id_emoticon = Null
    End If
    rs!nombre_autor = Trim$(.nombre_autor)
  End With
  rs.Update
  rs.Close
  Set rs = Nothing
  saveMensaje = SerializeMensaje(udtProps, contenido)
  Exit Function

errhandler:
  Set rs = Nothing
  Err.Raise Err.Number
End Function

Public Sub updateContenidoMensaje(ByVal id_mensaje As Long, ByVal contenido As String)
  Dim cn As New adodb.Connection
  Dim cm As New adodb.Command
  Dim strSQL As String
  
  On Error GoTo errhandler
  
  strSQL = "UPDATE MENSAJE SET CONTENIDO = ? WHERE ID_MENSAJE = ?"
  With cm
    .ActiveConnection = DBCONNECTION
    .CommandType = adCmdText
    .CommandText = strSQL
    .Parameters(0).Value = contenido
    .Parameters(1).Value = id_mensaje
    .Execute
  End With
  Set cm = Nothing
  If mflgInMTS Then mobjContext.SetComplete
  Exit Sub
  
errhandler:
  App.LogEvent "MensajePersist [updateContenidoMensaje()]: " & Err.Number & ": " & Err.Description & " (id_mensaje=" & id_mensaje & ")"
  Set cm = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Sub

Public Function removeMensaje(ByVal id_mensaje As Long, Optional ByVal bTerminateTrans As Boolean = True) As Long
Dim cn As adodb.Connection
Dim strSQL As String
Dim total As Long
  
  On Error GoTo errhandler
  
  Set cn = New adodb.Connection
  With cn
    .Open DBCONNECTION
    strSQL = "DELETE MENSAJE WHERE ID_MENSAJE = " & id_mensaje
    .Execute (strSQL), total
    .Close
  End With
  Set cn = Nothing
  removeMensaje = total
  If mflgInMTS And bTerminateTrans Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "MensajePersist [removeMensaje()]: " & Err.Number & ": " & Err.Description & " (id_mensaje=" & id_mensaje & ")"
  Set cn = Nothing
  If mflgInMTS And bTerminateTrans Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function removeMensajeCascade(ByVal id_mensaje As Long, Optional ByVal bTerminateTrans As Boolean = True) As Integer
  Dim rs As adodb.Recordset
  Dim strSQL As String
  Dim recsAfected As Integer
  Dim arrChilds As Variant
  Dim item As Variant
  Dim AttPerst As AttachmentPersist
  
  On Error GoTo errhandler
  
  recsAfected = 0
  strSQL = "Select ID_MENSAJE From MENSAJE Where ID_MENSAJE_ORIGINAL = " & id_mensaje
  Set rs = New adodb.Recordset
  With rs
    .Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
    If Not .EOF Then
      arrChilds = rs.GetRows
    End If
    .Close
  End With
  Set rs = Nothing
  If IsArray(arrChilds) Then
    For Each item In arrChilds
      recsAfected = recsAfected + removeMensajeCascade(item, False)
    Next item
  End If
  If mflgInMTS Then
    Set AttPerst = mobjContext.CreateInstance("WebForumsPersist.AttachmentPersist")
  Else
    Set AttPerst = CreateObject("WebForumsPersist.AttachmentPersist")
  End If
  If AttPerst.removeAttachment(id_mensaje) Then
    Set AttPerst = Nothing
    removeMensajeCascade = recsAfected + removeMensaje(id_mensaje, False)
  Else
    Set AttPerst = Nothing
    Err.Raise vbObjectError + 1001, , "Failed to delete attachment"
  End If
  If mflgInMTS And bTerminateTrans Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "MensajePersist [removeMensajeCascade()]: " & Err.Number & ": " & Err.Description & " (id_mensaje=" & id_mensaje & ")"
  Set AttPerst = Nothing
  Set rs = Nothing
  removeMensajeCascade = recsAfected
  If mflgInMTS And bTerminateTrans Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Sub removeAllMensajesTopico(ByVal id_topico As Long)
  Dim rs As adodb.Recordset
  Dim strSQL As String
  Dim arrChilds As Variant
  Dim item As Variant
  
  On Error GoTo errhandler
  
  strSQL = "Select ID_MENSAJE From MENSAJE Where ID_TOPICO = " & id_topico & " Order By ID_MENSAJE Desc"
  Set rs = New adodb.Recordset
  With rs
    .Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
    If Not .EOF Then
      arrChilds = rs.GetRows
    End If
    .Close
  End With
  Set rs = Nothing
  If IsArray(arrChilds) Then
    For Each item In arrChilds
      removeMensajeCascade item, False
    Next item
  End If
  If mflgInMTS Then mobjContext.SetComplete
  Exit Sub
  
errhandler:
  App.LogEvent "MensajePersist [removeAllMensajesTopico()]: " & Err.Number & ": " & Err.Description & " (id_topico =" & id_topico & ")"
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Sub

Private Sub DeserializeMensaje(ByVal Buffer As String, ByRef udtProps As MensajeProps, ByRef contenido As String)
  Dim udtData As MensajeData
  Dim PBag As PropertyBag
  Dim arrbyte_buff() As Byte
  
  arrbyte_buff = Buffer
  Set PBag = New PropertyBag
  With PBag
    .Contents = arrbyte_buff
    udtData.Buffer = .ReadProperty("fixedlength_state")
    contenido = .ReadProperty("contenido_mensaje")
  End With
  Set PBag = Nothing
  LSet udtProps = udtData
End Sub

Private Function SerializeMensaje(ByRef udtProps As MensajeProps, ByVal contenido As String) As String
  Dim udtData As MensajeData
  Dim PBag As PropertyBag
  
  LSet udtData = udtProps
  Set PBag = New PropertyBag
  With PBag
    .WriteProperty "fixedlength_state", udtData.Buffer
    .WriteProperty "contenido_mensaje", contenido
    SerializeMensaje = .Contents
  End With
  Set PBag = Nothing
End Function

Private Sub ObjectControl_Activate()
  Set mobjContext = GetObjectContext
  mflgInMTS = True
End Sub

Private Function ObjectControl_CanBePooled() As Boolean
  ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
  Set mobjContext = Nothing
End Sub



