VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "PerfilUsuarioPersist"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements ObjectControl

Private mobjContext As ObjectContext
Private mflgInMTS As Boolean

Public Function getPerfilUsuario(ByVal id_usuario As Long) As String
Dim rs As New adodb.Recordset
Dim strSQL As String
Dim udtProps As PerfilUsuarioProps

  On Error GoTo errhandler
  
  strSQL = "SELECT * FROM PERFILUSUARIO WHERE ID_USUARIO = " & id_usuario
  rs.Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
  With udtProps
    .id_usuario = id_usuario
    .titulo = rs!titulo & ""
    .compania = rs!compania & ""
    .direccion1 = rs!direccion1 & ""
    .direccion2 = rs!direccion2 & ""
    .ciudad = rs!ciudad & ""
    .estado = rs!estado & ""
    .cp = rs!cp & ""
    .telefono = rs!telefono & ""
    .uri = rs!uri & ""
  End With
  rs.Close
  Set rs = Nothing
  getPerfilUsuario = SerializePerfilUsuario(udtProps)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "PerfilUsuarioPersist [getPerfilUsuario()]: " & Err.Number & ": " & Err.Description & " (id_usuario=" & id_usuario & ")"
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function updatePerfilUsuario(ByVal Buffer As String) As String
  Dim udtProps As PerfilUsuarioProps
  
  On Error GoTo errhandler
  
  udtProps = DeserializePerfilUsuario(Buffer)
  updatePerfilUsuario = savePerfilUsuario(udtProps, False)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "PerfilUsuarioPersist [updatePerfilUsuario()]: " & Err.Number & ": " & Err.Description & " (id_usuario=" & udtProps.id_usuario & ")"
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function putPerfilUsuario(ByVal Buffer As String) As String
  Dim udtProps As PerfilUsuarioProps
  
  On Error GoTo errhandler
  
  udtProps = DeserializePerfilUsuario(Buffer)
  putPerfilUsuario = savePerfilUsuario(udtProps, True)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "PerfilUsuarioPersist [putPerfilUsuario()]: " & Err.Number & ": " & Err.Description
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Private Function savePerfilUsuario(ByRef udtProps As PerfilUsuarioProps, ByVal isNew As Boolean) As String
Dim rs As New adodb.Recordset
Dim strSQL As String

  On Error GoTo errhandler

  strSQL = "SELECT * FROM PERFILUSUARIO WHERE ID_USUARIO = " & udtProps.id_usuario
  rs.Open strSQL, DBCONNECTION, adOpenKeyset, adLockOptimistic
  With udtProps
    If isNew Then
      rs.AddNew
      rs!id_usuario = .id_usuario
    End If
    rs!titulo = Trim$(.titulo)
    rs!compania = Trim$(.compania)
    rs!direccion1 = Trim$(.direccion1)
    rs!direccion2 = Trim$(.direccion2)
    rs!ciudad = Trim$(.ciudad)
    rs!estado = Trim$(.estado)
    rs!cp = Trim$(.cp)
    rs!telefono = Trim$(.telefono)
    rs!uri = Trim$(.uri)
  End With
  rs.Update
  rs.Close
  Set rs = Nothing
  savePerfilUsuario = SerializePerfilUsuario(udtProps)
  Exit Function

errhandler:
  Set rs = Nothing
  Err.Raise Err.Number
End Function

Public Sub removePerfilUsuario(ByVal id_usuario As Long)
Dim cn As adodb.Connection
Dim strSQL As String
  
  On Error GoTo errhandler
  
  Set cn = New adodb.Connection
  With cn
    .Open DBCONNECTION
    strSQL = "DELETE PERFILUSUARIO WHERE ID_USUARIO = " & id_usuario
    .Execute strSQL
    .Close
  End With
  cn.Close
  Set cn = Nothing
  If mflgInMTS Then mobjContext.SetComplete
  Exit Sub
  
errhandler:
  App.LogEvent "PerfilUsuarioPersist [removePerfilUsuario()]: " & Err.Number & ": " & Err.Description & " (id_usuario=" & id_usuario & ")"
  Set cn = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Sub

Private Function DeserializePerfilUsuario(ByVal Buffer As String) As PerfilUsuarioProps
  Dim udtData As UsuarioData
  Dim PBag As PropertyBag
  Dim arrbyte_buff() As Byte
  
  arrbyte_buff = Buffer
  Set PBag = New PropertyBag
  With PBag
    .Contents = arrbyte_buff
    udtData.Buffer = .ReadProperty("fixedlength_state")
  End With
  Set PBag = Nothing
  LSet DeserializePerfilUsuario = udtData
End Function

Private Function SerializePerfilUsuario(ByRef udtProps As PerfilUsuarioProps) As String
  Dim udtData As UsuarioData
  Dim PBag As PropertyBag
  
  LSet udtData = udtProps
  Set PBag = New PropertyBag
  With PBag
    .WriteProperty "fixedlength_state", udtData.Buffer
    SerializePerfilUsuario = .Contents
  End With
  Set PBag = Nothing
End Function

Private Sub ObjectControl_Activate()
  Set mobjContext = GetObjectContext
  mflgInMTS = True
End Sub

Private Function ObjectControl_CanBePooled() As Boolean
  ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
  Set mobjContext = Nothing
End Sub

