VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SharedLong"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private mShareName As String

Private mlngMappingHandle As Long
Private mlngMappingAddress As Long
Private mlngMutexHandle As Long
Private mlngSemaphoreHandle As Long

Private Const FILE_MAP_WRITE = &H2
Private Const PAGE_READWRITE = 4&
Private Const ERROR_ALREADY_EXISTS = 183&

Private Const WAIT_FAILED = -1&
Private Const WAIT_OBJECT_0 = 0&
Private Const WAIT_ABANDONED = &H80&
Private Const WAIT_ABANDONED_0 = &H80&
Private Const WAIT_TIMEOUT = &H102&
Private Const INFINITE = -1&

Private Declare Function CreateFileMapping Lib "kernel32" Alias "CreateFileMappingA" _
  (ByVal hFile As Long, ByVal lpFileMappingAttributes As Long, ByVal _
  flProtect As Long, ByVal dwMaximumSizeHigh As Long, ByVal dwMaximumSizeLow _
  As Long, ByVal lpName As String) As Long

Private Declare Function UnmapViewOfFile Lib "kernel32" (ByVal lpBaseAddress _
  As Long) As Long

Private Declare Function MapViewOfFile Lib "kernel32" (ByVal _
  hFileMappingObject As Long, ByVal dwDesiredAccess As Long, ByVal _
  dwFileOffsetHigh As Long, ByVal dwFileOffsetLow As Long, ByVal _
  dwNumberOfBytesToMap As Long) As Long

Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) _
  As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
  (Destination As Any, Source As Any, ByVal Length As Long)

Private Declare Function CreateMutex Lib "kernel32" Alias "CreateMutexA" _
  (ByVal lpMutexAttributes As Long, ByVal bInitialOwner As Long, _
  ByVal lpName As String) As Long

Private Declare Function ReleaseMutex Lib "kernel32" (ByVal hMutex As Long) _
  As Long

Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal _
  hHandle As Long, ByVal dwMilliseconds As Long) As Long
  
Public Property Let value(ByVal vData As Long)
  
  Dim retval As Long

  If Len(mShareName) = 0 Then Err.Raise 445

  'Wait for mutex
  Do
    retval = WaitForSingleObject(mlngMutexHandle, 5000)
  Loop Until retval = WAIT_OBJECT_0
  
  CopyMemory ByVal mlngMappingAddress, vData, 4

  'Now relase it
  ReleaseMutex mlngMutexHandle
End Property

Public Property Get value() As Long
Attribute value.VB_UserMemId = 0

  Dim retval As Long

  If Len(mShareName) = 0 Then Err.Raise 445

  'Wait for mutex
  Do
    retval = WaitForSingleObject(mlngMutexHandle, 5000)
  Loop Until retval = WAIT_OBJECT_0
  
  CopyMemory retval, ByVal mlngMappingAddress, 4
  value = retval
End Property

Public Sub Initialize(Name As String)
  Dim lngMapErr As Long
  
  mShareName = Name
  mlngMappingHandle = CreateFileMapping(-1, 0, PAGE_READWRITE, 0, _
    4, mShareName & ".map")
  If mlngMappingHandle = 0 Then Exit Sub
  lngMapErr = Err.LastDllError
  
  mlngMappingAddress = MapViewOfFile(mlngMappingHandle, FILE_MAP_WRITE, 0, 0, 0)
  If mlngMappingAddress = 0 Then
    CloseHandle mlngMappingHandle
    Exit Sub
  End If
  If Not lngMapErr = ERROR_ALREADY_EXISTS Then _
    CopyMemory ByVal mlngMappingAddress, 0, 4

  mlngMutexHandle = CreateMutex(0, False, mShareName & ".mtx")
  If mlngMutexHandle = 0 Then
    UnmapViewOfFile mlngMappingAddress
    CloseHandle mlngMappingHandle
    Exit Sub
  End If
End Sub

Private Sub Class_Terminate()
  UnmapViewOfFile mlngMappingAddress
  CloseHandle mlngMappingHandle
  CloseHandle mlngMutexHandle
End Sub
