VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "SuscripcionPersist"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements ObjectControl

Private mobjContext As ObjectContext
Private mflgInMTS As Boolean

Public Function getSuscripcion(ByVal id_foro As Long, ByVal id_usuario As Long) As String
  Dim rs As adodb.Recordset
  Dim strSQL As String
  Dim udtProps As SuscripcionProps

  On Error GoTo errhandler
  
  strSQL = "SELECT * FROM SUSCRIPCION WHERE ID_USUARIO = " & id_usuario & " AND ID_FORO = " & id_foro
  Set rs = New adodb.Recordset
  With rs
    .Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
    If .EOF Then
      .Close
      Err.Raise vbObjectError + 1001, , "No se encontro el Registro Correspondiente"
    Else
      udtProps.id_usuario = id_usuario
      udtProps.id_foro = id_foro
      udtProps.estatus = .Fields("estatus").Value & ""
      udtProps.email_actualizaciones = .Fields("email_actualizaciones").Value & ""
      udtProps.email_nuevos = .Fields("email_nuevos").Value & ""
      udtProps.email_anuncios = .Fields("email_anuncios").Value & ""
      udtProps.tipo = .Fields("tipo").Value & ""
      udtProps.fecha_ultima_visita = .Fields("fecha_ultima_visita").Value
      udtProps.enviar_mensajes = .Fields("enviar_mensajes").Value & ""
      .Close
    End If
  End With
  Set rs = Nothing
  getSuscripcion = SerializeSuscripcion(udtProps)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "SuscripcionPersist [getSuscripcion()]: " & Err.Number & ": " & Err.Description & " (id_usuario=" & id_usuario & ", id_foro = " & id_foro & ")"
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function updateSuscripcion(ByVal Buffer As String) As String
  Dim udtProps As SuscripcionProps
  
  On Error GoTo errhandler
  
  udtProps = DeserializeSuscripcion(Buffer)
  updateSuscripcion = saveSuscripcion(udtProps, False)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "SuscripcionPersist [updateSuscripcion()]: " & Err.Number & ": " & Err.Description & " (id_usuario=" & udtProps.id_usuario & ", id_foro = " & udtProps.id_foro & ")"
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function putSuscripcion(ByVal Buffer As String) As String
  Dim udtProps As SuscripcionProps
  
  On Error GoTo errhandler
  
  udtProps = DeserializeSuscripcion(Buffer)
  putSuscripcion = saveSuscripcion(udtProps, True)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "SuscripcionPersist [putSuscripcion()]: " & Err.Number & ": " & Err.Description & " (id_usuario=" & udtProps.id_usuario & ", id_foro = " & udtProps.id_foro & ")"
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Private Function saveSuscripcion(ByRef udtProps As SuscripcionProps, ByVal isNew As Boolean) As String
  Dim rs As New adodb.Recordset
  Dim strSQL As String

  On Error GoTo errhandler

  strSQL = "SELECT * FROM SUSCRIPCION WHERE ID_USUARIO = " & _
    udtProps.id_usuario & " AND ID_FORO = " & udtProps.id_foro
  rs.Open strSQL, DBCONNECTION, adOpenKeyset, adLockOptimistic
  With udtProps
    If isNew Then
      rs.AddNew
      rs!id_usuario = .id_usuario
      rs!id_foro = .id_foro
    End If
    rs!estatus = .estatus
    rs!email_actualizaciones = .email_actualizaciones
    rs!email_nuevos = .email_nuevos
    rs!email_anuncios = .email_anuncios
    rs!tipo = .tipo
    rs!fecha_ultima_visita = .fecha_ultima_visita
    rs!enviar_mensajes = .enviar_mensajes
  End With
  rs.Update
  rs.Close
  Set rs = Nothing
  saveSuscripcion = SerializeSuscripcion(udtProps)
  Exit Function

errhandler:
  Set rs = Nothing
  Err.Raise Err.Number
End Function

Public Sub removeSuscripcion(ByVal id_foro As Long, ByVal id_usuario As Long)
  Dim cn As adodb.Connection
  Dim strSQL As String
  
  On Error GoTo errhandler
  
  Set cn = New adodb.Connection
  With cn
    .Open DBCONNECTION
    strSQL = "DELETE SUSCRIPCION WHERE ID_USUARIO = " & id_usuario & " AND ID_FORO = " & id_foro
    .Execute strSQL
    .Close
  End With
  cn.Close
  Set cn = Nothing
  If mflgInMTS Then mobjContext.SetComplete
  Exit Sub
  
errhandler:
  App.LogEvent "SuscripcionPersist [removeSuscripcion()]: " & Err.Number & ": " & Err.Description & " (id_usuario=" & id_usuario & ", id_foro = " & id_foro & ")"
  Set cn = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Sub

Public Sub removeSuscripcionesForo(ByVal id_foro As Long)
  Dim cn As adodb.Connection
  Dim strSQL As String
  
  On Error GoTo errhandler
  
  Set cn = New adodb.Connection
  With cn
    .Open DBCONNECTION
    strSQL = "DELETE SUSCRIPCION WHERE ID_FORO = " & id_foro
    .Execute strSQL
    .Close
  End With
  Set cn = Nothing
  If mflgInMTS Then mobjContext.SetComplete
  Exit Sub
  
errhandler:
  App.LogEvent "SuscripcionPersist [removeSuscripcionesForo()]: " & Err.Number & ": " & Err.Description & " (id_foro = " & id_foro & ")"
  Set cn = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Sub

Public Sub visitaSuscripcion(ByVal id_foro As Long, ByVal id_usuario As Long)
  Dim cm As New adodb.Command
  Dim strSQL As String
  
  On Error GoTo errhandler
  
  strSQL = "UPDATE SUSCRIPCION SET FECHA_ULTIMA_VISITA = ? WHERE ID_FORO = ? AND ID_USUARIO = ?"
  With cm
    .ActiveConnection = DBCONNECTION
    .CommandType = adCmdText
    .CommandText = strSQL
    .Parameters(0).Value = Now
    .Parameters(1).Value = id_foro
    .Parameters(2).Value = id_usuario
    .Execute
  End With
  Set cm = Nothing
  If mflgInMTS Then mobjContext.SetComplete
  Exit Sub
  
errhandler:
  App.LogEvent "SuscripcionPersist [visitaSuscripcion()]: " & Err.Number & ": " & Err.Description & " (id_usuario=" & id_usuario & ", id_foro = " & id_foro & ")"
  Set cm = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Sub

Public Sub updateTipoSuscripcion(ByVal tipo As String, ByVal id_foro As Long, ByVal id_usuario As Long)
  Dim cm As New adodb.Command
  Dim strSQL As String
  
  On Error GoTo errhandler
  
  strSQL = "UPDATE SUSCRIPCION SET TIPO = ? WHERE ID_FORO = ? AND ID_USUARIO = ?"
  With cm
    .ActiveConnection = DBCONNECTION
    .CommandType = adCmdText
    .CommandText = strSQL
    .Parameters(0).Value = tipo
    .Parameters(1).Value = id_foro
    .Parameters(2).Value = id_usuario
    .Execute
  End With
  Set cm = Nothing
  If mflgInMTS Then mobjContext.SetComplete
  Exit Sub
  
errhandler:
  App.LogEvent "SuscripcionPersist [updateTipoSuscripcion()]: " & Err.Number & ": " & Err.Description & " (id_usuario=" & id_usuario & ", id_foro = " & id_foro & ")"
  Set cm = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Sub

Private Function DeserializeSuscripcion(ByVal Buffer As String) As SuscripcionProps
  Dim udtData As UsuarioData
  Dim PBag As PropertyBag
  Dim arrbyte_buff() As Byte
  
  arrbyte_buff = Buffer
  Set PBag = New PropertyBag
  With PBag
    .Contents = arrbyte_buff
    udtData.Buffer = .ReadProperty("fixedlength_state")
  End With
  Set PBag = Nothing
  LSet DeserializeSuscripcion = udtData
End Function

Private Function SerializeSuscripcion(ByRef udtProps As SuscripcionProps) As String
  Dim udtData As UsuarioData
  Dim PBag As PropertyBag
  
  LSet udtData = udtProps
  Set PBag = New PropertyBag
  With PBag
    .WriteProperty "fixedlength_state", udtData.Buffer
    SerializeSuscripcion = .Contents
  End With
  Set PBag = Nothing
End Function

Private Sub ObjectControl_Activate()
  Set mobjContext = GetObjectContext
  mflgInMTS = True
End Sub

Private Function ObjectControl_CanBePooled() As Boolean
  ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
  Set mobjContext = Nothing
End Sub
