VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "TopicoPersist"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements ObjectControl
Private mobjContext As ObjectContext
Private mflgInMTS As Boolean

Public Function getTopico(ByVal id_topico As Long) As String
Dim rs As New adodb.Recordset
Dim strSQL As String
Dim udtProps As TopicoProps

  On Error GoTo errhandler
  
  strSQL = "SELECT * FROM TOPICO WHERE ID_TOPICO = " & id_topico
  rs.Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
  With udtProps
    .id_topico = id_topico
    .id_foro = rs!id_foro
    .id_usuario = rs!id_usuario
    .nombre = rs!nombre & ""
    .num_respuestas = rs!num_respuestas
    .fecha_creacion = rs!fecha_creacion
    .fecha_ultimo_mensaje = Nvl(rs!fecha_ultimo_mensaje, 0)
  End With
  rs.Close
  Set rs = Nothing
  getTopico = SerializeTopico(udtProps)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "TopicoPersist [getTopico()]: " & Err.Number & ": " & Err.Description & " (id_topico=" & id_topico & ")"
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function updateTopico(ByVal Buffer As String) As String
  Dim udtProps As TopicoProps
  
  On Error GoTo errhandler
  
  udtProps = DeserializeTopico(Buffer)
  updateTopico = saveTopico(udtProps, False)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "TopicoPersist [updateTopico()]: " & Err.Number & ": " & Err.Description & " (id_topico=" & udtProps.id_topico & ")"
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function putTopico(ByVal Buffer As String) As String
  Dim udtProps As TopicoProps
  
  On Error GoTo errhandler
  
  udtProps = DeserializeTopico(Buffer)
  putTopico = saveTopico(udtProps, True)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "TopicoPersist [putTopico()]: " & Err.Number & ": " & Err.Description
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Private Function saveTopico(ByRef udtProps As TopicoProps, ByVal isNew As Boolean) As String
  Dim rs As New adodb.Recordset
  Dim strSQL As String

  On Error GoTo errhandler

  strSQL = "SELECT * FROM TOPICO WHERE ID_TOPICO = " & udtProps.id_topico
  rs.Open strSQL, DBCONNECTION, adOpenKeyset, adLockOptimistic
  With udtProps
    If isNew Then
      Dim TopicoIDGen As TopicoIDGenerator
      If mflgInMTS Then
        Set TopicoIDGen = mobjContext.CreateInstance("WebForumsPersist.TopicoIDGenerator")
      Else
        Set TopicoIDGen = CreateObject("WebForumsPersist.TopicoIDGenerator")
      End If
      rs.AddNew
      .id_topico = TopicoIDGen.getNextID
      Set TopicoIDGen = Nothing
      .fecha_creacion = Now
      rs!id_topico = .id_topico
    End If
    rs!id_foro = .id_foro
    rs!id_usuario = .id_usuario
    rs!nombre = Trim$(.nombre)
    rs!num_respuestas = .num_respuestas
    rs!fecha_creacion = .fecha_creacion
    If .fecha_ultimo_mensaje > 0 Then
      rs!fecha_ultimo_mensaje = .fecha_ultimo_mensaje
    Else
      rs!fecha_ultimo_mensaje = 0
    End If
  End With
  rs.Update
  rs.Close
  Set rs = Nothing
  saveTopico = SerializeTopico(udtProps)
  Exit Function

errhandler:
  Set rs = Nothing
  Err.Raise Err.Number
End Function

Private Function removeTopicPath(ByVal id_foro As Long, ByVal id_topico As Long) As Boolean
  Dim objFSO As Scripting.FileSystemObject
  Dim winpath As String
  
  On Error GoTo errhandler
  
  winpath = TranslateToWinPath(ATTACHMENTPATH & id_foro & "\" & id_topico)
  Set objFSO = CreateObject("Scripting.FileSystemObject")
  If objFSO.FolderExists(winpath) Then objFSO.DeleteFolder winpath, True
  removeTopicPath = True
  Set objFSO = Nothing
  Exit Function
  
errhandler:
  Set objFSO = Nothing
  removeTopicPath = False
End Function

Public Sub removeTopico(ByVal id_topico As Long, Optional ByVal bTerminateTrans As Boolean = True)
  Dim rs As adodb.Recordset
  Dim strSQL As String

  On Error GoTo errhandler

  strSQL = "SELECT * FROM TOPICO WHERE ID_TOPICO = " & id_topico
  Set rs = New adodb.Recordset
  rs.Open strSQL, DBCONNECTION, adOpenKeyset, adLockOptimistic
  With rs
    If Not .EOF Then
      If removeTopicPath(.Fields("id_foro"), id_topico) Then
        .Delete adAffectCurrent
        .Update
      Else
        Err.Raise vbObjectError + 1001, , "No se pudo borrar el directorio fsico de los attachments"
      End If
    End If
    .Close
  End With
  Set rs = Nothing
  If mflgInMTS And bTerminateTrans Then mobjContext.SetComplete
  Exit Sub
  
errhandler:
  App.LogEvent "TopicoPersist [removeTopico()]: " & Err.Number & ": " & Err.Description & " (id_topico=" & id_topico & ")"
  Set rs = Nothing
  If mflgInMTS And bTerminateTrans Then mobjContext.SetAbort
  Err.Raise Err.Number
End Sub

Public Sub removeTopicoCascade(ByVal id_topico As Long, Optional ByVal bTerminateTrans As Boolean = True)
  Dim MensPerst As MensajePersist
  If mflgInMTS Then
    Set MensPerst = mobjContext.CreateInstance("WebForumsPersist.MensajePersist")
  Else
    Set MensPerst = CreateObject("WebForumsPersist.MensajePersist")
  End If
  MensPerst.removeAllMensajesTopico id_topico
  Set MensPerst = Nothing
  removeTopico id_topico, bTerminateTrans
End Sub

Public Sub removeAllTopicosForo(ByVal id_foro As Long)
  Dim rs As adodb.Recordset
  Dim strSQL As String
  Dim arrChilds As Variant
  Dim item As Variant
  
  On Error GoTo errhandler
  
  strSQL = "Select ID_TOPICO From TOPICO Where ID_FORO = " & id_foro & " Order By ID_TOPICO"
  Set rs = New adodb.Recordset
  With rs
    .Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
    If Not .EOF Then
      arrChilds = rs.GetRows
    End If
    .Close
  End With
  Set rs = Nothing
  If IsArray(arrChilds) Then
    For Each item In arrChilds
      removeTopicoCascade item, False
    Next item
  End If
  If mflgInMTS Then mobjContext.SetComplete
  Exit Sub
  
errhandler:
  App.LogEvent "TopicoPersist [removeAllTopicosTopico()]: " & Err.Number & ": " & Err.Description & " (id_foro =" & id_foro & ")"
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Sub

Public Function getNextTopico(ByVal id_foro As Long, ByVal id_topico As Long) As Long
  Dim rs As adodb.Recordset
  Dim strSQL As String

  On Error GoTo errhandler
  
  strSQL = "Select ID_TOPICO From TOPICO Where ID_FORO = " & id_foro & " And ID_TOPICO > " & id_topico & " Order By ID_TOPICO"
  Set rs = New adodb.Recordset
  With rs
    .Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
    If .EOF Then
      .Close
      Err.Raise vbObjectError + 1001, , "No more topics"
    Else
      getNextTopico = .Fields("id_topico").Value
      .Close
    End If
  End With
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  If Err.Number <> vbObjectError + 1001 Then App.LogEvent "TopicoPersist [getNextTopico()]: " & Err.Number & ": " & Err.Description & " (id_topico=" & id_topico & ")"
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function getPrevTopico(ByVal id_foro As Long, ByVal id_topico As Long) As Long
  Dim rs As adodb.Recordset
  Dim strSQL As String

  On Error GoTo errhandler
  
  strSQL = "Select ID_TOPICO From TOPICO Where ID_FORO = " & id_foro & " And ID_TOPICO < " & id_topico & " Order By ID_TOPICO DESC"
  Set rs = New adodb.Recordset
  With rs
    .Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
    If .EOF Then
      .Close
      Err.Raise vbObjectError + 1001, , "No more topics"
    Else
      getPrevTopico = .Fields("id_topico").Value
      .Close
    End If
  End With
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  If Err.Number <> vbObjectError + 1001 Then App.LogEvent "TopicoPersist [getPrevTopico()]: " & Err.Number & ": " & Err.Description & " (id_topico=" & id_topico & ")"
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Sub incrementNumMensajesTopico(ByVal id_topico As Long, Optional ByVal increment As Long = 1)
  Dim cm As New adodb.Command
  Dim strSQL As String
  
  On Error GoTo errhandler
  
  strSQL = "Update TOPICO Set NUM_RESPUESTAS = NUM_RESPUESTAS + ? Where ID_TOPICO = ?"
  With cm
    .ActiveConnection = DBCONNECTION
    .CommandType = adCmdText
    .CommandText = strSQL
    .Parameters(0).Value = increment
    .Parameters(1).Value = id_topico
    .Execute
  End With
  Set cm = Nothing
  If mflgInMTS Then mobjContext.SetComplete
  Exit Sub
  
errhandler:
  App.LogEvent "TopicoPersist [incrementNumMensajesTopico()]: " & Err.Number & ": " & Err.Description & " (id_topico=" & id_topico & ")"
  Set cm = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Sub

Public Sub decrementNumMensajesTopico(ByVal id_topico As Long, Optional ByVal decrement As Long = 1)
  Dim cm As New adodb.Command
  Dim strSQL As String
  
  On Error GoTo errhandler
  
  strSQL = "Update TOPICO Set NUM_RESPUESTAS = NUM_RESPUESTAS - ? Where ID_TOPICO = ?"
  With cm
    .ActiveConnection = DBCONNECTION
    .CommandType = adCmdText
    .CommandText = strSQL
    .Parameters(0).Value = decrement
    .Parameters(1).Value = id_topico
    .Execute
  End With
  Set cm = Nothing
  If mflgInMTS Then mobjContext.SetComplete
  Exit Sub
  
errhandler:
  App.LogEvent "TopicoPersist [decrementNumMensajesTopico()]: " & Err.Number & ": " & Err.Description & " (id_topico=" & id_topico & ")"
  Set cm = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Sub

Public Sub fixCounts()
  Dim cn As New adodb.Connection
  Dim cm As New adodb.Command
  Dim rs As New adodb.Recordset
  Dim strSQL As String
  
  On Error GoTo errhandler
  
  strSQL = "Select ID_TOPICO, COUNT(*) From MENSAJE GROUP BY ID_TOPICO"
  With cn
    .ConnectionString = DBCONNECTION
    .CursorLocation = adUseClient
    .Open
  End With
  rs.Open strSQL, cn, adOpenForwardOnly, adLockReadOnly
  rs.ActiveConnection = Nothing
  strSQL = "UPDATE TOPICO SET NUM_RESPUESTAS = ? WHERE ID_TOPICO = ?"
  With cm
    .ActiveConnection = cn
    .CommandType = adCmdText
    .CommandText = strSQL
    While Not rs.EOF
      .Parameters(0).Value = rs.Fields(1)
      .Parameters(1).Value = rs.Fields(0)
      .Execute
      rs.MoveNext
    Wend
  End With
  cn.Close
  Set rs = Nothing
  Set cm = Nothing
  Set cn = Nothing
  If mflgInMTS Then mobjContext.SetComplete
  Exit Sub
  
errhandler:
  App.LogEvent "TopicoPersist [fixCounts()]: " & Err.Number & ": " & Err.Description
  Set rs = Nothing
  Set cm = Nothing
  Set cn = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Sub

Private Function DeserializeTopico(ByVal Buffer As String) As TopicoProps
  Dim udtData As TopicoData
  Dim PBag As PropertyBag
  Dim arrbyte_buff() As Byte
  
  arrbyte_buff = Buffer
  Set PBag = New PropertyBag
  With PBag
    .Contents = arrbyte_buff
    udtData.Buffer = .ReadProperty("fixedlength_state")
  End With
  Set PBag = Nothing
  LSet DeserializeTopico = udtData
End Function

Private Function SerializeTopico(ByRef udtProps As TopicoProps) As String
  Dim udtData As TopicoData
  Dim PBag As PropertyBag
  
  LSet udtData = udtProps
  Set PBag = New PropertyBag
  With PBag
    .WriteProperty "fixedlength_state", udtData.Buffer
    SerializeTopico = .Contents
  End With
  Set PBag = Nothing
End Function

Private Sub ObjectControl_Activate()
  Set mobjContext = GetObjectContext
  mflgInMTS = True
End Sub

Private Function ObjectControl_CanBePooled() As Boolean
  ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
  Set mobjContext = Nothing
End Sub



