VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "VBMensajePersist"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements ObjectControl
Private mobjContext As ObjectContext
Private mflgInMTS As Boolean

Public Function findMensajes(ByVal autor As String, ByVal prioridad As Integer, _
                             ByVal asunto As String, ByVal all_asunto As Boolean, _
                             ByVal contenido As String, ByVal all_contenido As Boolean, _
                             ByVal fecha_inicial As Date, ByVal fecha_final As Date) As String
  Dim cn As adodb.Connection
  Dim cm As adodb.Command
  Dim rs As adodb.Recordset
  Dim strSQL As String
  Dim udtProps As VBMensajeProps
  Dim lngIndex As Long
  Dim PBag As PropertyBag
  Dim vStringTokenizer As Variant
  Dim sToken As Variant
  Dim putAndOr As Boolean

  On Error GoTo errhandler
  
  Set PBag = New PropertyBag
  strSQL = "SELECT T1.ID_FORO, T1.NOMBRE NOMBRE_FORO, T2.ID_USUARIO, T2.NOMBRE_CORTO NOMBRE_USUARIO, " _
         & "T3.ID_TOPICO, T3.NOMBRE NOMBRE_TOPICO, T4.ID_MENSAJE, T4.ASUNTO, T4.ENVIO_ANONIMO, " _
         & "T4.NOMBRE_AUTOR, T4.FECHA_ENVIO " _
         & "FROM FORO T1, USUARIO T2, TOPICO T3, MENSAJE T4 " _
         & "WHERE T1.ID_FORO = T3.ID_FORO " _
         & "AND T3.ID_TOPICO = T4.ID_TOPICO " _
         & "AND T2.ID_USUARIO = T4.ID_USUARIO "
  If Len(autor) > 0 Then strSQL = strSQL & " AND T2.NOMBRE_CORTO = '" & autor & "' "
  If prioridad > 0 Then strSQL = strSQL & " AND T4.PRIORIDAD = " & prioridad & " "
  If Len(asunto) > 0 Then
    If Not all_asunto Then strSQL = strSQL & " AND ("
    vStringTokenizer = Split(Replace(asunto, ",", " "), " ")
    putAndOr = False
    For Each sToken In vStringTokenizer
      If all_asunto Then
        strSQL = strSQL & " AND "
      Else
        If putAndOr Then
          strSQL = strSQL & " OR "
        Else
          putAndOr = True
        End If
      End If
      strSQL = strSQL & "T4.ASUNTO LIKE '%" & UCase(sToken) & "%' "
    Next
    If Not all_asunto Then strSQL = strSQL & ") "
  End If
  If Len(contenido) > 0 Then
    If Not all_contenido Then strSQL = strSQL & " AND ("
    vStringTokenizer = Split(Replace(contenido, ",", " "), " ")
    putAndOr = False
    For Each sToken In vStringTokenizer
      If all_contenido Then
        strSQL = strSQL & " AND "
      Else
        If putAndOr Then
          strSQL = strSQL & " OR "
        Else
          putAndOr = True
        End If
      End If
      strSQL = strSQL & "T4.CONTENIDO LIKE '%" & UCase(sToken) & "%' "
    Next
    If Not all_contenido Then strSQL = strSQL & ") "
  End If
  If CDbl(fecha_inicial) <> 0 Then strSQL = strSQL & " AND T4.FECHA_ENVIO >= ? "
  If CDbl(fecha_final) <> 0 Then strSQL = strSQL & " AND T4.FECHA_ENVIO <= ? "
  
  Set cn = New adodb.Connection
  Set cm = New adodb.Command
  Set rs = New adodb.Recordset
  With cn
    .ConnectionString = DBCONNECTION
    .CursorLocation = adUseClient
    .Open
  End With
  With cm
    .ActiveConnection = cn
    .CommandType = adCmdText
    .CommandText = strSQL
    If CDbl(fecha_inicial) <> 0 Then .Parameters(0).Value = fecha_inicial
    If CDbl(fecha_final) <> 0 Then .Parameters(IIf(CDbl(fecha_inicial) <> 0, 1, 0)).Value = fecha_final
  End With

  rs.CursorLocation = adUseClient
  rs.LockType = adLockReadOnly
  rs.CursorType = adOpenStatic
  Set rs = cm.Execute
  Set rs.ActiveConnection = Nothing
  cn.Close
  Set cm = Nothing
  Set cn = Nothing
  With rs
    While Not .EOF
      lngIndex = lngIndex + 1
      udtProps.id_mensaje = .Fields("id_mensaje").Value
      udtProps.id_foro = .Fields("id_foro").Value
      udtProps.id_topico = .Fields("id_topico").Value
      udtProps.id_usuario = .Fields("id_usuario").Value
      udtProps.asunto = .Fields("asunto").Value
      udtProps.envio_anonimo = .Fields("envio_anonimo").Value
      udtProps.fecha_envio = .Fields("fecha_envio").Value
      udtProps.nombre_autor = .Fields("nombre_autor").Value & ""
      udtProps.nombre_foro = .Fields("nombre_foro").Value & ""
      udtProps.nombre_topico = .Fields("nombre_topico").Value & ""
      udtProps.nombre_usuario = .Fields("nombre_usuario").Value
      PBag.WriteProperty "Item" & lngIndex, SerializeVBMensaje(udtProps)
      .MoveNext
    Wend
    .Close
  End With
  Set rs = Nothing
  PBag.WriteProperty "Count", lngIndex
  findMensajes = PBag.Contents
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function

errhandler:
  App.LogEvent "VBMensajePersist [findMensajes()]: " & Err.Number & ": " & Err.Description
  Set cm = Nothing
  Set cn = Nothing
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Private Function DeserializeVBMensaje(ByVal Buffer As String) As VBMensajeProps
  Dim udtData As VBMensajeData
  Dim PBag As PropertyBag
  Dim arrbyte_buff() As Byte
  
  arrbyte_buff = Buffer
  Set PBag = New PropertyBag
  With PBag
    .Contents = arrbyte_buff
    udtData.Buffer = .ReadProperty("fixedlength_state")
  End With
  Set PBag = Nothing
  LSet DeserializeVBMensaje = udtData
End Function

Private Function SerializeVBMensaje(ByRef udtProps As VBMensajeProps) As String
  Dim udtData As VBMensajeData
  Dim PBag As PropertyBag
  
  LSet udtData = udtProps
  Set PBag = New PropertyBag
  With PBag
    .WriteProperty "fixedlength_state", udtData.Buffer
    SerializeVBMensaje = .Contents
  End With
  Set PBag = Nothing
End Function

Private Sub ObjectControl_Activate()
  Set mobjContext = GetObjectContext
  mflgInMTS = True
End Sub

Private Function ObjectControl_CanBePooled() As Boolean
  ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
  Set mobjContext = Nothing
End Sub


