VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "VBTopicoPersist"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements ObjectControl
Private mobjContext As ObjectContext
Private mflgInMTS As Boolean

Public Function findTopicos(ByVal autor As String, _
                             ByVal nombre_topico As String, ByVal all_nombre_topico As Boolean, _
                             ByVal op_num_resp As String, ByVal num_resp As String, _
                             ByVal fecha_creacion1 As Date, ByVal fecha_creacion2 As Date, _
                             ByVal fecha_ultmens1 As Date, ByVal fecha_ultmens2 As Date) As String
  Dim cn As adodb.Connection
  Dim cm As adodb.Command
  Dim rs As adodb.Recordset
  Dim strSQL As String
  Dim udtProps As VBTopicoProps
  Dim lngIndex As Long
  Dim PBag As PropertyBag
  Dim vStringTokenizer As Variant
  Dim sToken As Variant
  Dim putAndOr As Boolean
  Dim aux As Integer

  On Error GoTo errhandler
  
  Set PBag = New PropertyBag
  strSQL = "SELECT T1.ID_FORO, T1.NOMBRE NOMBRE_FORO, T2.ID_USUARIO, " _
         & "T2.NOMBRE_CORTO NOMBRE_USUARIO, T3.ID_TOPICO, T3.NOMBRE NOMBRE_TOPICO, " _
         & "T3.NUM_RESPUESTAS, T3.FECHA_CREACION, T3.FECHA_ULTIMO_MENSAJE " _
         & "FROM FORO T1, USUARIO T2, TOPICO T3 " _
         & "WHERE T1.ID_FORO = T3.ID_FORO " _
         & "AND T2.ID_USUARIO = T3.ID_USUARIO  "
  If Len(autor) > 0 Then strSQL = strSQL & " AND T2.NOMBRE_CORTO = '" & autor & "' "
  If Len(nombre_topico) > 0 Then
    If Not all_nombre_topico Then strSQL = strSQL & " AND ("
    vStringTokenizer = Split(Replace(nombre_topico, ",", " "), " ")
    putAndOr = False
    For Each sToken In vStringTokenizer
      If all_nombre_topico Then
        strSQL = strSQL & " AND "
      Else
        If putAndOr Then
          strSQL = strSQL & " OR "
        Else
          putAndOr = True
        End If
      End If
      strSQL = strSQL & "T3.NOMBRE LIKE '%" & UCase(sToken) & "%' "
    Next
    If Not all_nombre_topico Then strSQL = strSQL & ") "
  End If
  If IsNumeric(num_resp) And Len(op_num_resp) > 0 Then
    strSQL = strSQL & " AND T3.NUM_RESPUESTAS " & op_num_resp & CStr(CInt(num_resp)) & " "
  End If
  If CDbl(fecha_creacion1) <> 0 Then strSQL = strSQL & " AND T3.FECHA_CREACION >= ? "
  If CDbl(fecha_creacion2) <> 0 Then strSQL = strSQL & " AND T3.FECHA_CREACION <= ? "
  If CDbl(fecha_ultmens1) <> 0 Then strSQL = strSQL & " AND T3.FECHA_ULTIMO_MENSAJE >= ? "
  If CDbl(fecha_ultmens2) <> 0 Then strSQL = strSQL & " AND T3.FECHA_ULTIMO_MENSAJE <= ? "

  Set cn = New adodb.Connection
  Set cm = New adodb.Command
  Set rs = New adodb.Recordset
  With cn
    .ConnectionString = DBCONNECTION
    .CursorLocation = adUseClient
    .Open
  End With
  With cm
    .ActiveConnection = cn
    .CommandType = adCmdText
    .CommandText = strSQL
    If CDbl(fecha_creacion1) <> 0 Then
      .Parameters(0).Value = fecha_creacion1
      aux = aux + 1
    End If
    If CDbl(fecha_creacion2) <> 0 Then
      .Parameters(aux).Value = fecha_creacion2
      aux = aux + 1
    End If
    If CDbl(fecha_ultmens1) <> 0 Then
      .Parameters(aux).Value = fecha_ultmens1
      aux = aux + 1
    End If
    If CDbl(fecha_ultmens2) <> 0 Then
      .Parameters(aux).Value = fecha_ultmens2
    End If
  End With

  rs.CursorLocation = adUseClient
  rs.LockType = adLockReadOnly
  rs.CursorType = adOpenStatic
  Set rs = cm.Execute
  Set rs.ActiveConnection = Nothing
  cn.Close
  Set cm = Nothing
  Set cn = Nothing
  With rs
    While Not .EOF
      lngIndex = lngIndex + 1
      udtProps.id_foro = .Fields("id_foro").Value
      udtProps.id_topico = .Fields("id_topico").Value
      udtProps.id_usuario = .Fields("id_usuario").Value
      udtProps.fecha_creacion = .Fields("fecha_creacion").Value
      udtProps.fecha_ultimo_mensaje = Nvl(.Fields("fecha_ultimo_mensaje").Value, 0)
      udtProps.nombre_foro = .Fields("nombre_foro").Value & ""
      udtProps.nombre_topico = .Fields("nombre_topico").Value & ""
      udtProps.nombre_usuario = .Fields("nombre_usuario").Value & ""
      udtProps.num_respuestas = .Fields("num_respuestas").Value
      PBag.WriteProperty "Item" & lngIndex, SerializeVBTopico(udtProps)
      .MoveNext
    Wend
    .Close
  End With
  Set rs = Nothing
  PBag.WriteProperty "Count", lngIndex
  findTopicos = PBag.Contents
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function

errhandler:
  App.LogEvent "VBTopicoPersist [findTopicos()]: " & Err.Number & ": " & Err.Description
  Set cm = Nothing
  Set cn = Nothing
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Private Function DeserializeVBTopico(ByVal Buffer As String) As VBTopicoProps
  Dim udtData As VBTopicoData
  Dim PBag As PropertyBag
  Dim arrbyte_buff() As Byte
  
  arrbyte_buff = Buffer
  Set PBag = New PropertyBag
  With PBag
    .Contents = arrbyte_buff
    udtData.Buffer = .ReadProperty("fixedlength_state")
  End With
  Set PBag = Nothing
  LSet DeserializeVBTopico = udtData
End Function

Private Function SerializeVBTopico(ByRef udtProps As VBTopicoProps) As String
  Dim udtData As VBTopicoData
  Dim PBag As PropertyBag
  
  LSet udtData = udtProps
  Set PBag = New PropertyBag
  With PBag
    .WriteProperty "fixedlength_state", udtData.Buffer
    SerializeVBTopico = .Contents
  End With
  Set PBag = Nothing
End Function

Private Sub ObjectControl_Activate()
  Set mobjContext = GetObjectContext
  mflgInMTS = True
End Sub

Private Function ObjectControl_CanBePooled() As Boolean
  ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
  Set mobjContext = Nothing
End Sub




