VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "HTMLUtils"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private mVirtualPath As String
Private mMeses(0 To 11) As String
Private mEmoticonsDictionary As Scripting.Dictionary
'El valor default de una variable booleana (no inicializada) es FALSE
Private mEmoticonsDictFlag As Boolean

Public Function DayOptionsHTML(Optional somedate As Date = 0) As String
  Dim opciones As String
  Dim i As Byte, dia As Byte
  
  If somedate = 0 Then somedate = Now
  dia = DatePart("d", somedate)
  For i = 1 To 32
    opciones = opciones & "<OPTION "
    If i = dia Then opciones = opciones & " selected"
    opciones = opciones & " value=""" & i & """>" & i & "</OPTION>"
  Next i
  DayOptionsHTML = opciones
End Function

Public Function MonthOptionsHTML(Optional somedate As Date = 0) As String
  Dim opciones As String
  Dim i As Byte, mes As Byte
  
  If somedate = 0 Then somedate = Now
  If Len(mMeses(0)) = 0 Then
    mMeses(0) = "Ene"
    mMeses(1) = "Feb"
    mMeses(2) = "Mar"
    mMeses(3) = "Abr"
    mMeses(4) = "May"
    mMeses(5) = "Jun"
    mMeses(6) = "Jul"
    mMeses(7) = "Ago"
    mMeses(8) = "Sep"
    mMeses(9) = "Oct"
    mMeses(10) = "Nov"
    mMeses(11) = "Dic"
  End If
  mes = DatePart("m", somedate) - 1
  For i = 0 To 11
    opciones = opciones & "<OPTION "
    If i = mes Then opciones = opciones & "selected "
    opciones = opciones & "value=""" & i & """>" & mMeses(i) & "</OPTION>"
  Next i
  MonthOptionsHTML = opciones
End Function

Public Function getAttachmentLinkHTML(uri_attachment As String) As String
  ' Si Len(mVirtualPath) = 0 entonces debemos inicializar su valor
  If Len(mVirtualPath) = 0 Then
    Dim spmMgr As SharedPropertyGroupManager
    Dim spmGroup As SharedPropertyGroup
    Dim spmProp As SharedProperty
    Dim bResult As Boolean
    Dim objSettings As New Settings
  
    Set spmMgr = CreateObject("MTxSpm.SharedPropertyGroupManager.1")
    Set spmGroup = spmMgr.CreatePropertyGroup("Settings", LockSetGet, Process, bResult)
    Set spmProp = spmGroup.CreateProperty("attachmentVirtualPath", bResult)
    If Not bResult Then
      mVirtualPath = objSettings.getSetting("asp.attachmentVirtualPath")
      spmProp.value = mVirtualPath
    Else
      mVirtualPath = spmProp.value
    End If
    Set spmProp = Nothing
    Set spmGroup = Nothing
    Set spmMgr = Nothing
  End If
  
  If Len(uri_attachment) > 0 Then
    Dim auxStringUtils As New StringUtils
    getAttachmentLinkHTML = "<A href=""" & mVirtualPath & _
                            auxStringUtils.URLItemEncode(uri_attachment) & _
                            """ target=""_blank""><IMG src=""images/attachment.gif"" border=""0""></A>"
  Else
    getAttachmentLinkHTML = ""
  End If
End Function

Public Function getNbspHTML(count As Integer) As String
  Dim i As Integer
  Dim retValue As String
  
  For i = 1 To count
    retValue = retValue & "&nbsp;"
  Next
  getNbspHTML = retValue
End Function

Public Function truncDate(Optional somedate As Date = 0) As Date
  If somedate = 0 Then somedate = Now
  truncDate = DateValue(somedate)
End Function

Public Function getNewImageHTML(element As Date, compare As Date) As String
  If DateDiff("d", compare, element) > 0 Then
    getNewImageHTML = "<IMG src=""images/new.gif"" border=""0"">"
  Else
    getNewImageHTML = ""
  End If
End Function

Public Function getImagePrioridadHTML(prioridad As Integer) As String
  If prioridad = 1 Then
    getImagePrioridadHTML = "<IMG src=""images/prioridad_urgente.gif"" border=""0"" alt=""Mensaje de Urgente Prioridad"">"
  ElseIf prioridad = 2 Then
    getImagePrioridadHTML = "<IMG src=""images/prioridad_alta.gif"" border=""0"" alt=""Mensaje de Alta Prioridad"">"
  Else
    getImagePrioridadHTML = ""
  End If
End Function

Private Sub InitEmoticonsDictionary()
  Dim objContext As COMSVCSLib.ObjectContext
  Dim objApplication As ASPTypeLibrary.Application

  Set objContext = GetObjectContext
  Set objApplication = objContext("Application")
  Set mEmoticonsDictionary = objApplication.StaticObjects("emoticons")
  Set objApplication = Nothing
  Set objContext = Nothing
  mEmoticonsDictFlag = True
End Sub

Public Function getEmoticonImgHTML(id_emoticon As Long) As String
  If Not mEmoticonsDictFlag Then InitEmoticonsDictionary
  If mEmoticonsDictionary.Exists(CStr(id_emoticon)) Then
    getEmoticonImgHTML = "<IMG src=""" & mEmoticonsDictionary.item(CStr(id_emoticon)) & """>&nbsp;"
  Else
    getEmoticonImgHTML = ""
  End If
End Function

Public Function getEmoticonsTableHTML() As String
  Dim spmMgr As SharedPropertyGroupManager
  Dim spmGroup As SharedPropertyGroup
  Dim spmProp As SharedProperty
  Dim bResult As Boolean
  
  Set spmMgr = CreateObject("MTxSpm.SharedPropertyGroupManager.1")
  Set spmGroup = spmMgr.CreatePropertyGroup("EmoticonsTable", LockSetGet, Process, bResult)
  Set spmProp = spmGroup.CreatePropertyByPosition(0, bResult)
  If Not bResult Then
    spmProp.value = buildEmoticonsTableHTML
  End If
  getEmoticonsTableHTML = CStr(spmProp.value)
  Set spmProp = Nothing
  Set spmGroup = Nothing
  Set spmMgr = Nothing
End Function

Public Sub setEmoticonsTableHTML()
  Dim spmMgr As SharedPropertyGroupManager
  Dim spmGroup As SharedPropertyGroup
  Dim spmProp As SharedProperty
  Dim bResult As Boolean
  
  Set spmMgr = CreateObject("MTxSpm.SharedPropertyGroupManager.1")
  Set spmGroup = spmMgr.CreatePropertyGroup("EmoticonsTable", LockSetGet, Process, bResult)
  Set spmProp = spmGroup.CreatePropertyByPosition(0, bResult)
  spmProp.value = buildEmoticonsTableHTML
  Set spmProp = Nothing
  Set spmGroup = Nothing
  Set spmMgr = Nothing
End Sub

Private Function buildEmoticonsTableHTML() As String
  Dim emoticonsTable As String
  Dim arrId As Variant
  Dim arrUri As Variant
  Dim i As Integer

  If Not mEmoticonsDictFlag Then InitEmoticonsDictionary
  arrId = mEmoticonsDictionary.Keys
  arrUri = mEmoticonsDictionary.Items
  emoticonsTable = "<TABLE align=""center"" border=""1"" cellPadding=""0"" cellSpacing=""0"" width=""100%""><TR>" & _
                   "<TD align=""center""><INPUT type=""radio"" name=""id_emoticon"" value=""0"" checked><BR>" & _
                   "<SPAN class=""SmallText"">Ninguno</SPAN></TD>"
  For i = LBound(arrId) To UBound(arrId)
    If (i + 1) Mod 18 = 0 Then emoticonsTable = emoticonsTable & "</TR><TR>"
    emoticonsTable = emoticonsTable & "<TD align=""center""><INPUT type=""radio"" name=""id_emoticon"" value=""" & _
                     CStr(arrId(i)) & """><BR><IMG src=""" & arrUri(i) & """></TD>"
  Next i
  emoticonsTable = emoticonsTable & "</TR></TABLE>"
  buildEmoticonsTableHTML = emoticonsTable
End Function
