Class Roles
	Public Property Get NOT_LOGGED()
    NOT_LOGGED = "NL"
	End Property
	
	Public Property Get SUSPENDED()
    SUSPENDED = "SU"
	End Property
	
  Public Property Get NOT_MEMBER()
    NOT_MEMBER = "NM"
	End Property
	
  Public Property Get INACTIVE_MEMBER()
    INACTIVE_MEMBER = "IM"
	End Property
	
  Public Property Get MEMBER()
    MEMBER = "ME"
	End Property
	
  Public Property Get ADMIN_MODERATOR()
    ADMIN_MODERATOR = "AM"
	End Property
  Public Property Get MODERATOR()
    MODERATOR = "MO"
	End Property
  Public Property Get ADMINISTRATOR()
    ADMINISTRATOR = "AD"
	End Property
  
  public function isEnough(neededRole, currentRole)
    if neededRole = currentRole then
      isEnough = true
    elseif instr(ADMINISTRATOR & ADMIN_MODERATOR & MODERATOR & MEMBER) >= 0 then
      if currentRole = ADMINISTRATOR then
        isEnough = true
      elseif neededRole = MODERATOR then
        isEnough = currentRole = ADMIN_MODERATOR
      elseif neededRole = MEMBER then
        isEnough = currentRole = ADMIN_MODERATOR or currentRole = MODERATOR
      else
        isEnough = false
      end if
    else
      isEnough = false
    end if
  end function

  
  public function isMember(currentRole)
    isMember = isEnough(MEMBER, currentRole)
  end function

  public function isModerator(currentRole) 
    isModerator = isEnough(MODERATOR, currentRole)
  end function

  public function isAdminModerator(currentRole) 
    isAdminModerator = isEnough(ADMIN_MODERATOR, currentRole)
  end function

  public function isAdministrator(currentRole) 
    isAdministrator = isEnough(ADMINISTRATOR, currentRole)
  end function

	public function getRolesListExcluding(excList)
		Dim excArr, itm1, itm2, found, list
		Dim allRolesArr(7)
		allRolesArr(0) = NOT_LOGGED
		allRolesArr(1) = SUSPENDED
    allRolesArr(2) = NOT_MEMBER
    allRolesArr(3) = INACTIVE_MEMBER
    allRolesArr(4) = MEMBER
    allRolesArr(5) = ADMIN_MODERATOR
    allRolesArr(6) = MODERATOR
    allRolesArr(7) = ADMINISTRATOR
		excArr = Split(excList, ",")
		list = ""
		For Each itm1 in allRolesArr
			found = false
			For Each itm2 in excArr
				if itm1 = itm2 then
					found = true
					Exit For
				end if
			Next
			if not found then
				list = itm1 & ","
			end if
		Next
		if len(list) > 0 then
			list = left(list, len(list)-1)
		end if
	end function
	
	public function getSuscriptionRole(Suscription_status, Suscription_type)
	  if Suscription_status = Estatus.INACTIVO then
			getSuscriptionRole = INACTIVE_MEMBER
		elseif Suscription_type = TipoDeSuscripcion.ADMIN_MODERADOR then
			getSuscriptionRole = ADMIN_MODERADOR
		elseif Suscription_type = TipoDeSuscripcion.MODERADOR then
			getSuscriptionRole = MODERADOR
		elseif Suscription_type = TipoDeSuscripcion.NORMAL then
			getSuscriptionRole = MEMBER
		elseif Suscription_type = TipoDeSuscripcion.SUSPENDIDO then
			getSuscriptionRole = SUSPENDED
		else
			getSuscriptionRole = NOT_MEMBER
		end if
	end function
End Class

