// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import javax.servlet.*;
import javax.servlet.http.*;
import java.util.Date;
import com.netapplications.webforums_jsp.persist.*;
import com.netapplications.webforums_jsp.types.*;
import com.netapplications.webforums_jsp.domain.Foro;

public class AddForumCommand extends Command {

  private String next;

  public AddForumCommand(String next) {
    this.next = next;
  }

  // Al finalizar la ejecucin de este comando
  // se deber actualizar el arreglo global de
  // foros de la aplicacin  
  public boolean globalObjectUpdated() {
    return true;
  }

  public String execute(HttpServletRequest req)
    throws CommandException {
    HttpSession session = req.getSession(true);
    if (!Roles.isAdministrator((String) session.getAttribute("role"))) {
      req.setAttribute("webforums.msg", "Need ADMIN privileges for this command");
    } else if (!CommandToken.isValid(req)) {
      req.setAttribute("webforums.msg", "Invalid Reload Attempted");
    } else {
      try {
        Foro forum = new Foro();
        ForoPersist fdb = ForoPersist.getInstance();
        forum.setDescripcion(req.getParameter("descripcion"));
        forum.setEs_activo(StrBoolean.TRUE);
        forum.setFecha_creacion(new Date());
        forum.setFecha_ultima_visita(new Date());
        forum.setNombre(req.getParameter("nombre"));
        forum.setNum_topicos(0);
        forum.setNum_visitas(0);
        fdb.put(forum);
        req.setAttribute("webforums.msg", "Forum creation Success!");
      } catch (PersistException fe) {
        throw new CommandException("AddForumCommand: " + fe.getMessage());
      }
    }
    return next;
  }
}
