// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import javax.servlet.*;
import javax.servlet.http.*;
import com.netapplications.webforums_jsp.domain.Usuario;
import com.netapplications.webforums_jsp.persist.*;
import com.netapplications.webforums_jsp.types.*;

public class AddUserCommand extends Command {

  private String nextAddSuccess;
  private String nextAddFail;

  public AddUserCommand(String nextAddSuccess, String nextAddFail) {
    this.nextAddSuccess = nextAddSuccess;
    this.nextAddFail = nextAddFail;
  }

  public String execute(HttpServletRequest req)
    throws CommandException {
    HttpSession session = req.getSession(true);
    Usuario user = new Usuario();
    if (CommandToken.isValid(req)) {
      try {
        UsuarioPersist udb = UsuarioPersist.getInstance();
        user.setNombre_corto(req.getParameter("nombre_corto"));
        user.setNombre_completo(req.getParameter("nombre_completo"));
        user.setPassword(req.getParameter("password"));
        user.setEmail(req.getParameter("email"));
        user.setEstatus(Estatus.ACTIVO);
        user.setAdministrador(StrBoolean.FALSE);
        udb.put(user);
        session.setAttribute("usuario", user);
        req.setAttribute("webforums.msg", "Register Success!");
        session.setAttribute("role", Roles.NOT_MEMBER);
        return nextAddSuccess;
      } catch (UnknownPersistException e) {
        req.setAttribute("webforums.msg", e.getMessage());
        return nextAddFail;
      } catch (PersistException fe) {
        throw new CommandException("AddUserCommand: " + fe.getMessage());
      }
    } else {
      req.setAttribute("webforums.msg", "Invalid Reload Attempted");
      return nextAddFail;
    }
  }
}
