// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import java.util.HashMap;
import java.util.StringTokenizer;

public class CommandsHashMap extends Object {

  private HashMap map;

  public CommandsHashMap() {
    map = new HashMap();
  }

  public void putCommand(String key, Command cmd) {
    map.put(key, cmd);
  }

  public Command getCommand(String key) throws CommandException {
    if (map.containsKey(key.toLowerCase())) {
      return (Command) map.get(key.toLowerCase());
    } else {
      throw new CommandException("Invalid Command Identifier: " + "\'" + key.toLowerCase() + "\'");
    }
  }

  public String getKeysListExcluding(String excList) {
    StringBuffer list = new StringBuffer(50);
    if (map.size()>0) {
      String[] keys = (String[]) map.keySet().toArray(new String[0]);
      for (int i=0; i<keys.length; i++) {
        list.append(keys[i]);
        list.append(',');
      }
      int pos;
      if (excList!=null && excList.length()>0) {
        StringTokenizer excludeTok = new StringTokenizer(excList,", ");
        String exclude;
        while (excludeTok.hasMoreTokens()) {
          exclude = excludeTok.nextToken();
          pos = list.toString().indexOf(exclude + ",");
          if (pos>=0) {
            list.delete(pos,++pos+exclude.length());
          }
        }
      }
      pos = list.length();
      if (pos>0) {
        list.delete(--pos,list.length());
      }
    }
    return list.toString();
  }

  public static void main(String[] argc) {
    try {
      CommandsHashMap cmds = new CommandsHashMap();
      cmds.putCommand("go-home", new NullCommand("home.xml"));
      cmds.putCommand("go-home2", new AbortCommand("home.xml"));
      cmds.putCommand("go-home-ads", new AbortCommand("home.xml"));
      cmds.putCommand("go-house", new AbortCommand("home.xml"));
      System.out.println(">" + cmds.getKeysListExcluding("go-home") + "<");
    }
    catch (Exception e) {System.out.println(e.getMessage());}
  }
}

