// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import javax.servlet.*;
import javax.servlet.http.*;
import java.util.StringTokenizer;
import com.netapplications.webforums_jsp.persist.*;

public class DelEmoticonCascadeCommand extends Command {
  private String next;

  public DelEmoticonCascadeCommand(String next) {
    this.next = next;
  }

  // Al finalizar la ejecucin de este comando
  // se deber actualizar el arreglo global de
  // foros de la aplicacin  
  public boolean globalObjectUpdated() {
    return true;
  }

  public String execute(HttpServletRequest req)
    throws CommandException {
    HttpSession session = req.getSession(true);
    if (!Roles.isAdministrator((String) session.getAttribute("role"))) {
      req.setAttribute("webforums.msg", "Need ADMIN privileges for this command");
    } else if (!CommandToken.isValid(req)) {
      req.setAttribute("webforums.msg", "Invalid Reload Attempted");
    } else if (req.getParameter("idlist")!=null) {
      try {
        EmoticonPersist edb = EmoticonPersist.getInstance();
        StringTokenizer emoticon = new StringTokenizer(req.getParameter("idlist"),",");
        while (emoticon.hasMoreTokens()) {
          edb.removeEmoticonCascade(Integer.parseInt(emoticon.nextToken()));
        }
        req.setAttribute("webforums.msg", "Emoticon(s) deleted");
      }
      catch (NumberFormatException e) {
        throw new CommandException("DelEmoticonCascadeCommand: invalid ID");
      }
      catch (PersistException fe) {
        throw new CommandException("DelEmoticonCascadeCommand: " + fe.getMessage());
      }
    }
    return next;
  }
}
