// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import com.netapplications.webforums_jsp.persist.*;

public class DelForumCascadeCommand extends Command {
  private String next;

  public DelForumCascadeCommand(String next) {
    this.next = next;
  }

  // Al finalizar la ejecucin de este comando
  // se deber actualizar el arreglo global de
  // foros de la aplicacin  
  public boolean globalObjectUpdated() {
    return true;
  }

  public String execute(HttpServletRequest req) throws CommandException {
    HttpSession session = req.getSession(true);
    if (!Roles.isAdministrator((String) session.getAttribute("role"))) {
      req.setAttribute("webforums.msg", "Need ADMIN privileges for this command");
    } else if (!CommandToken.isValid(req)) {
      req.setAttribute("webforums.msg", "Invalid Reload Attempted");
    } else if (req.getParameter("idlist")!=null) {
      try {
        ForoPersist fdb = ForoPersist.getInstance();
        StringTokenizer tops = new StringTokenizer(req.getParameter("idlist"),",");
        int total = tops.countTokens();
        while (tops.hasMoreTokens()) {
          fdb.remove(Integer.parseInt(tops.nextToken()));
        }
        req.setAttribute("webforums.msg", total + " Forum(s) deleted");
      }
      catch (NumberFormatException e) {
        throw new CommandException("DelForumCascadeCommand: invalid ID");
      }
      catch (PersistException e) {
        throw new CommandException("DelForumCascadeCommand: " + e.getMessage());
      }
    }
    return next;
  }
}
