// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import com.netapplications.webforums_jsp.persist.*;

public class DelMessageCascadeCommand extends Command {
  private String nextThreadView;
  private String nextFlatView;

  public DelMessageCascadeCommand(String nextThreadView, String nextFlatView) {
    this.nextThreadView = nextThreadView;
    this.nextFlatView = nextFlatView;
  }

  public String execute(HttpServletRequest req)
    throws CommandException {
      throw new CommandException("DelMessageCascadeCommand: This call is not allowed!");
  }

  public String execute(HttpServletRequest req, HttpServletResponse res)
    throws CommandException {
    HttpSession session = req.getSession(true);
    if (!Roles.isEnough(Roles.MODERATOR, (String) session.getAttribute("role"))) {
      req.setAttribute("webforums.msg", "Need MODERATOR privileges for this command");
    } else if (!CommandToken.isValid(req)) {
      req.setAttribute("webforums.msg", "Invalid Reload Attempted");
    } else if (req.getParameter("idlist")!=null) {
      try {
        MensajePersist mdb = MensajePersist.getInstance();
        TopicoPersist tdb = TopicoPersist.getInstance();
        StringTokenizer mens = new StringTokenizer(req.getParameter("idlist"),",");
        Collection ints = new ArrayList();
        while (mens.hasMoreTokens()) {
          ints.add(new Integer(mens.nextToken()));
        }
        Integer[] arr = (Integer[])ints.toArray(new Integer[0]);
        Arrays.sort(arr);
        int total = 0;
        for (int i=arr.length; i-->0;) {
          total += mdb.removeMensajeCascade(arr[i].intValue());
        }
        tdb.decrementNumMensajesTopico(Integer.parseInt(req.getParameter("id_topico")),total);
        req.setAttribute("webforums.msg", total + " Message(s) deleted");
      }
      catch (NumberFormatException e) {
        throw new CommandException("DelMessageCascadeCommand: invalid ID");
      }
      catch (PersistException fe) {
        throw new CommandException("DelMessageCascadeCommand: " + fe.getMessage());
      }
    }
    GetAllMessagesOfTopicCommand nextCmd = new GetAllMessagesOfTopicCommand(nextThreadView, nextFlatView);
    return nextCmd.execute(req, res);
  }
}
