// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import com.netapplications.webforums_jsp.persist.*;

public class DelTopicCascadeCommand extends Command {
  private String next;
  private boolean goForumNext;

  public DelTopicCascadeCommand(String next, boolean goForumNext) {
    this.next = next;
    this.goForumNext = goForumNext;
  }

  public DelTopicCascadeCommand(String next) {
    this(next, false);
  }

  public String execute(HttpServletRequest req) throws CommandException {
    HttpSession session = req.getSession(true);
    if (!Roles.isEnough(Roles.MODERATOR, (String) session.getAttribute("role"))) {
      req.setAttribute("webforums.msg", "Need MODERATOR privileges for this command");
    } else if (!CommandToken.isValid(req)) {
      req.setAttribute("webforums.msg", "Invalid Reload Attempted");
    } else if (req.getParameter("idlist")!=null) {
      try {
        TopicoPersist tdb = TopicoPersist.getInstance();
        ForoPersist fdb = ForoPersist.getInstance();
        StringTokenizer tops = new StringTokenizer(req.getParameter("idlist"),",");
        int total = tops.countTokens();
        while (tops.hasMoreTokens()) {
          tdb.removeTopicoCascade(Integer.parseInt(tops.nextToken()));
        }
        if (req.getParameter("id_foro")!=null) {
          fdb.decrementNumTopicosForo(Integer.parseInt(req.getParameter("id_foro")),total);
        }
        req.setAttribute("webforums.msg", total + " Topic(s) deleted");
      }
      catch (NumberFormatException e) {
        throw new CommandException("DelTopicCascadeCommand: invalid ID");
      }
      catch (PersistException e) {
        throw new CommandException("DelTopicCascadeCommand: " + e.getMessage());
      }
    }
    if (goForumNext) {
      GetAllTopicsOfForumCommand nextCmd = new GetAllTopicsOfForumCommand(next);
      return nextCmd.execute(req);
    } else {
      return next;
    }
  }
}
