// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import javax.servlet.*;
import javax.servlet.http.*;
import com.netapplications.webforums_jsp.persist.*;

public class FetchAnotherTopicOfForum extends Command {
  private String nextThreadView;
  private String nextFlatView;
  private boolean fetchPrevious;

  public FetchAnotherTopicOfForum(String nextThreadView, String nextFlatView, boolean fetchPrevious) {
    this.nextThreadView = nextThreadView;
    this.nextFlatView = nextFlatView;
    this.fetchPrevious = fetchPrevious;
  }

  public FetchAnotherTopicOfForum(String nextThreadView, String nextFlatView) {
    this(nextThreadView, nextFlatView, false);
  }

  public String execute(HttpServletRequest req)
    throws CommandException {
      throw new CommandException("FetchAnotherTopicOfForum: This call is not allowed");
  }

  public String execute(HttpServletRequest req, HttpServletResponse res)
    throws CommandException {
    int new_id_topico;
    int id_topico = 0;
    try {
      TopicoPersist tdb = TopicoPersist.getInstance();
      int id_foro = Integer.parseInt(req.getParameter("id_foro"));
      id_topico = Integer.parseInt(req.getParameter("id_topico"));
      if (fetchPrevious) {
        new_id_topico = tdb.getPrevTopico(id_foro, id_topico);
      } else {
        new_id_topico = tdb.getNextTopico(id_foro, id_topico);
      }
    } catch (NumberFormatException e) {
      throw new CommandException("FetchAnotherTopicOfForum: invalid ID");
    } catch (UnknownPersistException fe) {
      new_id_topico = id_topico;
      req.setAttribute("webforums.msg", "No more topics (this is the "+((fetchPrevious)?"first":"last")+" one)!");
    } catch (PersistException fe) {
      throw new CommandException("FetchAnotherTopicOfForum: " + fe.getMessage());
    }
    synchronized (req) {
      req.setAttribute("id_topico",String.valueOf(new_id_topico));
    }
    GetAllMessagesOfTopicCommand nextCmd = new GetAllMessagesOfTopicCommand(nextThreadView, nextFlatView);
    return nextCmd.execute(req, res);
  }
}
