// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import javax.servlet.*;
import javax.servlet.http.*;
import java.util.Date;
import com.netapplications.webforums_jsp.persist.*;
import com.netapplications.webforums_jsp.domain.VistaBusquedaMensaje;

public class FindMessagesCommand extends Command {

  private final int ONEDAYMILLIS = 1000*60*60*24;
  private String next;

  public FindMessagesCommand(String next) {
    this.next = next;
  }

  public String execute(HttpServletRequest req)
    throws CommandException {
    try {
      VistaBusquedaMensajePersist vbmdb = VistaBusquedaMensajePersist.getInstance();
      Date fecha1 = null;
      Date fecha2 = null;
      int prioridad;
      try {
        prioridad = Integer.parseInt(req.getParameter("prioridad"));
      } catch (NumberFormatException e) {
        prioridad = 0;
      }
      if (req.getParameter("fechainicio")!=null&&!req.getParameter("fechainicio").equals("")) {
        try {
          fecha1 = new Date(Long.parseLong(req.getParameter("fechainicio")));
        } catch (NumberFormatException e) {}
      }
      if (req.getParameter("fechafinal")!=null&&!req.getParameter("fechafinal").equals("")) {
        try {
          long millis = Long.parseLong(req.getParameter("fechafinal"));
          millis += ONEDAYMILLIS - 1;
          fecha2 = new Date(millis);
        } catch (NumberFormatException e) {}
      }
      VistaBusquedaMensaje[] bmens = vbmdb.findMensajes(req.getParameter("autor"),
        prioridad,
        req.getParameter("asunto"),
        req.getParameter("all_asunto")!=null&&req.getParameter("all_asunto").equalsIgnoreCase("s"),
        req.getParameter("contenido"),
        req.getParameter("all_contenido")!=null&&req.getParameter("all_contenido").equalsIgnoreCase("s"),
        fecha1,fecha2);
      req.setAttribute("mensajes_buscados", bmens);
      return next;
    }
    catch (PersistException fe) {
      throw new CommandException("FindMessagesCommand: " + fe.getMessage());
    }
  }
}
