// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import javax.servlet.*;
import javax.servlet.http.*;
import java.util.Date;
import com.netapplications.webforums_jsp.persist.*;
import com.netapplications.webforums_jsp.domain.VistaBusquedaTopico;

public class FindTopicsCommand extends Command {

  private final int ONEDAYMILLIS = 1000*60*60*24;
  private String next;

  public FindTopicsCommand(String next) {
    this.next = next;
  }

  public String execute(HttpServletRequest req)
    throws CommandException {
    try {
      VistaBusquedaTopicoPersist vbtdb = VistaBusquedaTopicoPersist.getInstance();
      Date fecha1 = null;
      Date fecha2 = null;
      Date fecha3 = null;
      Date fecha4 = null;
      if (req.getParameter("fechacreacion1")!=null&&!req.getParameter("fechacreacion1").equals("")) {
        try {
          fecha1 = new Date(Long.parseLong(req.getParameter("fechacreacion1")));
        } catch (NumberFormatException e) {}
      }
      if (req.getParameter("fechacreacion2")!=null&&!req.getParameter("fechacreacion2").equals("")) {
        try {
          long millis = Long.parseLong(req.getParameter("fechacreacion2"));
          millis += ONEDAYMILLIS - 1;
          fecha2 = new Date(millis);
        } catch (NumberFormatException e) {}
      }
      if (req.getParameter("fechaultmens1")!=null&&!req.getParameter("fechaultmens1").equals("")) {
        try {
          fecha3 = new Date(Long.parseLong(req.getParameter("fechaultmens1")));
        } catch (NumberFormatException e) {}
      }
      if (req.getParameter("fechaultmens2")!=null&&!req.getParameter("fechaultmens2").equals("")) {
        try {
          long millis = Long.parseLong(req.getParameter("fechaultmens2"));
          millis += ONEDAYMILLIS - 1;
          fecha4 = new Date(millis);
        } catch (NumberFormatException e) {}
      }
      VistaBusquedaTopico[] btops = vbtdb.findTopicos(
        req.getParameter("autor"),
        req.getParameter("nom_topico"),
        req.getParameter("all_nom_topico")!=null&&req.getParameter("all_nom_topico").equalsIgnoreCase("s"),
        req.getParameter("op_num_resp"),
        req.getParameter("num_resp"),
        fecha1,fecha2,fecha3,fecha4);
      req.setAttribute("topicos_buscados", btops);
      return next;
    }
    catch (PersistException fe) {
      throw new CommandException("FindTopicsCommand: " + fe.getMessage());
    }
  }
}
