// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import javax.servlet.*;
import javax.servlet.http.*;
import com.netapplications.webforums_jsp.persist.*;
import com.netapplications.webforums_jsp.domain.Foro;
import com.netapplications.webforums_jsp.domain.VistaSuscripcion;

public class GetAllActiveSuscriptionsForumCommand extends Command {
  private String next;

  public GetAllActiveSuscriptionsForumCommand(String next) {
    this.next = next;
  }

  public String execute(HttpServletRequest req)
    throws CommandException {
    HttpSession session = req.getSession(true);
    try {
      int id_foro = Integer.parseInt(req.getParameter("id_foro"));
      ForoPersist fdb = ForoPersist.getInstance();
      VistaSuscripcionPersist vsdb = VistaSuscripcionPersist.getInstance();
      Foro forum = fdb.get(id_foro);
      req.setAttribute("foro", forum);
      VistaSuscripcion[] vsubscr = vsdb.getActivasForo(id_foro);
      req.setAttribute("suscripciones", vsubscr);
      return next;
    } catch (NumberFormatException e) {
      throw new CommandException("GetAllActiveSuscriptionsForumCommand: invalid ID");
    } catch (PersistException e) {
      throw new CommandException("GetAllActiveSuscriptionsForumCommand: " + e.getMessage());
    }
  }
}
