// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import javax.servlet.*;
import javax.servlet.http.*;
import com.netapplications.webforums_jsp.domain.Usuario;
import com.netapplications.webforums_jsp.domain.Foro;
import com.netapplications.webforums_jsp.domain.Suscripcion;
import com.netapplications.webforums_jsp.domain.VistaTopico;
import com.netapplications.webforums_jsp.persist.*;
import com.netapplications.webforums_jsp.types.*;
import java.util.Date;

public class GetAllTopicsOfForumCommand extends Command {
  private String next;
  private boolean navAction;

  public GetAllTopicsOfForumCommand(String next, boolean navAction) {
    this.next = next;
    this.navAction = navAction;
  }

  public GetAllTopicsOfForumCommand(String next) {
    this(next, false);
  }

  public String execute(HttpServletRequest req)
    throws CommandException {
    HttpSession session = req.getSession(true);
    try {
      ForoPersist fdb = ForoPersist.getInstance();
      int id_foro;
      if (navAction) {
        id_foro = Integer.parseInt(req.getParameter("nav_parameter_1"));
      } else {
        id_foro = Integer.parseInt(req.getParameter("id_foro"));
      }
      Foro forum = fdb.get(id_foro);
      req.setAttribute("foro", forum);
      VistaTopicoPersist vtdb = VistaTopicoPersist.getInstance();
      VistaTopico[] topics = vtdb.getTopicosForo(forum.getId_foro());
      req.setAttribute("topicos", topics);
      Date fec_ult_visita = new Date();
      String rolForo = Roles.NOT_LOGGED;
      if (session.getAttribute("usuario")!=null) {
        int id_usuario = ((Usuario) session.getAttribute("usuario")).getId_usuario();
        String rol = (String) session.getAttribute("role");
        Suscripcion suscrip = new Suscripcion();
        SuscripcionPersist sdb = SuscripcionPersist.getInstance();
        try {
          suscrip = sdb.get(forum.getId_foro(), id_usuario);
          fec_ult_visita = suscrip.getFecha_ultima_visita();
          rolForo = Roles.getSuscriptionRole(suscrip.getEstatus(), suscrip.getTipo());
          fdb.visitaForo(forum.getId_foro());
          sdb.visitaSuscripcion(forum.getId_foro(), id_usuario);
        } catch (UnknownPersistException notfound) {
          rolForo = Roles.NOT_MEMBER;
        }
        if (rol.equals(Roles.ADMINISTRATOR)) {
          if (rolForo.equals(Roles.NOT_MEMBER)) {
//          -----------------------------------------------------
//          si es un administrador y no era miembro se hace automaticamente la membresia
            suscrip.setEmail_anuncios(StrBoolean.FALSE);
            suscrip.setEmail_actualizaciones(StrBoolean.FALSE);
            suscrip.setEmail_nuevos(StrBoolean.FALSE);
            suscrip.setEnviar_mensajes(StrBoolean.FALSE);
            suscrip.setEstatus(Estatus.ACTIVO);
            suscrip.setFecha_ultima_visita(new Date());
            suscrip.setTipo(TipoDeSuscripcion.ADMIN_MODERADOR);
            suscrip.setId_foro(forum.getId_foro());
            suscrip.setId_usuario(id_usuario);
            sdb.put(suscrip);
//          -----------------------------------------------------
          }
          rolForo = rol;
        }
      }
      session.setAttribute("role", rolForo);
      if (rolForo.equals(Roles.NOT_LOGGED)) {
        req.setAttribute("webforums.hint", "You need to <A href=\"javascript:document.forma.cmd.value=\'go-login\';document.forma.submit();\">register</A> to be able to participate on this forum");
      } else if (rolForo.equals(Roles.NOT_MEMBER)) {
        req.setAttribute("webforums.hint", "You need to <A href=\"javascript:document.forma.cmd.value=\'go-subscribe\';document.forma.submit();\">subscribe</A> to be able to participate on this forum");
      } else if (rolForo.equals(Roles.SUSPENDED)) {
        req.setAttribute("webforums.hint", "Your subscription was suspended by one moderator of this forum");
      } else if (rolForo.equals(Roles.INACTIVE_MEMBER)) {
        req.setAttribute("webforums.hint", "You need to reactivate your subscription to be able to participate on this forum");
      }
      req.setAttribute("fec_ult_visita", fec_ult_visita);
      return next;
    }
    catch (NumberFormatException e) {
      throw new CommandException("GetAllTopicsOfForumCommand: invalid ID");
    }
    catch (PersistException e) {
      throw new CommandException("GetAllTopicsOfForumCommand: " + e.getMessage());
    }
  }
}
