// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import javax.servlet.*;
import javax.servlet.http.*;
import com.netapplications.webforums_jsp.persist.*;
import com.netapplications.webforums_jsp.domain.Suscripcion;
import com.netapplications.webforums_jsp.domain.Foro;
import com.netapplications.webforums_jsp.domain.Usuario;

public class GetForumSubscriptionCommand extends Command {
  private String next;

  public GetForumSubscriptionCommand(String next) {
    this.next = next;
  }

  public String execute(HttpServletRequest req)
    throws CommandException {
    HttpSession session = req.getSession(true);
    try {
      int id_foro = Integer.parseInt(req.getParameter("id_foro"));
      ForoPersist fdb = ForoPersist.getInstance();
      SuscripcionPersist sdb = SuscripcionPersist.getInstance();
      Foro forum = fdb.get(id_foro);
      req.setAttribute("foro", forum);
      Suscripcion subscr = new Suscripcion();
      try {
        subscr = sdb.get(id_foro, ((Usuario) session.getAttribute("usuario")).getId_usuario());
      } catch (UnknownPersistException notfound) {
      }
      req.setAttribute("suscripcion", subscr);
      return next;
    } catch (NumberFormatException e) {
      throw new CommandException("GetForumSubscriptionCommand: invalid ID");
    } catch (PersistException fe) {
      throw new CommandException("GetForumSubscriptionCommand: " + fe.getMessage());
    }
  }
}
