// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import javax.servlet.*;
import javax.servlet.http.*;
import com.netapplications.webforums_jsp.domain.Usuario;
import com.netapplications.webforums_jsp.persist.*;
import com.netapplications.webforums_jsp.types.*;

public class GetUserFromLoginCommand extends Command {

  private String nextLoginOK;
  private String nextLoginWrong;

  public GetUserFromLoginCommand(String nextLoginOK, String nextLoginWrong) {
    this.nextLoginOK = nextLoginOK;
    this.nextLoginWrong = nextLoginWrong;
  }

  public String execute(HttpServletRequest req)
    throws CommandException {
    HttpSession session = req.getSession(true);
    try {
      UsuarioPersist udb = UsuarioPersist.getInstance();
      Usuario user = udb.getUsuarioLogin(req.getParameter("nombre_corto"),req.getParameter("password"));
      session.setAttribute("usuario", user);
      if (user.getAdministrador().equals(StrBoolean.TRUE)) {
        session.setAttribute("role", Roles.ADMINISTRATOR);
      } else {
        session.setAttribute("role", Roles.NOT_MEMBER);
      }
      return nextLoginOK;
    } catch (UnknownPersistException e) {
      session.setAttribute("role", Roles.NOT_LOGGED);
      req.setAttribute("webforums.msg", e.getMessage());
      return nextLoginWrong;
    } catch (PersistException e) {
      throw new CommandException("GetUserFromLoginCommand: " + e.getMessage());
    }
  }
}
