// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import javax.servlet.*;
import javax.servlet.http.*;
import com.netapplications.webforums_jsp.domain.Usuario;
import com.netapplications.webforums_jsp.domain.PerfilUsuario;
import com.netapplications.webforums_jsp.persist.*;

public class GetUserProfileCommand extends Command {

  private String nextKnownUser;
  private String nextUnknownUser;

  public GetUserProfileCommand(String nextKnownUser, String nextUnknownUser) {
    this.nextKnownUser = nextKnownUser;
    this.nextUnknownUser = nextUnknownUser;
  }

  public String execute(HttpServletRequest req)
    throws CommandException {
    HttpSession session = req.getSession(true);
    PerfilUsuario perfil = new PerfilUsuario();
    if (req.getParameter("id_usuario")!=null || session.getAttribute("usuario")!=null) {
      try {
        int id_usuario = 0;
        if (req.getParameter("id_usuario")!=null) {
          id_usuario = Integer.parseInt(req.getParameter("id_usuario"));
          UsuarioPersist udb = UsuarioPersist.getInstance();
          req.setAttribute("usuario", udb.getUsuario(id_usuario));
        } else if (session.getAttribute("usuario")!=null) {
          id_usuario = ((Usuario) session.getAttribute("usuario")).getId_usuario();
          req.setAttribute("usuario", session.getAttribute("usuario"));
        }
        PerfilUsuarioPersist pudb = PerfilUsuarioPersist.getInstance();
        perfil = pudb.get(id_usuario);
      } catch (NumberFormatException e) {
        throw new CommandException("GetUserProfileCommand: invalid ID");
      } catch (UnknownPersistException e) {
        // Si no existe el perfil no importa
      } catch (PersistException e) {
        throw new CommandException("GetUserProfileCommand: " + e.getMessage());
      }
      req.setAttribute("profile", perfil);
      return nextKnownUser;
    } else {
      req.setAttribute("webforums.msg", "Unable to retrieve subscription of unknown user!");
      return nextUnknownUser;
    }
  }
}
