// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import java.util.StringTokenizer;
import com.netapplications.webforums_jsp.types.*;

public class Roles extends Object {
  public static final String NOT_LOGGED = "NL";
  public static final String SUSPENDED = "SU";
  public static final String NOT_MEMBER = "NM";
  public static final String INACTIVE_MEMBER = "IM";
  public static final String MEMBER = "ME";
  public static final String ADMIN_MODERATOR = "AM";
  public static final String MODERATOR = "MO";
  public static final String ADMINISTRATOR = "AD";

  public static boolean isMember(String currentRole) {
    return isEnough(MEMBER, currentRole);
  }

  public static boolean isModerator(String currentRole) {
    return isEnough(MODERATOR, currentRole);
  }

  public static boolean isAdminModerator(String currentRole) {
    return isEnough(ADMIN_MODERATOR, currentRole);
  }

  public static boolean isAdministrator(String currentRole) {
    return isEnough(ADMINISTRATOR, currentRole);
  }

  public static boolean isEnough(String neededRole, String currentRole) {
    if (neededRole.equals(currentRole)) {
      return true;
    } else if ((ADMINISTRATOR+ADMIN_MODERATOR+MODERATOR+MEMBER).indexOf(neededRole)>=0) {
      if (currentRole.equals(ADMINISTRATOR)) {
        return true;
      } else if (neededRole.equals(MODERATOR)) {
        return currentRole.equals(ADMIN_MODERATOR);
      } else if (neededRole.equals(MEMBER)) {
        return currentRole.equals(ADMIN_MODERATOR) || currentRole.equals(MODERATOR);
      } else {
        return false;
      }
    } else {
      return false;
    }
  }

  public static String getRolesListExcluding(String excList) {
    StringBuffer list = new StringBuffer(15);
    list.append(NOT_LOGGED);
    list.append(',');
    list.append(SUSPENDED);
    list.append(',');
    list.append(NOT_MEMBER);
    list.append(',');
    list.append(INACTIVE_MEMBER);
    list.append(',');
    list.append(MEMBER);
    list.append(',');
    list.append(ADMIN_MODERATOR);
    list.append(',');
    list.append(MODERATOR);
    list.append(',');
    list.append(ADMINISTRATOR);
    list.append(',');
    int pos;
    if (excList!=null && excList.length()>0) {
      StringTokenizer excludeTok = new StringTokenizer(excList,", ");
      String exclude;
      while (excludeTok.hasMoreTokens()) {
        exclude = excludeTok.nextToken();
        pos = list.toString().indexOf(exclude);
        if (pos>=0) {
          list.delete(pos,pos+3);
        }
      }
    }
    pos = list.length();
    if (pos>0) {
      list.delete(pos-1,list.length());
    }
    return list.toString();
  }

  public static String getSuscriptionRole(String Suscription_status, String Suscription_type) {
    if (Suscription_status==null || Suscription_type == null
        || Suscription_status.length()==0 || Suscription_type.length()==0) {
      return NOT_MEMBER;
    } else {
      if (Suscription_status.equalsIgnoreCase(Estatus.INACTIVO)) {
        return INACTIVE_MEMBER;
      } else if (Suscription_type.equalsIgnoreCase(TipoDeSuscripcion.ADMIN_MODERADOR)) {
        return ADMIN_MODERATOR;
      } else if (Suscription_type.equalsIgnoreCase(TipoDeSuscripcion.MODERADOR)) {
        return MODERATOR;
      } else if (Suscription_type.equalsIgnoreCase(TipoDeSuscripcion.NORMAL)) {
        return MEMBER;
      } else if (Suscription_type.equalsIgnoreCase(TipoDeSuscripcion.SUSPENDIDO)) {
        return SUSPENDED;
      } else {
        return NOT_MEMBER;
      }
    }
  }

  public static void main(String[] argc) {
    System.out.println(Roles.getRolesListExcluding("NL,SU,NM,AM,MO"));
  }
}