// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import com.netapplications.webforums_jsp.persist.*;
import com.netapplications.webforums_jsp.domain.Emoticon;

public class UpdEmoticonCommand extends Command {
  private String next;

  public UpdEmoticonCommand(String next) {
    this.next = next;
  }

  // Al finalizar la ejecucin de este comando
  // se deber actualizar el arreglo global de
  // foros de la aplicacin  
  public boolean globalObjectUpdated() {
    return true;
  }

  public String execute(HttpServletRequest req)
    throws CommandException {
    HttpSession session = req.getSession(true);
    if (!Roles.isAdministrator((String) session.getAttribute("role"))) {
      req.setAttribute("webforums.msg", "Need ADMIN privileges for this command");
    } else if (!CommandToken.isValid(req)) {
      req.setAttribute("webforums.msg", "Invalid Reload Attempted");
    } else {
      try {
        EmoticonPersist edb = EmoticonPersist.getInstance();
        Emoticon emoticon = new Emoticon();
        Enumeration paramNames = req.getParameterNames();
        while (paramNames.hasMoreElements()) {
          String parName = (String) paramNames.nextElement();
          if (parName.startsWith("upd_"))  {
            String otherName = "old_" + parName.substring(4);
            if (req.getParameter(otherName)!=null && !req.getParameter(parName).equals(req.getParameter(otherName))) {
              emoticon.setId_emoticon(Integer.parseInt(parName.substring(4)));
              emoticon.setUri(req.getParameter(parName));
              edb.update(emoticon);
            }
          } else if (parName.startsWith("new_") && req.getParameter(parName)!=null) {
            emoticon.setUri(req.getParameter(parName));
            if (emoticon.getUri().length()>0) {
              edb.put(emoticon);
            }
          }
        }
        req.setAttribute("webforums.msg", "Emoticon(s) added/updated");
      }
      catch (NumberFormatException e) {
        throw new CommandException("UpdEmoticonCommand: invalid ID");
      }
      catch (PersistException fe) {
        throw new CommandException("UpdEmoticonCommand: " + fe.getMessage());
      }
    }
    return next;
  }
}
