// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import javax.servlet.*;
import javax.servlet.http.*;
import java.util.Date;
import com.netapplications.webforums_jsp.persist.*;
import com.netapplications.webforums_jsp.domain.Suscripcion;
import com.netapplications.webforums_jsp.domain.Foro;
import com.netapplications.webforums_jsp.domain.Usuario;
import com.netapplications.webforums_jsp.types.*;

public class UpdForumSubscriptionCommand extends Command {
  private String next;

  public UpdForumSubscriptionCommand(String next) {
    this.next = next;
  }

  public String execute(HttpServletRequest req)
    throws CommandException {
    HttpSession session = req.getSession(true);
    int id_usuario;
    try {
      id_usuario = ((Usuario) session.getAttribute("usuario")).getId_usuario();
    } catch (Exception e) {
      id_usuario = 0;
    }
    String rol = (String) session.getAttribute("role");
    if (id_usuario == 0) {
      req.setAttribute("webforums.msg", "Not logged user can't subscribe!");
    } else if (!CommandToken.isValid(req)) {
      req.setAttribute("webforums.msg", "Invalid Reload Attempted");
    } else if (!((Usuario) session.getAttribute("usuario")).getPassword().equals(req.getParameter("password"))) {
      req.setAttribute("webforums.msg", "Invalid Password");
    } else {
      try {
        int id_foro = Integer.parseInt(req.getParameter("id_foro"));
        SuscripcionPersist sdb = SuscripcionPersist.getInstance();
        boolean newMember = false;
        Suscripcion subscr = new Suscripcion();
        try {
          subscr = sdb.get(id_foro, id_usuario);
        } catch (UnknownPersistException notfound) {
          subscr.setId_foro(id_foro);
          subscr.setId_usuario(id_usuario);
          subscr.setTipo(TipoDeSuscripcion.NORMAL);
          subscr.setFecha_ultima_visita(new Date());
          newMember = true;
        }
        if (req.getParameter("enviar_mensajes")!=null && req.getParameter("enviar_mensajes").equalsIgnoreCase("on")) {
          subscr.setEnviar_mensajes(StrBoolean.TRUE);
        } else {
          subscr.setEnviar_mensajes(StrBoolean.FALSE);
        }
        if (req.getParameter("email_actualizaciones")!=null && req.getParameter("email_actualizaciones").equalsIgnoreCase("on")) {
          subscr.setEmail_actualizaciones(StrBoolean.TRUE);
        } else {
          subscr.setEmail_actualizaciones(StrBoolean.FALSE);
        }
        if (req.getParameter("email_nuevos")!=null && req.getParameter("email_nuevos").equalsIgnoreCase("on")) {
          subscr.setEmail_nuevos(StrBoolean.TRUE);
        } else {
          subscr.setEmail_nuevos(StrBoolean.FALSE);
        }
        if (req.getParameter("email_anuncios")!=null && req.getParameter("email_anuncios").equalsIgnoreCase("on")) {
          subscr.setEmail_anuncios(StrBoolean.TRUE);
        } else {
          subscr.setEmail_anuncios(StrBoolean.FALSE);
        }
        if (req.getParameter("suspend")!=null && req.getParameter("suspend").equalsIgnoreCase("on")) {
          subscr.setEstatus(Estatus.INACTIVO);
        } else {
          subscr.setEstatus(Estatus.ACTIVO);
        }
        if (newMember) {
          sdb.put(subscr);
          req.setAttribute("webforums.msg", "Subscription created successfully!");
        } else {
          sdb.update(subscr);
          req.setAttribute("webforums.msg", "Subscription updated successfully!");
        }
      }
      catch (NumberFormatException e) {
        throw new CommandException("UpdForumSubscriptionCommand: invalid ID");
      }
      catch (PersistException	fe) {
        throw new CommandException("UpdForumSubscriptionCommand: " + fe.getMessage());
      }
    }
    GetAllTopicsOfForumCommand nextCmd = new GetAllTopicsOfForumCommand(next);
    return nextCmd.execute(req);
  }
}
