// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import javax.servlet.*;
import javax.servlet.http.*;
import com.netapplications.webforums_jsp.persist.*;
import com.netapplications.webforums_jsp.domain.Usuario;

public class UpdMessageContentCommand extends Command {
  private String nextThreadView;
  private String nextFlatView;

  public UpdMessageContentCommand(String nextThreadView, String nextFlatView) {
    this.nextThreadView = nextThreadView;
    this.nextFlatView = nextFlatView;
  }

  public String execute(HttpServletRequest req)
    throws CommandException {
      throw new CommandException("UpdMessageContentCommand: This call is not allowed");
  }

  public String execute(HttpServletRequest req, HttpServletResponse res)
    throws CommandException {
    HttpSession session = req.getSession(true);
    if (!Roles.isEnough(Roles.MODERATOR, (String) session.getAttribute("role"))) {
      req.setAttribute("webforums.msg", "Need MODERATOR privileges for this command");
    } else if (!CommandToken.isValid(req)) {
      req.setAttribute("webforums.msg", "Invalid Reload Attempted");
    } else if (req.getParameter("idlist")!=null) {
      try {
        MensajePersist mdb = MensajePersist.getInstance();
        mdb.updateContenidoMensaje(
          Integer.parseInt(req.getParameter("id_mensaje_original")),
          "***** Este mensaje fue modificado por el moderador "
          + ((Usuario) session.getAttribute("usuario")).getNombre_corto()
          + " *****\r\n" + req.getParameter("contenido_mensaje_original"));
        req.setAttribute("webforums.msg", "Message successfully updated");
      }
      catch (NumberFormatException e) {
        throw new CommandException("UpdMessageContentCommand: invalid ID");
      }
      catch (PersistException fe) {
        throw new CommandException("UpdMessageContentCommand: " + fe.getMessage());
      }
    }
    GetAllMessagesOfTopicCommand nextCmd = new GetAllMessagesOfTopicCommand(nextThreadView, nextFlatView);
    return nextCmd.execute(req, res);
  }
}
 