// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import javax.servlet.*;
import javax.servlet.http.*;
import java.util.StringTokenizer;
import com.netapplications.webforums_jsp.persist.*;

public class UpdSusbscriptionsTypeCommand extends Command {
  private String next;

  public UpdSusbscriptionsTypeCommand(String next) {
    this.next = next;
  }

  public String execute(HttpServletRequest req)
    throws CommandException {
    HttpSession session = req.getSession(true);
    if (!Roles.isEnough(Roles.MODERATOR, (String) session.getAttribute("role"))) {
      req.setAttribute("webforums.msg", "Need MODERATOR privileges for this command");
    } else if (!CommandToken.isValid(req)) {
      req.setAttribute("webforums.msg", "Invalid Reload Attempted");
    } else if (req.getParameter("upd_list")!=null && req.getParameter("upd_list").indexOf("-")>0) {
      //En este caso "-" no puede ser el primer caracter
      try {
        SuscripcionPersist sdb = SuscripcionPersist.getInstance();
        int id_forum = Integer.parseInt(req.getParameter("id_foro"));
        StringTokenizer updateList = new StringTokenizer(req.getParameter("upd_list"),",");
        while (updateList.hasMoreTokens()) {
          String token = updateList.nextToken();
          sdb.updateTipoSuscripcion(
            token.substring(token.indexOf("-")+1),
            id_forum,
            Integer.parseInt(token.substring(0,token.indexOf("-"))));
        }
        req.setAttribute("webforums.msg", "Members(s) updated");
      } catch (NumberFormatException e) {
        throw new CommandException("UpdSusbscriptionsTypeCommand: invalid ID");
      } catch (PersistException fe) {
        throw new CommandException("UpdSusbscriptionsTypeCommand: " + fe.getMessage());
      }
    }
    GetAllTopicsOfForumCommand nextCmd = new GetAllTopicsOfForumCommand(next);
    return nextCmd.execute(req);
  }
}
