// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import javax.servlet.*;
import javax.servlet.http.*;
import com.netapplications.webforums_jsp.domain.Usuario;
import com.netapplications.webforums_jsp.domain.PerfilUsuario;
import com.netapplications.webforums_jsp.persist.*;

public class UpdUserProfileCommand extends Command {

  private String next;

  public UpdUserProfileCommand(String next) {
    this.next = next;
  }

  public String execute(HttpServletRequest req)
    throws CommandException {
    HttpSession session = req.getSession(true);
    if (CommandToken.isValid(req)) {
      Usuario user;
      PerfilUsuario profile = new PerfilUsuario();
      if (session.getAttribute("usuario")!=null && ((Usuario) session.getAttribute("usuario")).getId_usuario()>0) {
        user = (Usuario) session.getAttribute("usuario");
      } else {
        throw new CommandException("UpdUserProfileCommand: User Session Lost");
      }
      int perfilusuario_id_usuario;
      try {
        perfilusuario_id_usuario = Integer.parseInt(req.getParameter("perfilusuario_id_usuario"));
      } catch (NumberFormatException e) {
        throw new CommandException("UpdUserProfileCommand: Invalid User Profile ID");
      }
      if (user.getPassword().equals(req.getParameter("old_password"))) {
        try {
          UsuarioPersist udb = UsuarioPersist.getInstance();
          user.setNombre_completo(req.getParameter("nombre_completo"));
          if (req.getParameter("password").length()>0) {
            user.setPassword(req.getParameter("password"));
          }
          user.setEmail(req.getParameter("email"));
          udb.update(user);
        } catch (PersistException e) {
          throw new CommandException("UpdUserProfileCommand: " + e.getMessage());
        }
        try {
          PerfilUsuarioPersist pudb = PerfilUsuarioPersist.getInstance();
          profile.setId_usuario(user.getId_usuario());
          profile.setTitulo(req.getParameter("titulo"));
          profile.setCompania(req.getParameter("compania"));
          profile.setDireccion1(req.getParameter("direccion1"));
          profile.setDireccion2(req.getParameter("direccion2"));
          profile.setCiudad(req.getParameter("ciudad"));
          profile.setEstado(req.getParameter("estado"));
          profile.setCp(req.getParameter("cp"));
          profile.setTelefono(req.getParameter("telefono"));
          profile.setUri(req.getParameter("uri"));
          if (user.getId_usuario()==perfilusuario_id_usuario) {
            pudb.update(profile);
          } else {
            pudb.put(profile);
          }
          session.setAttribute("usuario", user);
        } catch (PersistException e) {
          throw new CommandException("UpdUserProfileCommand: " + e.getMessage());
        }
      } else {
        req.setAttribute("webforums.msg", "Invalid Password");
      }
    } else {
      req.setAttribute("webforums.msg", "Invalid Reload Attempted");
    }
    return next;
  }
}
