
// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.domain;

import java.util.Date;
import java.io.Serializable;
import com.netapplications.webforums_jsp.types.*;

public class Foro extends Object implements Serializable {
  private int id_foro;
  private String nombre;
  private String descripcion;
  private String es_activo;
  private Date fecha_creacion;
  private int num_visitas;
  private Date fecha_ultima_visita;
  private int num_topicos;

  public Foro() {
    id_foro = 0;
    nombre = "";
    descripcion = "";
    es_activo = "";
    fecha_creacion = new Date();
    num_visitas = 0;
    fecha_ultima_visita = new Date();
    num_topicos = 0;
  }

  public synchronized int getId_foro() {
    return id_foro;
  }

  public synchronized void setId_foro(int newId_foro) {
    id_foro = newId_foro;
  }

  public synchronized String getNombre() {
    return nombre;
  }

  public synchronized void setNombre(String newNombre) {
    nombre = newNombre;
  }

  public synchronized String getDescripcion() {
    if (descripcion!=null) {
      return descripcion;
    } else {
      return "";
    }
  }

  public synchronized void setDescripcion(String newDescripcion) {
    descripcion = newDescripcion;
  }

  public synchronized String getEs_activo() {
    if (es_activo!= null && !es_activo.equals("")) {
      return es_activo;
    } else {
      return StrBoolean.FALSE;
    }
  }

  public synchronized void setEs_activo(String newEs_activo) {
    if (newEs_activo.equalsIgnoreCase(StrBoolean.TRUE)) {
      es_activo = StrBoolean.TRUE;
    } else {
      es_activo = StrBoolean.FALSE;
    }
  }

  public synchronized Date getFecha_creacion() {
    return fecha_creacion;
  }

  public synchronized void setFecha_creacion(Date newFecha_creacion) {
    fecha_creacion = newFecha_creacion;
  }

  public synchronized int getNum_visitas() {
    return num_visitas;
  }

  public synchronized void setNum_visitas(int newNum_visitas) {
    num_visitas = newNum_visitas;
  }

  public synchronized int getNum_topicos() {
    return num_topicos;
  }

  public synchronized void setNum_topicos(int newNum_topicos) {
    num_topicos = newNum_topicos;
  }

  public synchronized Date getFecha_ultima_visita() {
    return fecha_ultima_visita;
  }

  public synchronized void setFecha_ultima_visita(Date newFecha_ultima_visita) {
    fecha_ultima_visita = newFecha_ultima_visita;
  }
}
 