// Copyright (c) 2001 NetApplications
package com.netapplications.webforums_jsp.domain;

import java.util.Date;
import java.io.Serializable;
import com.netapplications.webforums_jsp.types.*;

public class Mensaje extends Object implements Serializable, IMensajeMinimo {
  private int id_mensaje;
  private int id_topico;
  private int id_mensaje_original;
  private String asunto;
  private String contenido;
  private int prioridad;
  private Date fecha_envio;
  private String envio_anonimo;
  private String estatus;
  private String incluir_original;
  private int id_foro;
  private int id_usuario;
  private int id_emoticon;
  private String nombre_autor;

  public Mensaje() {
  }

  public synchronized int getId_mensaje() {
    return id_mensaje;
  }

  public synchronized void setId_mensaje(int newId_mensaje) {
    id_mensaje = newId_mensaje;
  }

  public synchronized int getId_topico() {
    return id_topico;
  }

  public synchronized void setId_topico(int newId_topico) {
    id_topico = newId_topico;
  }

  public synchronized int getId_mensaje_original() {
    return id_mensaje_original;
  }

  public synchronized void setId_mensaje_original(int newId_mensaje_original) {
    id_mensaje_original = newId_mensaje_original;
  }

  public synchronized String getAsunto() {
    return asunto;
  }

  public synchronized void setAsunto(String newAsunto) {
    asunto = newAsunto;
  }

  public synchronized String getContenido() {
    return contenido;
  }

  public synchronized void setContenido(String newContenido) {
    contenido = newContenido;
  }

  public synchronized int getPrioridad() {
    return prioridad;
  }

  public synchronized void setPrioridad(int newPrioridad) {
    prioridad = newPrioridad;
  }

  public synchronized Date getFecha_envio() {
    return fecha_envio;
  }

  public synchronized void setFecha_envio(Date newFecha_envio) {
    fecha_envio = newFecha_envio;
  }

  public synchronized String getEnvio_anonimo() {
    if (envio_anonimo!= null) {
      return envio_anonimo;
    } else {
      return StrBoolean.FALSE;
    }
  }

  public synchronized void setEnvio_anonimo(String newEnvio_anonimo) {
    if (newEnvio_anonimo.toUpperCase().equals(StrBoolean.TRUE)) {
      envio_anonimo = StrBoolean.TRUE;
    } else {
      envio_anonimo = StrBoolean.FALSE;
    }
  }

  public synchronized String getEstatus() {
    if (estatus!= null) {
      return estatus;
    } else {
      return Estatus.INACTIVO;
    }
  }

  public synchronized void setEstatus(String newEstatus) {
    if (newEstatus.toUpperCase().equals(Estatus.ACTIVO)) {
      estatus = Estatus.ACTIVO;
    } else {
      estatus = Estatus.INACTIVO;
    }
  }

  public synchronized String getIncluir_original() {
    if (incluir_original!= null) {
      return incluir_original;
    } else {
      return StrBoolean.FALSE;
    }
  }

  public synchronized void setIncluir_original(String newIncluir_original) {
    if (newIncluir_original.toUpperCase().equals(StrBoolean.TRUE)) {
      incluir_original = StrBoolean.TRUE;
    } else {
      incluir_original = StrBoolean.FALSE;
    }
  }

  public synchronized int getId_foro() {
    return id_foro;
  }

  public synchronized void setId_foro(int newId_foro) {
    id_foro = newId_foro;
  }

  public synchronized int getId_usuario() {
    return id_usuario;
  }

  public synchronized void setId_usuario(int newId_usuario) {
    id_usuario = newId_usuario;
  }

  public synchronized int getId_emoticon() {
    return id_emoticon;
  }

  public synchronized void setId_emoticon(int newId_emoticon) {
    id_emoticon = newId_emoticon;
  }

  public synchronized String getNombre_autor() {
    return nombre_autor;
  }

  public synchronized void setNombre_autor(String newNombre_autor) {
    nombre_autor = newNombre_autor;
  }
}

