// Copyright (c) 2001 NetApplications
package com.netapplications.webforums_jsp.domain;

import java.util.Date;
import java.io.Serializable;
import com.netapplications.webforums_jsp.types.*;

public class Suscripcion extends Object implements Serializable {
  private String enviar_mensajes;
  private int id_usuario = 0;
  private int id_foro = 0;
  private String estatus;
  private String email_actualizaciones;
  private String email_nuevos;
  private String email_anuncios;
  private String tipo;
  private Date fecha_ultima_visita;

  public Suscripcion() {
  }

  public synchronized String getEnviar_mensajes() {
    if (enviar_mensajes!= null) {
      return enviar_mensajes;
    } else {
      return StrBoolean.FALSE;
    }
  }

  public synchronized void setEnviar_mensajes(String newEnviar_mensajes) {
    if (newEnviar_mensajes.toUpperCase().equals(StrBoolean.TRUE)) {
      enviar_mensajes = StrBoolean.TRUE;
    } else {
      enviar_mensajes = StrBoolean.FALSE;
    }
  }

  public synchronized int getId_usuario() {
    return id_usuario;
  }

  public synchronized void setId_usuario(int newId_usuario) {
    id_usuario = newId_usuario;
  }

  public synchronized int getId_foro() {
    return id_foro;
  }

  public synchronized void setId_foro(int newId_foro) {
    id_foro = newId_foro;
  }

  public synchronized String getEstatus() {
    if (estatus!= null) {
      return estatus;
    } else {
      return "";
    }
  }

  public synchronized void setEstatus(String newEstatus) {
    if (newEstatus.toUpperCase().equals(Estatus.ACTIVO)) {
      estatus = Estatus.ACTIVO;
    } else {
      estatus = Estatus.INACTIVO;
    }
  }


  public synchronized String getEmail_actualizaciones() {
    if (email_actualizaciones!= null) {
      return email_actualizaciones;
    } else {
      return StrBoolean.FALSE;
    }
  }

  public synchronized void setEmail_actualizaciones(String newEmail_actualizaciones) {
    if (newEmail_actualizaciones.toUpperCase().equals(StrBoolean.TRUE)) {
      email_actualizaciones = StrBoolean.TRUE;
    } else {
      email_actualizaciones = StrBoolean.FALSE;
    }
  }

  public synchronized String getEmail_nuevos() {
    if (email_nuevos!= null) {
      return email_nuevos;
    } else {
      return StrBoolean.FALSE;
    }
  }

  public synchronized void setEmail_nuevos(String newEmail_nuevos) {
    if (newEmail_nuevos.toUpperCase().equals(StrBoolean.TRUE)) {
      email_nuevos = StrBoolean.TRUE;
    } else {
      email_nuevos = StrBoolean.FALSE;
    }
  }

  public synchronized String getEmail_anuncios() {
    if (email_anuncios!= null) {
      return email_anuncios;
    } else {
      return StrBoolean.FALSE;
    }
  }

  public synchronized void setEmail_anuncios(String newEmail_anuncios) {
    if (newEmail_anuncios.toUpperCase().equals(StrBoolean.TRUE)) {
      email_anuncios = StrBoolean.TRUE;
    } else {
      email_anuncios = StrBoolean.FALSE;
    }
  }

  public synchronized String getTipo() {
    if (tipo!= null) {
      return tipo;
    } else {
      return TipoDeSuscripcion.NORMAL;
    }
  }

  public synchronized void setTipo(String newTipo) {
    if (newTipo.toUpperCase().equals(TipoDeSuscripcion.ADMIN_MODERADOR) ||
        newTipo.toUpperCase().equals(TipoDeSuscripcion.MODERADOR) ||
        newTipo.toUpperCase().equals(TipoDeSuscripcion.SUSPENDIDO)) {
      tipo = newTipo;
    } else {
      tipo = TipoDeSuscripcion.NORMAL;
    }
  }

  public synchronized Date getFecha_ultima_visita() {
    return fecha_ultima_visita;
  }

  public synchronized void setFecha_ultima_visita(Date newFecha_ultima_visita) {
    fecha_ultima_visita = newFecha_ultima_visita;
  }
}

