// Copyright (c) 2001 NetApplications
package com.netapplications.webforums_jsp.domain;

import java.util.Date;
import java.io.Serializable;
import com.netapplications.webforums_jsp.types.*;

public class Usuario extends Object implements Serializable {

  private int id_usuario;
  private String nombre_corto;
  private String nombre_completo;
  private String password;
  private String email;
  private String estatus;
  private Date fecha_registro;
  private Date fecha_ultimo_acceso;
  private String administrador;

  public Usuario() {
    id_usuario = 0;
    nombre_corto = "";
    nombre_completo = "";
    password = "";
    email = "";
    estatus = Estatus.ACTIVO;
    fecha_registro = new Date();
    fecha_ultimo_acceso = new Date();
    administrador = StrBoolean.FALSE;
  }

  public synchronized int getId_usuario() {
    return id_usuario;
  }

  public synchronized void setId_usuario(int newId_usuario) {
    id_usuario = newId_usuario;
  }

  public synchronized String getNombre_corto() {
    return nombre_corto;
  }

  public synchronized void setNombre_corto(String newNombre_corto) {
    nombre_corto = newNombre_corto;
  }

  public synchronized String getNombre_completo() {
    return nombre_completo;
  }

  public synchronized void setNombre_completo(String newNombre_completo) {
    nombre_completo = newNombre_completo;
  }

  public synchronized String getPassword() {
    return password;
  }

  public synchronized void setPassword(String newPassword) {
    password = newPassword;
  }

  public synchronized String getEmail() {
    return email;
  }

  public synchronized String getEmail_nombreCorto() {
    if (email!=null
        && email.indexOf("@")>0
        && email.indexOf("@")<email.length()-1) {
      return "<a href=\"mailto:" + email + "\">" + nombre_corto + "</a>";
    } else {
      return nombre_corto;
    }
  }

  public synchronized void setEmail(String newEmail) {
    email = newEmail;
  }

  public synchronized String getEstatus() {
    return estatus;
  }

  public synchronized void setEstatus(String newEstatus) {
    if (newEstatus.toUpperCase().equals(Estatus.ACTIVO)) {
      estatus = Estatus.ACTIVO;
    } else {
      estatus = Estatus.INACTIVO;
    }
  }

  public synchronized Date getFecha_registro() {
    return fecha_registro;
  }

  public synchronized void setFecha_registro(Date newFecha_registro) {
    fecha_registro = newFecha_registro;
  }

  public synchronized Date getFecha_ultimo_acceso() {
    return fecha_ultimo_acceso;
  }

  public synchronized void setFecha_ultimo_acceso(Date newFecha_ultimo_acceso) {
    fecha_ultimo_acceso = newFecha_ultimo_acceso;
  }

  public synchronized void setAdministrador(String newAdministrador) {
    if (newAdministrador.equalsIgnoreCase(StrBoolean.TRUE)) {
      administrador = StrBoolean.TRUE;
    } else {
      administrador = StrBoolean.FALSE;
    }
  }

  public synchronized String getAdministrador() {
    return administrador;
  }
}
