 // Copyright (c) 2001 NetApplications
package com.netapplications.webforums_jsp.domain;

import java.util.Date;
import java.io.Serializable;
import com.netapplications.webforums_jsp.util.StringUtils;

public class VistaMensaje extends Object implements Serializable, IMensajeMinimo {

  private int id_mensaje;
  private int id_mensaje_original;
  private String asunto;
  private String contenido;
  private int prioridad;
  private Date fecha_envio;
  private String envio_anonimo;
  private String estatus_mensaje;
  private String incluir_original;
  private int id_usuario;
  private String nombre_usuario;
  private String email_usuario;
  private int id_emoticon;
  private String nombre_autor;
  private String uri_attachment;
  private String nombre_topico;

  public VistaMensaje() {
  }

  public synchronized int getId_mensaje() {
    return id_mensaje;
  }

  public synchronized void setId_mensaje(int newId_mensaje) {
    id_mensaje = newId_mensaje;
  }

  public synchronized int getId_mensaje_original() {
    return id_mensaje_original;
  }

  public synchronized void setId_mensaje_original(int newId_mensaje_original) {
    id_mensaje_original = newId_mensaje_original;
  }

  public synchronized String getAsunto() {
    return asunto;
  }

  public synchronized void setAsunto(String newAsunto) {
    asunto = newAsunto;
  }

  public synchronized String getContenido() {
    return contenido;
  }

  public synchronized void setContenido(String newContenido) {
    contenido = newContenido;
  }

  public synchronized int getPrioridad() {
    return prioridad;
  }

  public synchronized void setPrioridad(int newPrioridad) {
    prioridad = newPrioridad;
  }

  public synchronized Date getFecha_envio() {
    return fecha_envio;
  }

  public synchronized void setFecha_envio(Date newFecha_envio) {
    fecha_envio = newFecha_envio;
  }

  public synchronized String getEnvio_anonimo() {
    return envio_anonimo;
  }

  public synchronized void setEnvio_anonimo(String newEnvio_anonimo) {
    envio_anonimo = newEnvio_anonimo;
  }

  public synchronized String getEstatus_mensaje() {
    return estatus_mensaje;
  }

  public synchronized void setEstatus_mensaje(String newEstatus_mensaje) {
    estatus_mensaje = newEstatus_mensaje;
  }

  public synchronized String getIncluir_original() {
    return incluir_original;
  }

  public synchronized void setIncluir_original(String newIncluir_original) {
    incluir_original = newIncluir_original;
  }

  public synchronized int getId_usuario() {
    return id_usuario;
  }

  public synchronized void setId_usuario(int newId_usuario) {
    id_usuario = newId_usuario;
  }

  public synchronized String getNombre_usuario() {
    return nombre_usuario;
  }

  public synchronized void setNombre_usuario(String newNombre_usuario) {
    nombre_usuario = newNombre_usuario;
  }

  public synchronized String getEmail_usuario() {
    return email_usuario;
  }

  public synchronized String getEmail_nombre_usuario() {
    if (email_usuario!=null
        && email_usuario.indexOf("@")>0
        && email_usuario.indexOf("@")<email_usuario.length()-1) {
      return "<a href=\"mailto:" + StringUtils.HTMLEncode(email_usuario) + "\">" + StringUtils.HTMLEncode(nombre_usuario) + "</a>";
    } else {
      return nombre_usuario;
    }
  }

  public synchronized String getEmail_nombre_usuario_subject() {
    if (email_usuario!=null
        && email_usuario.indexOf("@")>0
        && email_usuario.indexOf("@")<email_usuario.length()-1) {
      return "<a href=\"mailto:" + StringUtils.HTMLEncode(email_usuario + "?Subject=Re: " + asunto) + "\">"
         + StringUtils.HTMLEncode(nombre_usuario) + "</a>";
    } else {
      return nombre_usuario;
    }
  }

  public synchronized void setEmail_usuario(String newEmail_usuario) {
    email_usuario = newEmail_usuario;
  }

  public synchronized int getId_emoticon() {
    return id_emoticon;
  }

  public synchronized void setId_emoticon(int newId_emoticon) {
    id_emoticon = newId_emoticon;
  }

  public synchronized String getNombre_autor() {
    if (nombre_autor==null) {
      return "";
    } else {
      return nombre_autor;
    }
  }

  public synchronized void setNombre_autor(String newNombre_autor) {
    nombre_autor = newNombre_autor;
  }

  public synchronized String getUri_attachment() {
    if (uri_attachment==null) {
      return "";
    } else {
      return uri_attachment;
    }
  }

  public synchronized void setUri_attachment(String newUri_attachment) {
    uri_attachment = newUri_attachment;
  }

  public synchronized String getNombre_topico() {
    return nombre_topico;
  }

  public synchronized void setNombre_topico(String newNombre_topico) {
    nombre_topico = newNombre_topico;
  }
}
