// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.domain;

import java.util.Date;
import java.io.Serializable;
import com.netapplications.webforums_jsp.types.*;

public class VistaSuscripcion extends Object implements Serializable {

  private int id_usuario = 0;
  private String nombre_corto_usuario;
  private String nombre_completo_usuario;
  private String email_usuario;
  private int id_foro = 0;
  private String estatus;
  private String email_actualizaciones;
  private String email_nuevos;
  private String email_anuncios;
  private String tipo;
  private Date fecha_ultima_visita;
  private String enviar_mensajes;

  public VistaSuscripcion() {
  }

  public synchronized int getId_usuario() {
    return id_usuario;
  }

  public synchronized void setId_usuario(int newId_usuario) {
    id_usuario = newId_usuario;
  }

  public synchronized String getNombre_corto_usuario() {
    return nombre_corto_usuario;
  }

  public synchronized void setNombre_corto_usuario(String newNombre_corto_usuario) {
    nombre_corto_usuario = newNombre_corto_usuario;
  }

  public synchronized String getNombre_completo_usuario() {
    return nombre_completo_usuario;
  }

  public synchronized void setNombre_completo_usuario(String newNombre_completo_usuario) {
    nombre_completo_usuario = newNombre_completo_usuario;
  }

  public synchronized String getEmail_usuario() {
    return email_usuario;
  }

  public synchronized String getEmail_nombre_usuario() {
    if (email_usuario!=null
        && email_usuario.indexOf("@")>0
        && email_usuario.indexOf("@")<email_usuario.length()-1) {
      return "<a href=\"mailto:" + email_usuario + "\">" + nombre_corto_usuario + "</a>";
    } else {
      return nombre_corto_usuario;
    }
  }

  public synchronized void setEmail_usuario(String newEmail_usuario) {
    email_usuario = newEmail_usuario;
  }

  public synchronized int getId_foro() {
    return id_foro;
  }

  public synchronized void setId_foro(int newId_foro) {
    id_foro = newId_foro;
  }

  public synchronized String getEstatus() {
    if (email_actualizaciones!= null) {
      return estatus;
    } else {
      return "";
    }
  }

  public synchronized void setEstatus(String newEstatus) {
    if (newEstatus.toUpperCase().startsWith(Estatus.ACTIVO)) {
      estatus = Estatus.ACTIVO;
    } else {
      estatus = Estatus.INACTIVO;
    }
  }

  public synchronized String getEmail_actualizaciones() {
    if (email_actualizaciones!= null) {
      return email_actualizaciones;
    } else {
      return StrBoolean.FALSE;
    }
  }

  public synchronized void setEmail_actualizaciones(String newEmail_actualizaciones) {
    if (newEmail_actualizaciones.toUpperCase().startsWith(StrBoolean.TRUE)) {
      email_actualizaciones = StrBoolean.TRUE;
    } else {
      email_actualizaciones = StrBoolean.FALSE;
    }
  }

  public synchronized String getEmail_nuevos() {
    if (email_nuevos!= null) {
      return email_nuevos;
    } else {
      return StrBoolean.FALSE;
    }
  }

  public synchronized void setEmail_nuevos(String newEmail_nuevos) {
    if (newEmail_nuevos.toUpperCase().startsWith(StrBoolean.TRUE)) {
      email_nuevos = StrBoolean.TRUE;
    } else {
      email_nuevos = StrBoolean.FALSE;
    }
  }

  public synchronized String getEmail_anuncios() {
    if (email_anuncios!= null) {
      return email_anuncios;
    } else {
      return StrBoolean.FALSE;
    }
  }

  public synchronized void setEmail_anuncios(String newEmail_anuncios) {
    if (newEmail_anuncios.toUpperCase().startsWith(StrBoolean.TRUE)) {
      email_anuncios = StrBoolean.TRUE;
    } else {
      email_anuncios = StrBoolean.FALSE;
    }
  }

  public synchronized String getTipo() {
    if (tipo!= null) {
      return tipo;
    } else {
      return TipoDeSuscripcion.NORMAL;
    }
  }

  public synchronized void setTipo(String newTipo) {
    if (newTipo.equalsIgnoreCase(TipoDeSuscripcion.SUSPENDIDO) ||
        newTipo.equalsIgnoreCase(TipoDeSuscripcion.MODERADOR) ||
        newTipo.equalsIgnoreCase(TipoDeSuscripcion.ADMIN_MODERADOR)) {
      tipo = newTipo;
    } else {
      tipo = TipoDeSuscripcion.NORMAL;
    }
  }

  public synchronized Date getFecha_ultima_visita() {
    return fecha_ultima_visita;
  }

  public synchronized void setFecha_ultima_visita(Date newFecha_ultima_visita) {
    fecha_ultima_visita = newFecha_ultima_visita;
  }

  public synchronized String getEnviar_mensajes() {
    if (enviar_mensajes!= null) {
      return enviar_mensajes;
    } else {
      return StrBoolean.FALSE;
    }
  }

  public synchronized void setEnviar_mensajes(String newEnviar_mensajes) {
    if (newEnviar_mensajes.toUpperCase().startsWith(StrBoolean.TRUE)) {
      enviar_mensajes = StrBoolean.TRUE;
    } else {
      enviar_mensajes = StrBoolean.FALSE;
    }
  }
}
