// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.persist;

import java.sql.*;
import com.netapplications.webforums_jsp.util.Settings;

public class MensajeIDGenerator {
  private int increment = 1;
  private int max = 0;
  private int currentID = 0;

  private Connection connection;
  private static MensajeIDGenerator instance;
  private PreparedStatement updSurrogateStmt;
  private PreparedStatement getSurrogateStmt;

  public static MensajeIDGenerator getInstance() throws PersistException {
    if (instance == null) {
      instance = new MensajeIDGenerator();
    }
    return instance;
  }

  private synchronized void parseStatements() throws SQLException {
    getSurrogateStmt = connection.prepareStatement(Settings.get("sql.MensajeIDGenerator.get"));
    updSurrogateStmt = connection.prepareStatement(Settings.get("sql.MensajeIDGenerator.upd"));
  }

  private MensajeIDGenerator() throws PersistException {
    try {
      connection = ConnectionPool.get();
      parseStatements();
      ConnectionPool.free(connection);
    }
    catch (SQLException se) {
      throw new PersistException("MensajeIDGenerator [MensajeIDGenerator()]: " + se.getMessage());
    }
  }

  public synchronized int getNextID() throws PersistException {
  	if (++currentID > max) {
      Connection confrompool = null;
      try {
        confrompool = ConnectionPool.get();
        if (confrompool != connection) {
          synchronized (connection) {
            connection = confrompool;
          }
          parseStatements();
        }
        synchronized(updSurrogateStmt) {
          updSurrogateStmt.clearParameters();
          updSurrogateStmt.setInt(1, increment);
          int rowsChanged = updSurrogateStmt.executeUpdate();
          if (rowsChanged < 1) {
            throw new UnknownPersistException("MensajeIDGenerator (getNextID()): " + " Failed to update Surrogates");
          }
        }
        synchronized (getSurrogateStmt) {
          ResultSet results = getSurrogateStmt.executeQuery();
          if (results.next()) {
            currentID = results.getInt("NEXTIDSET") - increment;
            max = currentID + increment -1;
          } else {
            throw new UnknownPersistException("MensajeIDGenerator [getNextID()]: " + " Failed to read Surrogates");
          }
        }
      } catch (SQLException e) {
        throw new PersistException("MensajeIDGenerator [getNextID()]: " + e.getMessage());
      }
      finally {
        if (confrompool!=null) {
          ConnectionPool.free(confrompool);
        }
      }
    }
	  return currentID;
  }
}
