// Copyright (c) 2001 NetApplications
package com.netapplications.webforums_jsp.persist;

import java.sql.*;
import java.util.*;
import com.netapplications.webforums_jsp.domain.VistaBusquedaMensaje;
import com.netapplications.webforums_jsp.util.Settings;

public class VistaBusquedaMensajePersist extends Object {

  private static VistaBusquedaMensajePersist instance;

  private Connection connection;

  public static VistaBusquedaMensajePersist getInstance()
    throws PersistException {
    if (instance == null)
      instance = new VistaBusquedaMensajePersist();
    return instance;
  }

  private VistaBusquedaMensajePersist() throws PersistException {
  }

  private VistaBusquedaMensaje makeVistaBusquedaMensaje(ResultSet results)
    throws PersistException {
    try {
      VistaBusquedaMensaje vbMensaje = new VistaBusquedaMensaje();
      vbMensaje.setId_foro(results.getInt("ID_FORO"));
      vbMensaje.setNombre_foro(results.getString("NOMBRE_FORO"));
      vbMensaje.setId_usuario(results.getInt("ID_USUARIO"));
      vbMensaje.setNombre_usuario(results.getString("NOMBRE_USUARIO"));
      vbMensaje.setId_topico(results.getInt("ID_TOPICO"));
      vbMensaje.setNombre_topico(results.getString("NOMBRE_TOPICO"));
      vbMensaje.setId_mensaje(results.getInt("ID_MENSAJE"));
      vbMensaje.setAsunto(results.getString("ASUNTO"));
      vbMensaje.setEnvio_anonimo(results.getString("ENVIO_ANONIMO"));
      vbMensaje.setNombre_autor(results.getString("NOMBRE_AUTOR"));
      vbMensaje.setFecha_envio((java.util.Date) results.getTimestamp("FECHA_ENVIO"));
      return vbMensaje;
    }
    catch (SQLException e) {
      throw new PersistException("VistaBusquedaMensajePersist [makeVistaBusquedaMensaje()]: " + e.getMessage());
    }
  }

  public VistaBusquedaMensaje[] findMensajes(String autor, int prioridad,
        String asunto, boolean all_asunto, String contenido, boolean all_contenido,
        java.util.Date fecha_inicial, java.util.Date fecha_final)
      throws PersistException {
    StringBuffer query = new StringBuffer(400);
    query.append(Settings.get("sql.VistaBusquedaMensajePersist.part1"));
    query.append(' ');
    if (autor!=null && autor.length()>0) {
      query.append(Settings.get("sql.VistaBusquedaMensajePersist.part2"));
      query.append(autor);
      query.append(Settings.get("sql.VistaBusquedaMensajePersist.part3"));
      query.append(' ');
    }
    if (prioridad>0) {
      query.append(Settings.get("sql.VistaBusquedaMensajePersist.part4"));
      query.append(prioridad);
      query.append(' ');
    }
    if (asunto!=null && asunto.length()>0) {
      StringTokenizer asuntos = new StringTokenizer(asunto,", ");
      if (!all_asunto) {
        query.append(Settings.get("sql.VistaBusquedaMensajePersist.part5"));
      }
      boolean putAndOr = false;
      while (asuntos.hasMoreTokens()) {
        if (all_asunto) {
          query.append(Settings.get("sql.VistaBusquedaMensajePersist.part6"));
          query.append(' ');
        } else {
          if (putAndOr) {
            query.append(Settings.get("sql.VistaBusquedaMensajePersist.part7"));
            query.append(' ');
          } else {
            putAndOr = true;
          }
        }
        query.append(Settings.get("sql.VistaBusquedaMensajePersist.part8"));
        query.append(asuntos.nextToken().toUpperCase());
        query.append(Settings.get("sql.VistaBusquedaMensajePersist.part9"));
        query.append(' ');
      }
      if (!all_asunto) {
        query.append(Settings.get("sql.VistaBusquedaMensajePersist.part10"));
        query.append(' ');
      }
    }
    if (contenido!=null && contenido.length()>0) {
      StringTokenizer contenidos = new StringTokenizer(contenido,", ");
      if (!all_contenido) {
        query.append(Settings.get("sql.VistaBusquedaMensajePersist.part5"));
      }
      boolean putAndOr = false;
      while (contenidos.hasMoreTokens()) {
        if (all_contenido) {
          query.append(Settings.get("sql.VistaBusquedaMensajePersist.part6"));
          query.append(' ');
        } else {
          if (putAndOr) {
            query.append(Settings.get("sql.VistaBusquedaMensajePersist.part7"));
            query.append(' ');
          } else {
            putAndOr = true;
          }
        }
        query.append(Settings.get("sql.VistaBusquedaMensajePersist.part11"));
        query.append(contenidos.nextToken().toUpperCase());
        query.append(Settings.get("sql.VistaBusquedaMensajePersist.part9"));
        query.append(' ');
      }
      if (!all_contenido) {
        query.append(Settings.get("sql.VistaBusquedaMensajePersist.part10"));
        query.append(' ');
      }
    }
    if (fecha_inicial!=null) {
      query.append(Settings.get("sql.VistaBusquedaMensajePersist.part12"));
      query.append(' ');
    }
    if (fecha_final!=null) {
      query.append(Settings.get("sql.VistaBusquedaMensajePersist.part13"));
      query.append(' ');
    }
    try {
      connection = ConnectionPool.get();
      PreparedStatement findMensajes = connection.prepareStatement(query.toString());
      if (fecha_inicial!=null) {
        findMensajes.setTimestamp(1, new java.sql.Timestamp(fecha_inicial.getTime()));
      }
      if (fecha_final!=null) {
        findMensajes.setTimestamp((fecha_inicial!=null)?2:1, new java.sql.Timestamp(fecha_final.getTime()));
      }
      ResultSet results = findMensajes.executeQuery();
      Collection vbMensajes = new ArrayList();
      while (results.next()) {
        vbMensajes.add(makeVistaBusquedaMensaje(results));
      }
      return (VistaBusquedaMensaje[])vbMensajes.toArray(new VistaBusquedaMensaje[0]);
    } catch (SQLException e) {
      throw new UnknownPersistException("VistaBusquedaMensajePersist [findMensajes()]: " + e.getMessage()
        + " \r\n{" + query.toString() + "}");
    } catch (Exception e) {
      throw new PersistException("VistaBusquedaMensajePersist [findMensajes()]: " + e.getMessage()
        + " \r\n{" + query.toString() + "}");
    } finally {
      if (connection != null) {
        ConnectionPool.free(connection);
      }
    }
  }

  public static void main(String[] argc) {
    try {
      VistaBusquedaMensajePersist tmdb = VistaBusquedaMensajePersist.getInstance();
    }
    catch (Exception e) {System.out.println(e.getMessage());}
  }
}

