// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.servlets;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import com.netapplications.webforums_jsp.persist.*;
import com.netapplications.webforums_jsp.domain.*;
import com.netapplications.webforums_jsp.types.*;
import com.netapplications.webforums_jsp.util.*;

public class AddMessageServlet extends HttpServlet {

  public void init(ServletConfig config) throws ServletException {
    super.init(config);
  }

  /**
   * Get Servlet information
   * @return java.lang.String
   */
  public String getServletInfo() {
    return "com.netapplications.jforums.AddMessageServlet Information";
  }

  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    RequestDispatcher rd;
    rd = getServletContext().getRequestDispatcher(Settings.get("servlet.mainServletAlias"));
    rd.forward(request, response);
  }

  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException {
    HttpSession session = request.getSession(true);
    Mensaje message = new Mensaje();
    try {
      ParseMultiForm pmf = new ParseMultiForm(request);
      String param;
      String value;
      boolean responderTopico = false;
      File attach = null;
      int id_topico = 0;
      int id_mensaje = 1000;
      String fname = "";
      String cmd = "";
      String page = "1";
      String requestToken = "";
      while ( (param = pmf.getNextParameter()) != null ){
        if (param.equalsIgnoreCase("cmd")){
          cmd = pmf.getParameter();
        } else if (param.equalsIgnoreCase("token")){
          requestToken = pmf.getParameter();
        } else if (param.equalsIgnoreCase("page")){
          page = pmf.getParameter();
        } else if (param.equalsIgnoreCase("id_topico")){
          message.setId_topico(Integer.parseInt(pmf.getParameter()));
        } else if (param.equalsIgnoreCase("responder_topico")){
          value = pmf.getParameter();
          responderTopico = value!=null && value.equalsIgnoreCase("on");
        } else if (param.equalsIgnoreCase("id_mensaje_original")){
          try {
            message.setId_mensaje_original(Integer.parseInt(pmf.getParameter()));
          } catch (NumberFormatException e) {
            message.setId_mensaje_original(0);
          }
        } else if (param.equalsIgnoreCase("asunto")){
          message.setAsunto(pmf.getParameter());
        } else if (param.equalsIgnoreCase("contenido")){
          message.setContenido(pmf.getParameter(true));
        } else if (param.equalsIgnoreCase("prioridad")){
          message.setPrioridad(Integer.parseInt(pmf.getParameter()));
        } else if (param.equalsIgnoreCase("incluir_original")){
          value = pmf.getParameter();
          if (value!=null && value.equals("on")) {
            message.setIncluir_original(StrBoolean.TRUE);
          } else {
            message.setIncluir_original(StrBoolean.FALSE);
          }
        } else if (param.equalsIgnoreCase("id_foro")){
          message.setId_foro(Integer.parseInt(pmf.getParameter()));
        } else if (param.equalsIgnoreCase("id_emoticon")){
          message.setId_emoticon(Integer.parseInt(pmf.getParameter()));
        } else if (param.equalsIgnoreCase("attachment")){
          fname = pmf.getFilename();
          if (fname!=null) {
            attach = File.createTempFile("wfa",".tmp",
              new File(Settings.get("servlet.attachmentRealPath")));
            FileOutputStream OutFile = new FileOutputStream(attach);
            pmf.getParameter( OutFile );
            OutFile.close();
          }
        }
      }
      if (requestToken.equals((String)session.getAttribute("token"))) {
        if (responderTopico || message.getId_topico()==0) {
          message.setId_mensaje_original(0);
        }
        message.setFecha_envio(new Date());
//        message.setEnvio_anonimo(req.getParameter("envio_anonimo"));
        message.setEnvio_anonimo(StrBoolean.FALSE);
        message.setEstatus(Estatus.ACTIVO);
//        message.setNombre_autor(req.getParameter("nom_autor"));
        message.setNombre_autor(null);
        message.setId_usuario(((Usuario) session.getAttribute("usuario")).getId_usuario());
        TopicoPersist tdb =  TopicoPersist.getInstance();
        MensajePersist mdb =  MensajePersist.getInstance();
        if (message.getId_topico()==0) {
          Topico topic = new Topico();
          topic.setId_foro(message.getId_foro());
          topic.setId_usuario(message.getId_usuario());
          topic.setNombre(message.getAsunto());
          topic.setFecha_creacion(message.getFecha_envio());
          topic.setNum_respuestas(0);
          topic.setFecha_ultimo_mensaje(null);
          tdb.put(topic);
          message.setId_topico(topic.getId_topico());
        }
        mdb.put(message);
        Mailman.sendMessage(message.getId_mensaje());
        request.setAttribute("webforums.msg", "Post Success!");
        if (attach!=null) {
          String partialPath = message.getId_foro() + "/" + message.getId_topico()
            + "/" + message.getId_mensaje() + "/";
          Attachment attBean = new Attachment();
          attBean.setId_mensaje(message.getId_mensaje());
          attBean.setUri(partialPath + fname);
          mdb.putAttachment(attBean);
          File attPath = new File(Settings.get("servlet.attachmentRealPath") + partialPath);
          attPath.mkdirs();
          attach.renameTo(new File(Settings.get("servlet.attachmentRealPath") + partialPath + StringUtils.validAttahcmentName(fname)));
        }
      } else {
        if (attach!=null) {
          attach.delete();
        }
        request.setAttribute("webforums.msg", "Invalid Reload Attempted");
      }
      RequestDispatcher rd;
      rd = getServletContext().getRequestDispatcher(Settings.get("servlet.mainServletAlias") + "?cmd="
        + cmd + "&id_foro=" + message.getId_foro() + "&id_topico=" + message.getId_topico()
        + "&page=" + page);
      rd.forward(request, response);
    } catch (PersistException e) {
      RequestDispatcher rd;
      request.setAttribute("javax.servlet.jsp.jspException", e);
      rd = getServletContext().getRequestDispatcher(Settings.get("servlet.jspDir") + Settings.get("servlet.errorPage"));
      try {
        rd.forward(request, response);
      } catch (IOException ioe) {
        throw new ServletException(e.getMessage());
      }
    } catch (IOException e) {
      RequestDispatcher rd;
      request.setAttribute("javax.servlet.jsp.jspException", e);
      rd = getServletContext().getRequestDispatcher(Settings.get("servlet.jspDir") + Settings.get("servlet.errorPage"));
      try {
        rd.forward(request, response);
      } catch (IOException ioe) {
        throw new ServletException(e.getMessage());
      }
    }
  }
}

