package com.netapplications.webforums_jsp.servlets;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import com.netapplications.webforums_jsp.util.Settings;
import com.netapplications.webforums_jsp.util.StringUtils;
import com.netapplications.webforums_jsp.util.FileUtils;

public class TestFileSys extends HttpServlet {

  public void init(ServletConfig config) throws ServletException {
    super.init(config);
    initSettings();
  }

  private synchronized void initSettings() throws ServletException {
    String path = getServletContext().getInitParameter("webforumsConfigFile");
    try {
      Settings.getInstance().load(path);
    } catch (IOException e) {
      throw new ServletException("initSettings: " + e.getMessage() + " {" + path + "}");
    }
  }

  private static boolean removeFile(String pathname) {
    return FileUtils.delete(Settings.get("servlet.attachmentRealPath") + pathname)
      && FileUtils.delete(Settings.get("servlet.attachmentRealPath") + pathname.substring(0, pathname.lastIndexOf("/")));
  }

  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    response.setContentType("text/html");
    OutputStreamWriter osw = new OutputStreamWriter(response.getOutputStream());
    PrintWriter out = new PrintWriter (response.getOutputStream());
    out.println("<html>");
    out.println("<head><title>TestFileSys</title></head>");
    out.println("<body>");
    File attach = null;
    char action = 'c';
    String partialPath = "0/0/0/";
    String path = Settings.get("servlet.attachmentRealPath");
    if (request.getParameter("path")!=null) {
      path = request.getParameter("path");
    }
    String fname = "prueba.txt";
    if (request.getParameter("fname")!=null) {
      fname = request.getParameter("fname");
    }
    out.println("<b> getServletContext().getRealPath(\"/\") = " + getServletContext().getRealPath("/") + "</b><br>");
    out.println("<b> System.getProperty(\"context.dir\") = " + System.getProperty("context.dir") + "</b><br>");
    out.println("<b> path = " + path + "</b><br><br>");
    FileOutputStream outFile = null;
    FileInputStream inFile = null;
    try {
      if (request.getParameter("action")!=null) {
        action = request.getParameter("action").toLowerCase().charAt(0);
      }
      if (action == 'c') {
        attach = File.createTempFile("wfa",".tmp", new File(path));
        out.println("createTempFile Done!<br>");
        outFile = new FileOutputStream(attach);
        out.println("FileOutputStream Done!<br>");
        outFile.write("Prueba!".getBytes());
        out.println("outFile.write Done!<br>");
        outFile.close();
        out.println("outFile.close Done!<br>");
        out.println("<b>File: " + attach.getAbsolutePath() + "</b><br>");
        File attPath = new File(path + partialPath);
        attPath.mkdirs();
        out.println("attPath.mkdirs Done!<br>");
        attach.renameTo(new File(path + partialPath + StringUtils.validAttahcmentName(fname)));
        out.println("attach.renameTo Done!<br>");
        out.println("<b>File: " + attach.getAbsolutePath() + "</b><br>");
      } else if (action == 'b') {
        removeFile(partialPath + fname);
        out.println("removeFile Done!<br>");
      } else if (action == 'v') {
        attach = new File(path + fname);
        out.println("new File Done!<br>");
        inFile = new FileInputStream(attach);
        out.println("new FileInputStream Done!<br>");
        byte[] buff = new byte[4096];
        int bytes_read;
        out.println("<text>");
        while ((bytes_read = inFile.read(buff)) != -1) {
          out.print(new String(buff));
        }
      }
    } catch (Exception e) {
      out.println("<b>Exception: " + e.getMessage() + "</b><br>");
    } finally {
      if (outFile!=null)  outFile.close();
      if (inFile!=null)  inFile.close();
      out.println("</body></html>");
      out.close();
    }
  }

  /**
   * Process the HTTP Post request
   */
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    doGet(request, response);
  }

  /**
   * Get Servlet information
   * @return java.lang.String
   */
  public String getServletInfo() {
    return "com.netapplications.webforums_jsp.servlets.TestFileSys Information";
  }
}
