package com.netapplications.webforums_jsp.servlets;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import javax.mail.*;
import javax.mail.internet.*;
import com.netapplications.webforums_jsp.util.Settings;
import com.netapplications.webforums_jsp.persist.*;
import com.netapplications.webforums_jsp.util.Mailman;

public class TestMailman extends HttpServlet {

  public void init(ServletConfig config) throws ServletException {
    super.init(config);
    initSettings();
  }

  private synchronized void initSettings() throws ServletException {
    String path = getServletContext().getInitParameter("webforumsConfigFile");
    try {
      Settings.getInstance().load(path);
    } catch (IOException e) {
      throw new ServletException("initSettings: " + e.getMessage() + " {" + path + "}");
    }
  }

  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    response.setContentType("text/html");
    OutputStreamWriter osw = new OutputStreamWriter(response.getOutputStream());
    PrintWriter out = new PrintWriter (response.getOutputStream());
    out.println("<html>");
    out.println("<head><title>TestMailman</title></head>");
    out.println("<body>");
    try {
      if (request.getParameter("id_mensaje")!=null) {
        Mailman.sendMessage(Integer.parseInt(request.getParameter("id_mensaje")));
        out.println("<b>Message # " + request.getParameter("id_mensaje") + " was send</b><br>");
      } else if (request.getParameter("to")!=null) {
        String subject = "TEST";
        String content = "THIS IS A TEST";
        String smtp_host = Settings.get("mail.smtp.host");
        String smtp_user = Settings.get("mail.smtp.user");
        String to = request.getParameter("to");
        String from = Settings.get("mailmsg.address.from");
        String reply_to = Settings.get("mailmsg.address.from");
        if (request.getParameter("subject")!=null) {
          subject = request.getParameter("subject");
        }
        if (request.getParameter("content")!=null) {
          content = request.getParameter("content");
        }
        if (request.getParameter("smtp_host")!=null) {
          smtp_host = request.getParameter("smtp_host");
        }
        if (request.getParameter("smtp_user")!=null) {
          smtp_user = request.getParameter("smtp_user");
        }
        if (request.getParameter("from")!=null) {
          from = request.getParameter("from");
        }
        if (request.getParameter("reply_to")!=null) {
          from = request.getParameter("reply_to");
        }
        Properties props = new Properties();
        props.put("mail.transport.protocol", "smtp");
        props.put("mail.smtp.host", smtp_host);
        props.put("mail.smtp.user", smtp_user);
        Session session = Session.getDefaultInstance(props, null);
        Transport trans = session.getTransport();
        trans.connect(props.getProperty("mail.smtp.host"),props.getProperty("mail.smtp.user"), "");
        MimeMessage msg = new MimeMessage(session);
        InternetAddress[] addressesReply = {new InternetAddress(reply_to)};
        msg.setFrom(new InternetAddress(from));
        msg.setReplyTo(addressesReply);
        msg.setSentDate(new Date());
        msg.setHeader("Organization", "NetApplications");
        msg.setHeader("MIME-Version","1.0");
        msg.setSubject(subject);
        msg.setContent(content ,"text/plain");
        InternetAddress[] addresses = {new InternetAddress(to)};
        msg.setRecipients(Message.RecipientType.TO, addresses);
        trans.sendMessage(msg, addresses);
        out.println("<b>Message sended to: " + to + "</b><br>");
      } else {
        out.println("<b>Missing Parameters:<br>...TestMailman?id_mensaje=#<br>or<br>TestMailman?to=emailaddress</b><br>");
      }
    } catch (NumberFormatException e) {
      out.println("<b>NumberFormatException: Invalid ID_MENSAJE</b><br>");
    } catch (MessagingException e) {
      out.println("<b>MessagingException: " + e.getMessage() + "</b><br>");
    } catch (Exception e) {
      out.println("<b>Exception: " + e.getMessage() + "</b><br>");
    } finally {
      out.println("</body></html>");
      out.close();
    }
  }

  /**
   * Process the HTTP Post request
   */
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    doGet(request, response);
  }

  /**
   * Get Servlet information
   * @return java.lang.String
   */
  public String getServletInfo() {
    return "com.netapplications.webforums_jsp.servlets.TestMailman Information";
  }
}
