package com.netapplications.webforums_jsp.servlets;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import com.netapplications.webforums_jsp.util.Settings;
import com.netapplications.webforums_jsp.util.StringUtils;

public class TestSettings extends HttpServlet {

  public void init(ServletConfig config) throws ServletException {
    super.init(config);
  }

  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    response.setContentType("text/html");
    OutputStreamWriter osw = new OutputStreamWriter(response.getOutputStream());
    PrintWriter out = new PrintWriter (response.getOutputStream());
    out.println("<html>");
    out.println("<head><title>TestSettings</title></head>");
    out.println("<body>");
    String path;
    if (request.getParameter("path")!=null) {
      path = request.getParameter("path");
    } else {
      path = getServletContext().getInitParameter("webforumsConfigFile");
    }
    if (request.getParameter("realpath")!=null) {
      path = getServletContext().getRealPath(path);
    }
    out.println("<P>Trying to load the settings from the path: <b>" + StringUtils.HTMLEncode(path)+"</b></P>");
    boolean ok = true;
    try {
      Settings.getInstance().load(path);
    } catch (Exception e) {
      ok = false;
      out.println("<P>Fail: " + StringUtils.HTMLEncode(e.getMessage()) + "</P>");
    }
    if (ok) {
      out.println("<P>Done!</P>");
      if (request.getParameter("key")!=null) {
        String key = request.getParameter("key");
        out.println("<P>" + key + ": <b>" + StringUtils.HTMLEncode(Settings.get(key)) + "</b></P>");
      }
    }
    out.println("</body></html>");
    out.close();
  }

  /**
   * Process the HTTP Post request
   */
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    doGet(request, response);
  }

  /**
   * Get Servlet information
   * @return java.lang.String
   */
  public String getServletInfo() {
    return "com.netapplications.webforums_jsp.servlets.TestSettings Information";
  }
}

