// Copyright (c) 2001 NetApplications
package com.netapplications.webforums_jsp.util;

// default settings source, uses a properties file
import java.io.*;
import java.util.*;

public class FileSettings implements SettingsSource{
  private Properties prop = new Properties();
  private String fileName;

  public FileSettings() {
    // default constructor
  }

  public synchronized void load (String param) throws IOException {
    fileName = Settings.getInstance().translateDirectory(param);
    File propFile=new File(fileName);
    prop.load(new FileInputStream(propFile));
   }

  public synchronized void save () throws IOException {
    if (fileName != null){
      File propFile=new File(fileName);
      prop.store(new FileOutputStream(propFile),"");
    }
  }

  public String getSetting(String key) {
     return prop.getProperty(key);
 }

  public void setSetting(String key,String value) {
     prop.setProperty(key,value);
   }

 public Enumeration getPropertyNames(){
    return prop.propertyNames();
 }
  public int size() {
   return prop.size();
  }
}

