// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.util;

import java.util.Date;
import java.util.Calendar;
import com.netapplications.webforums_jsp.domain.Emoticon;

public class HTMLUtils extends Object {

  private static final String[] meses = {"Ene","Feb","Mar","Abr","May","Jun","Jul","Ago","Sep","Oct","Nov","Dic"};

  public static String DayOptionsHTML(java.util.Date somedate) {
    Calendar cal = Calendar.getInstance();
    if (somedate!=null) {
      cal.setTime(somedate);
    }
    StringBuffer opciones = new StringBuffer(600);
    int dia = cal.get(Calendar.DAY_OF_MONTH);
    for (int i=1; i < 32; i++) {
      opciones.append("<option ");
      if (i == dia) {
        opciones.append("selected ");
      }
      opciones.append("value=\"");
      opciones.append(String.valueOf(i));
      opciones.append("\">");
      opciones.append(String.valueOf(i));
      opciones.append("</option>");
    }
    return opciones.toString();
  }

  public static String MonthOptionsHTML(java.util.Date somedate) {
    Calendar cal = Calendar.getInstance();
    if (somedate!=null) {
      cal.setTime(somedate);
    }
    StringBuffer opciones = new StringBuffer(200);
    int mes = cal.get(Calendar.MONTH);
    for (int i=0; i < 12; i++) {
      opciones.append("<option ");
      if (i == mes) {
        opciones.append("selected ");
      }
      opciones.append("value=\"");
      opciones.append(String.valueOf(i));
      opciones.append("\">");
      opciones.append(meses[i]);
      opciones.append("</option>");
    }
    return opciones.toString();
  }

/*
  public static String getButtonCode(String name) {
    StringBuffer retVal = new StringBuffer("<A href=\"javascript:");
    retVal.append(name);
    retVal.append("()\" onClick=\"MM_nbGroup(\'down\',\'group1\',\'");
    retVal.append(name);
    retVal.append("\',\'images/");
    retVal.append(name);
    retVal.append("Up.gif\',1)\" onMouseOver=\"MM_nbGroup(\'over\',\'");
    retVal.append(name);
    retVal.append("\',\'images/");
    retVal.append(name);
    retVal.append("Over.gif\',\'images/");
    retVal.append(name);
    retVal.append("Over.gif\',1); top.status=\'");
    retVal.append(name);
    retVal.append("\'; return true;\" onMouseOut=\"MM_nbGroup(\'out\'); top.status=\'\';\"><IMG src=\"images/");
    retVal.append(name);
    retVal.append("Up.gif\" name=\"");
    retVal.append(name);
    retVal.append("\" border=\"0\" onLoad=\"\"></A>");
    return retVal.toString();
  }
*/

  private static Date truncDate(Date date) {
    Calendar calendar = Calendar.getInstance();
    calendar.setTime(date);
    calendar.set(Calendar.HOUR_OF_DAY, 0);
    calendar.set(Calendar.MINUTE, 0);
    calendar.set(Calendar.SECOND, 0);
    calendar.set(Calendar.MILLISECOND, 0);
    return calendar.getTime();
  }

  public static String getNewImageHTML(Date element, Date compare) {
    if (element!= null && compare != null && !truncDate(element).before(truncDate(compare))) {
      return "<IMG src=\"images/new.gif\" border=\"0\">";
    } else {
      return "";
    }
  }

  public static String getImagePrioridadHTML(int prioridad) {
    if (prioridad==1) {
      return "<IMG src=\"images/prioridad_urgente.gif\" border=\"0\" alt=\"Mensaje de Urgente Prioridad\">";
    } else if (prioridad==2) {
      return "<IMG src=\"images/prioridad_alta.gif\" border=\"0\" alt=\"Mensaje de Alta Prioridad\">";
    } else {
      return "";
    }
  }

  private static String getURI_Emoticon(Emoticon[] emoticons, int id_emoticon) {
    for (int i=0; i<emoticons.length; i++) {
      if (emoticons[i].getId_emoticon() == id_emoticon) {
        return emoticons[i].getUri();
      }
    }
    return "";
  }

  public static String getEmoticonImgHTML(Emoticon[] emoticons, int id_emoticon) {
    String src = getURI_Emoticon(emoticons, id_emoticon);
    if (src.length()>0) {
      return "<IMG src=\"" + src + "\">&nbsp;";
    } else {
      return "";
    }
  }

  public static String getEmoticonsTableHTML(Emoticon[] emoticons) {
    StringBuffer retVal = new StringBuffer("<TABLE align=\"center\" border=\"1\" cellPadding=\"0\" cellSpacing=\"0\" width=\"100%\"><TR>");
    retVal.append("<TD align=\"center\"><INPUT type=\"radio\" name=\"id_emoticon\" value=\"0\" checked><BR>");
    retVal.append("<SPAN class=\"SmallText\">Ninguno</SPAN></TD>");
    for (int i=0; i<emoticons.length; i++) {
      if ((i+1)%18==0) {
        retVal.append("</TR><TR>");
      }
      retVal.append("<TD align=\"center\"><INPUT type=\"radio\" name=\"id_emoticon\" value=\"");
      retVal.append(emoticons[i].getId_emoticon());
      retVal.append("\"><BR><IMG src=\"");
      retVal.append(emoticons[i].getUri());
      retVal.append("\"></TD>");
    }
    retVal.append("</TR></TABLE>");
    return retVal.toString();
  }

  public static String getAttachmentLinkHTML(String uri_attachment) {
    if (uri_attachment!=null && uri_attachment.length()>0) {
      return "<A href=\"" + Settings.get("servlet.attachmentVirtualPath") + StringUtils.URLItemEncode(uri_attachment) + "\" target=\"_blank\"><IMG src=\"images/attachment.gif\" border=\"0\"></A>";
    } else {
      return "";
    }
  }

  public static String getNbspHTML(int count) {
    StringBuffer retValue = new StringBuffer();
    for (int i=0;i<count;i++) {
      retValue.append("&nbsp;");
    }
    return retValue.toString();
  }

}

 