// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.util;

import java.util.*;
import java.io.*;
import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;
import com.netapplications.webforums_jsp.persist.*;
import com.netapplications.webforums_jsp.domain.*;
import com.netapplications.webforums_jsp.types.*;

public class Mailman extends Object implements Runnable {

  private int id_mensaje;

  private Mailman(int id_mensaje) {
    this.id_mensaje = id_mensaje;
  }

  private synchronized String MessageEncode(VistaMensaje mensaje, String layout) {
    StringBuffer part = new StringBuffer(layout);
    int pos = part.toString().indexOf("##id_mensaje##");
    while (pos>=0) {
      part.replace(pos, pos+14, String.valueOf(mensaje.getId_mensaje()));
      pos = part.toString().indexOf("##id_mensaje##");
    }
    pos = part.toString().indexOf("##id_mensaje_original##");
    while (pos>=0) {
      part.replace(pos, pos+23, String.valueOf(mensaje.getId_mensaje_original()));
      pos = part.toString().indexOf("##id_mensaje_original##");
    }
    pos = part.toString().indexOf("##asunto##");
    while (pos>=0) {
      part.replace(pos, pos+10, mensaje.getAsunto());
      pos = part.toString().indexOf("##asunto##");
    }
    pos = part.toString().indexOf("##contenido##");
    while (pos>=0) {
      part.replace(pos, pos+13, mensaje.getContenido());
      pos = part.toString().indexOf("##contenido##");
    }
    pos = part.toString().indexOf("##reply_contenido##");
    while (pos>=0) {
      part.replace(pos, pos+19, StringUtils.ReplyText(mensaje.getContenido()));
      pos = part.toString().indexOf("##reply_contenido##");
    }
    pos = part.toString().indexOf("##prioridad##");
    while (pos>=0) {
      part.replace(pos, pos+13, String.valueOf(mensaje.getPrioridad()));
      pos = part.toString().indexOf("##prioridad##");
    }
    pos = part.toString().indexOf("##fec_envio##");
    while (pos>=0) {
      part.replace(pos, pos+13, CustomFormats.StringDate(mensaje.getFecha_envio()));
      pos = part.toString().indexOf("##fec_envio##");
    }
    pos = part.toString().indexOf("##envio_anonimo##");
    while (pos>=0) {
      part.replace(pos, pos+17, mensaje.getEnvio_anonimo());
      pos = part.toString().indexOf("##envio_anonimo##");
    }
    pos = part.toString().indexOf("##status_mensaje##");
    while (pos>=0) {
      part.replace(pos, pos+18, mensaje.getEstatus_mensaje());
      pos = part.toString().indexOf("##status_mensaje##");
    }
    pos = part.toString().indexOf("##incluir_original##");
    while (pos>=0) {
      part.replace(pos, pos+20, mensaje.getIncluir_original());
      pos = part.toString().indexOf("##incluir_original##");
    }
    pos = part.toString().indexOf("##id_usuario##");
    while (pos>=0) {
      part.replace(pos, pos+15, String.valueOf(mensaje.getId_usuario()));
      pos = part.toString().indexOf("##id_usuario##");
    }
    pos = part.toString().indexOf("##nom_usuario##");
    while (pos>=0) {
      part.replace(pos, pos+15, mensaje.getNombre_usuario());
      pos = part.toString().indexOf("##nom_usuario##");
    }
    pos = part.toString().indexOf("##email_usuario##");
    while (pos>=0) {
      part.replace(pos, pos+17, mensaje.getEmail_usuario());
      pos = part.toString().indexOf("##email_usuario##");
    }
    pos = part.toString().indexOf("##id_emoticon##");
    while (pos>=0) {
      //--------------------
      part.replace(pos, pos+15, "");
      //--------------------
      pos = part.toString().indexOf("##id_emoticon##");
    }
    pos = part.toString().indexOf("##nom_autor##");
    while (pos>=0) {
      part.replace(pos, pos+13, mensaje.getNombre_autor());
      pos = part.toString().indexOf("##nom_autor##");
    }
    pos = part.toString().indexOf("##uri_attachment##");
    while (pos>=0) {
      part.replace(pos, pos+18, mensaje.getUri_attachment());
      pos = part.toString().indexOf("##uri_attachment##");
    }
    pos = part.toString().indexOf("##nom_topico##");
    while (pos>=0) {
      part.replace(pos, pos+14, mensaje.getNombre_topico());
      pos = part.toString().indexOf("##nom_topico##");
    }
    return part.toString();
  }

  public void run() {
    try {
      // Esperamos un rato antes de hacer algo
      Thread.currentThread().sleep(10000);
      VistaMensajePersist vmdb = VistaMensajePersist.getInstance();
      VistaMensaje mensaje = vmdb.get(id_mensaje);
      UsuarioPersist udb = UsuarioPersist.getInstance();
      Usuario[] recipientes = udb.getUsuariosToSendEmail(mensaje.getId_mensaje());
      Properties props = new Properties();
      props.put("mail.transport.protocol", "smtp");
      props.put("mail.smtp.host", Settings.get("mail.smtp.host"));
      props.put("mail.smtp.user", Settings.get("mail.smtp.user"));
      Session session = Session.getDefaultInstance(props, null);
      Transport trans = null;
      try {
        trans = session.getTransport();
        trans.connect(props.getProperty("mail.smtp.host"),props.getProperty("mail.smtp.user"), "");
        MimeMessage msg = new MimeMessage(session);
        InternetAddress[] addressesReply = {new InternetAddress(mensaje.getNombre_usuario()+" <"+mensaje.getEmail_usuario()+">")};
        msg.setFrom(new InternetAddress(Settings.get("mailmsg.address.from")));
        //msg.setFrom(addressesReply[0]);
        msg.setReplyTo(addressesReply);
        msg.setSentDate(new Date());
        msg.setHeader("Organization", Settings.get("mailmsg.organization"));
        msg.setHeader("MIME-Version","1.0");
/*
        msg.setHeader("Content-Type","text/plain; charset=\"us-ascii\"");
        msg.setHeader("Content-Transfer-Encoding", "7bit");
*/
        String original_msg = "";
        if (mensaje.getIncluir_original().equals(StrBoolean.TRUE) && mensaje.getId_mensaje_original()>0) {
          original_msg = MessageEncode(vmdb.get(mensaje.getId_mensaje_original()), Settings.get("mailmsg.originalmsg"));
        }
        if (mensaje.getId_mensaje_original()>0) {
          msg.setSubject(MessageEncode(mensaje, Settings.get("mailmsg.newtopic.subject")));
          msg.setContent(MessageEncode(mensaje, Settings.get("mailmsg.newtopic.body")) + original_msg ,"text/plain");
        } else {
          msg.setSubject(MessageEncode(mensaje, Settings.get("mailmsg.reply.subject")));
          msg.setContent(MessageEncode(mensaje, Settings.get("mailmsg.reply.body")) + original_msg ,"text/plain");
        }
        for (int i=0; i<recipientes.length; i++) {
          try {
            InternetAddress[] addresses = {new InternetAddress(recipientes[i].getEmail())};
            msg.setRecipients(Message.RecipientType.TO, addresses);
            trans.sendMessage(msg, addresses);
          } catch (MessagingException e) {}
        }
      } catch (MessagingException e) {
        System.err.println("MessagingException: " + e.getMessage());
      } finally {
        if (trans!=null) {
          try {
            trans.close();
          } catch (MessagingException e) { }
        }
      }
    } catch (InterruptedException e) {
      System.err.println("InterruptedException: " + e.getMessage());
    } catch (PersistException e) {
      System.err.println("PersistException: " + e.getMessage());
    }
  }

  public static void sendMessage(int id_mensaje) {
      Thread t = new Thread(new Mailman(id_mensaje));
      t.start();
  }

  public static void main(String[] argc) {
    try {
      Settings.getInstance().load("C:\\JRun\\servers\\default\\default-app\\webforums_jsp\\settings\\init.conf");
      Mailman.sendMessage(46);
    } catch (Exception e) {
      System.err.println("PersistException: " + e.getMessage());
    }
  }
}

