
// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.util;

import java.util.Iterator;
import java.util.NoSuchElementException;

public class PagedIterator extends Object {

  private class InnerIterator implements Iterator {
    private int index;
    private int page;

    protected InnerIterator(int page) {
      // internamete la primera pgina es la nmero cero pero para
      // los clientes de esta clase la primera pgina es la nmero uno
      this.page = page - 1;
      this.index = 0;
    }

    public boolean hasNext() {
      return (page * pageSize + index < Math.min(arrObjects.length, (page + 1) * pageSize))
        && (page * pageSize + index >= 0);
    }

    public Object next() throws NoSuchElementException {
      if (hasNext()) {
          return arrObjects[page * pageSize + index++];
      } else {
        throw new NoSuchElementException("This iterator has no more elements");
      }
    }

    public void remove() throws UnsupportedOperationException {
      throw new UnsupportedOperationException("This iterator is read only");
    }
  }

  protected int pageSize;
  protected Object[] arrObjects;

  public PagedIterator(Object[] arrObjects, int pageSize) {
    this.arrObjects = arrObjects;
    this.pageSize = pageSize;
  }

  public PagedIterator(Object[] arrObjects) {
    this(arrObjects, arrObjects.length);
  }

  public Iterator iterator(int page) {
    return new InnerIterator(page);
  }

  public int length() {
    return arrObjects.length;
  }

  public int pagesCount() {
    return (int) Math.ceil((double) arrObjects.length/pageSize);
  }

  public static void main(String[] argc) {
    try {
      PagedIterator pi = new PagedIterator(new String[] {"1","2","3","4","5","6","7"}, 4);
      Iterator it = pi.iterator(1);
      while (it.hasNext()) {
        System.out.println(">" + (String) it.next());
      }
    } catch (Exception e) {
      System.out.println("ERROR: " + e.getMessage());
    }
  }
}

