// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.view;

import com.netapplications.webforums_jsp.domain.Emoticon;
import javax.servlet.ServletContext;

public class EmoticonsICatalogProvider extends Object implements ICatalogProvider {

  private ServletContext application;

  private class AdapterEmoticon implements ICatalog {
    private Emoticon emot;
    private AdapterEmoticon(Emoticon emot) {
      this.emot = emot;
    }
    public String getIdentifier() {
      return String.valueOf(emot.getId_emoticon());
    }
    public String getName() {
      return emot.getUri();
    }
  }

  public EmoticonsICatalogProvider(ServletContext application) {
    this.application = application;
  }

  public ICatalog[] getCatalog() {
    Emoticon[] emoticons = (Emoticon[]) application.getAttribute("emoticons");
    AdapterEmoticon[] adapters = new AdapterEmoticon[emoticons.length];
    for (int i=0;i<emoticons.length;i++) {
      adapters[i] = new AdapterEmoticon(emoticons[i]);
    }
    return adapters;
  }
}
