// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.view;

import com.netapplications.webforums_jsp.domain.Foro;
import javax.servlet.ServletContext;

public class ForosICatalogProvider extends Object implements ICatalogProvider {

  private ServletContext application;

  private class AdapterForo implements ICatalog {
    private Foro foro;
    private AdapterForo(Foro foro) {
      this.foro = foro;
    }
    public String getIdentifier() {
      return String.valueOf(foro.getId_foro());
    }
    public String getName() {
      return foro.getNombre();
    }
  }

  public ForosICatalogProvider(ServletContext application) {
    this.application = application;
  }

  public ICatalog[] getCatalog() {
    Foro[] foros = (Foro[]) application.getAttribute("foros");
    AdapterForo[] adapters = new AdapterForo[foros.length];
    for (int i=0;i<foros.length;i++) {
      adapters[i] = new AdapterForo(foros[i]);
    }
    return adapters;
  }
}
