// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.view;

import com.netapplications.webforums_jsp.util.StringUtils;

public class NavComboBox extends Object implements INavItem {

  private String cmdKey;
  private String paramName;
  private String hint;
  private String text;
  private ICatalogProvider provider;
  private StringBuffer html;

  public NavComboBox(String cmdKey, String paramName, String hint, String text, ICatalogProvider provider)
    throws IllegalArgumentException {
    if (cmdKey!=null && paramName!=null && hint!=null && text!=null && provider!=null) {
      this.cmdKey = cmdKey;
      this.paramName = paramName;
      this.hint = hint;
      this.text = text;
      this.provider = provider;
      this.rebuildHTML();
    } else {
      throw new IllegalArgumentException("All arguments of this constructor are mandatory");
    }
  }

  public String getHTML() {
    return html.toString();
  }

  public void rebuildHTML() {
    html = new StringBuffer("writeToolCombo(\'");
    html.append(cmdKey);
    html.append("\',\'");
    html.append(text);
    html.append("\',\'");
    html.append(hint);
    html.append("\',\'");
    html.append(paramName);
    html.append("\',new Array(");
    ICatalog[] cat = provider.getCatalog();
    boolean hasPrevious = false;
    for (int i=0;i<cat.length;i++) {
      if (hasPrevious) {
        html.append(",");
      }
      html.append("new Array(\'");
      html.append(StringUtils.JavaEncode(cat[i].getIdentifier()));
      html.append("\',\'");
      html.append(StringUtils.JavaEncode(cat[i].getName()));
      html.append("\')");
      hasPrevious = true;
    }
    html.append("));\r\n");
  }
}

